#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


char String[] = "SIGHUP, TWO, THREE, FOUR!\n";
const int Strlen  	=(sizeof(String)-1);


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];

	pid_t pid;

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(64, BASE)
		GTI_NOT_PROVIDED_RESULT(65, BASE)
		GTI_NOT_PROVIDED_RESULT(66, BASE)
		done();
	}

	exit_on(ERROR);

	setup(E_INTERFACE);
	funct(E_INTERFACE);


										/* Disconnected terminal */
	assertion(64, BASE);
	start
		if(GTI_MODEM_CONTROL) {
			Zsetsid();
			ENABLE_PSYNC
				prep("Fork a child  process.");
				start
					sv_flush();
					pid = Zfork();
				finis
		
				if(pid == (pid_t)0) {
					prep("Open PORT_LOOP, wait for PORT_TTY to");
					prep("complete then exit.");
					start 
						loop_prep(&loop_fildes, loop_termios_p);
										/* Wait for PORT_TTY to complete. */
						SET_TIMEOUT
							WAIT_PSYNC
						CLEAR_ALARM
					finis
		
					done();
				}
	
				prep("Open PORT_TTY and wait for child to open");
				prep("PORT_LOOP then exit.");
				start
					sigset_t set, oset;
					sig_rcvd = 0;
					SIGNAL(SIGHUP, sig_int);
					tty_prep(&tty_fildes, tty_termios_p);

						/*	Block SIGHUP signal to prevent race condition. */
					Zsigemptyset(&set);
					Zsigaddset(&set, SIGHUP);
					Zsigprocmask(SIG_BLOCK, &set, &oset);

					SET_TIMEOUT
						SEND_PSYNC
										/*	Unblock SIGHUP and wait for it.  */
    					sigsuspend(&oset);
										/*	Reset signal process mask.	*/
    					Zsigprocmask(SIG_SETMASK, &oset, NULL);
					IGNORE_ALARM
				finis
		
				testing("SIGHUP signal is sent to controlling process.");
				start
					if(sig_rcvd == 0)
						error("SIGHUP signal not received.");
				finis
												/* Assertion #67 */
				testing("Subsequent reads return zero.");
				start
					expecting(0);		/* EOF detected. */
					Zread(tty_fildes, inbuf, sizeof(inbuf));
					expecting(0);		/* EOF detected.  */
					Zread(tty_fildes, inbuf, sizeof(inbuf));
				finis

												/* Assertion #68 */
				testing("Subsequent write() to the disconnected terminal");
				testing("retuns -1 with errno of [EIO].");
				start
					expecting(-1);
					expecting(EIO);
					Zwrite(tty_fildes, String, _POSIX_MAX_INPUT);

					expecting(-1);
					expecting(EIO);
					Zwrite(tty_fildes, String, _POSIX_MAX_INPUT);
				finis
			DISABLE_PSYNC
			SLEEP(GTI_LINE_CLOSE_DELAY)
		}
		else
			not_implemented("modem control");
	finis

	assertion(65, BASE);
	start
		if(GTI_MODEM_CONTROL) {
			testing("Assertion #65 tested as part of assertion #64.");
			start
			finis
		}
		else
			not_implemented("MODEM_CONTROL");
	finis

	assertion(66, BASE);
	start
		if(GTI_MODEM_CONTROL) {
			testing("Assertion #66 tested as part of assertion #64.");
			start
			finis
		}
		else
			not_implemented("MODEM_CONTROL");
	finis

	done();
}
