#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	char	outbuf[_POSIX_MAX_INPUT];
	int 	i,j;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	exit_on(ERROR);

									/* ~OPOST */
	assertion(36, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY and PORT_LOOP to non-canonical, MIN=TIME=0.");
		prep("Clear OPOST flag for PORT_TTY.");
		start
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			loop_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			loop_termios_p->c_cc[VMIN] = 0;
			loop_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;

			tty_termios_p->c_oflag &= ~OPOST;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("If OPOST is clear, characters are transmitted to the.");
		testing("terminal without change.");
		start
										/* CHAR_MIN may be negative. */
			for(i=0, j=(CHAR_MIN); i < _POSIX_MAX_INPUT; ++i, j++) {
				outbuf[i] = j % CHAR_MAX;
				inbuf[i] = 0;
			}

		  	SET_TIMEOUT
				expecting(_POSIX_MAX_INPUT);
				Zwrite(tty_fildes, outbuf, _POSIX_MAX_INPUT);
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(_POSIX_MAX_INPUT);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			continue_on(ERROR);
			for(i=0; i<_POSIX_MAX_INPUT; i++)
				if(inbuf[i] != outbuf[i])
					error("%s%d.\n%s%x(Hex)\n%s%x(Hex)\n",
						"Character changed in transmission, array index ",
						i,
						"Expected: ",
						outbuf[i],
						"Received: ",
						inbuf[i]);
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
