#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz\n";
#define	Strlen	(sizeof(String)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(43, BASE)
		GTI_NOT_PROVIDED_RESULT(44, BASE)
		GTI_NOT_PROVIDED_RESULT(45, BASE)
		GTI_NOT_PROVIDED_RESULT(46, BASE)
		GTI_NOT_PROVIDED_RESULT(47, BASE)
		GTI_NOT_PROVIDED_RESULT(48, BASE)
		done();
	}

	assertion(43, EXTENDED);
	assertion(44, EXTENDED);
									/* CSTOPB */
	assertion(45, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY and PORT_LOOP to non-canonical, MIN=TIME=0.");
		prep("Set CSTOPB on PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
		    tty_termios_p->c_cflag |= CSTOPB;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			Ztcgetattr(tty_fildes, tty_termios_p);
			if((tty_termios_p->c_cflag & CSTOPB) != CSTOPB)
				error("CSTOPB set not supported.");
		finis

		prep("Set CSTOPB flag on PORT_LOOP.");
		start
	    	loop_termios_p->c_cflag |= CSTOPB;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
		finis

		testing("Write and read to PORTs.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(inbuf, String, Strlen))
					error("Data read != to data written.");
		finis
	finis
									/* ~CSTOPB */
	assertion(46, BASE);
	start
		prep("Clear CSTOPB on PORT_TTY.");
		start
		    tty_termios_p->c_cflag &= ~CSTOPB;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			Ztcgetattr(tty_fildes, tty_termios_p);
			if((tty_termios_p->c_cflag & CSTOPB) == CSTOPB)
				error("CSTOPB clear not supported.");
		finis

		prep("Clear CSTOPB flag on PORT_LOOP.");
		start
	    	loop_termios_p->c_cflag &= ~CSTOPB;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
		finis

		testing("Write and read to PORTs.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(inbuf, String, Strlen))
					error("Data read != to data written.");
		finis
	finis
									/* CREAD */
	assertion(47, BASE);
	start
		prep("Set CREAD on PORT_TTY.");
		start
		    tty_termios_p->c_cflag |= CREAD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		Ztcgetattr(tty_fildes, tty_termios_p);
		if((tty_termios_p->c_cflag & CREAD) == CREAD) {
			testing("Write and read to PORTs.");
			start
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM

				SET_TIMEOUT
					expecting(Strlen);
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				if(strncmp(inbuf, String, Strlen))
						error("Data read != to data written.");
			finis
		}
		else
			not_implemented("CREAD set");
	finis

									/* ~CREAD */
	assertion(48, BASE);
	start
		prep("Clear CREAD on PORT_TTY.");
		start
		    tty_termios_p->c_cflag &= ~CREAD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		Ztcgetattr(tty_fildes, tty_termios_p);
		if((tty_termios_p->c_cflag & CREAD) != CREAD) {
			prep("Write to PORT_LOOP.");
			start
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM
			finis

			testing("Data is not received while CREAD is clear.");
			start
				SET_TIMEOUT
					expecting(0);
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

		    	tty_termios_p->c_cflag |= CREAD;
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
				SET_TIMEOUT
					expecting(0);
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM
			finis
		}
		else
			not_implemented("CREAD clear");
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
