#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "How now, brown cow?";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];

	setup(E_TCFLOW);
	funct(E_TCFLOW);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(5, BASE)
		GTI_NOT_PROVIDED_RESULT(6, BASE)
		GTI_NOT_PROVIDED_RESULT(7, BASE)
		done();
	}

	assertion(5, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);

			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			tty_termios_p->c_iflag |= IXON;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

		prep("Check writes and reads are working.");
		start
			size_t	n_read;

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);

  				for(n_read=0; n_read != Strlen;)
  					n_read += Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis	

		testing("A call to tcflush(fildes, TCIFLUSH), on the controlling");
		testing("terminal of the process, discards data received from the");
		testing("terminal but not read.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM
		
			SET_TIMEOUT
				expecting(0);
				Ztcflush(tty_fildes, TCIFLUSH);

				expecting(0);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis


	assertion(6, BASE);
	start
		prep("Inhibit data transfer, then write data to port queues.");
		start
			SET_TIMEOUT
				if(PCTS_GTI_BUFFERS_OUTPUT) {
					Ztcflow(loop_fildes, TCOOFF);
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
				}
			CLEAR_ALARM
		finis

		testing("A call to tcflush(fildes, TCOFLUSH) flushes data");
		testing("written to the terminal but not transmitted.");
		start
			SET_TIMEOUT
				expecting(0);
				Ztcflush(loop_fildes, TCOFLUSH);
				Ztcflow(loop_fildes, TCOON);
				Ztcdrain(loop_fildes);
												/* Output flushed? */
				expecting(0);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	assertion(7, BASE);
	start
		prep("Inhibit data transfer, then write data to port queues.");
		start
			SET_TIMEOUT
				if(PCTS_GTI_BUFFERS_OUTPUT) {
					Ztcflow(tty_fildes, TCOOFF);
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				}
			CLEAR_ALARM
		finis

		testing("A call to tcflush(fildes, TCIOFLUSH) discards both data");
		testing("received but not read, and data written but not");
		testing("transmitted and returns the value zero.");
		start
			SET_TIMEOUT
				expecting(0);
				Ztcflush(tty_fildes, TCIOFLUSH);
				Ztcflow(tty_fildes, TCOON);
				Ztcdrain(tty_fildes);

												/* Output flushed? */
				expecting(0);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
												/* Input flushed? */
				expecting(0);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
