#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "How now, brown cow?";
#define	Strlen	(sizeof(String) -1)

void	com_code(void);

static	int		tty_fildes, loop_fildes;
static	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
static	sigset_t set;

int main(void)
{
	pid_t	pid;

	setup(E_TCFLUSH);
	funct(E_TCFLUSH);

	assertion(11, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY and PORT_LOOP as non-controlling");
		prep("terminals.");
		start
			exit_on(ERROR);
	
			termios_nct(&tty_fildes, tty_termios_p, &loop_fildes,
															loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			tty_termios_p->c_iflag |= IXON;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

									/* Foreground process test. */
		ENABLE_PSYNC
		FORK
			com_code();
		KROF


									/* Background process tests. */
		FORK
			prep("Catch SIGTTOU and establish a background process group.");
			start
				SIGNAL(SIGTTOU, sig_int);
				Zsetpgid((pid_t)0, (pid_t)0);
			finis

			com_code();

			prep("Block SIGTTOU in background process group.");
			start
				SIGBLOCK(set, SIGTTOU);
			finis

			com_code();

			prep("Unblock and ignore SIGTTOU in background process group.");
			start
				SIGNAL(SIGTTOU, SIG_IGN);
				SIGUNBLOCK(set, SIGTTOU);
			finis

			com_code();
		KROF

									/* Orphaned background process test. */
		FORK
			prep("Catch SIGTTOU and establish an orphaned background");
			prep("process group.");
			start
				SIGNAL(SIGTTOU, sig_int);
				Zsetpgid((pid_t)0, (pid_t)0);
			finis

			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				SLEEP(WAIT_FOR_TIME)

				com_code();
				SEND_PSYNCA

				done();
			}
		KROF
										/* Wait for test to complete. */
		SET_TIMEOUT
			WAIT_PSYNCA
		CLEAR_ALARM
		DISABLE_PSYNC
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}

void com_code(void)
{
	char	inbuf[_POSIX_MAX_INPUT];

	prep("Check writes and reads are working.");
	start
		size_t	n_read;

		SET_TIMEOUT
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			Ztcdrain(loop_fildes);

  			for(n_read=0; n_read != Strlen;)
  				n_read += Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
		CLEAR_ALARM
	finis	

	testing("A call to tcflush(fildes, TCIFLUSH), on the controlling");
	testing("terminal of the process, discards data received from the");
	testing("terminal but not read.");
	start
		SET_TIMEOUT
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			Ztcdrain(loop_fildes);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
		CLEAR_ALARM
	
		SET_TIMEOUT
			expecting(0);
			Ztcflush(tty_fildes, TCIFLUSH);

			expecting(0);
			Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
		CLEAR_ALARM
	finis
}
