#include	<pcts_ass.h>

#include	<string.h>

#include	<sv_env.h>

#undef	E2BIG
#undef	EACCES
#undef	EAGAIN
#undef	EBADF
#undef	EBUSY
#undef	ECHILD
#undef	EDEADLK
#undef	EDOM
#undef	EEXIST
#undef	EFAULT
#undef	EFBIG
#undef	EINTR
#undef	EINVAL
#undef	EIO
#undef	EISDIR
#undef	EMFILE
#undef	ENAMETOOLONG
#undef	ENFILE
#undef	ENODEV
#undef	ENOENT
#undef	ENOEXEC
#undef	ENOLCK
#undef	ENOMEM
#undef	ENOSPC
#undef	ENOSYS
#undef	ENOTDIR
#undef	ENOTEMPTY
#undef	ENOTTY
#undef	ENXIO
#undef	EPERM
#undef	EPIPE
#undef	ERANGE
#undef	EROFS
#undef	ESPIPE
#undef	ESRCH
#undef	EXDEV

#include	<errno.h>

struct	err_flgs {
		   char	*sym;
		   int	value;
		 } e_flgs[] = {
				"E2BIG",	E2BIG,
				"EACCES",	EACCES,
				"EAGAIN",	EAGAIN,
				"EBADF",	EBADF,
				"EBUSY",	EBUSY,
				"ECHILD",	ECHILD,
				"EDEADLK",	EDEADLK,
				"EDOM",		EDOM,
				"EEXIST",	EEXIST,
				"EFAULT",	EFAULT,
				"EFBIG",	EFBIG,
				"EINTR",	EINTR,
				"EINVAL",	EINVAL,
				"EIO",		EIO,
				"EISDIR",	EISDIR,
				"EMFILE",	EMFILE,
				"ENAMETOOLONG",	ENAMETOOLONG,
				"ENFILE",	ENFILE,
				"ENODEV",	ENODEV,
				"ENOENT",	ENOENT,
				"ENOEXEC",	ENOEXEC,
				"ENOLCK",	ENOLCK,
				"ENOMEM",	ENOMEM,
				"ENOSPC",	ENOSPC,
				"ENOSYS",	ENOSYS,
				"ENOTDIR",	ENOTDIR,
				"ENOTEMPTY",	ENOTEMPTY,
				"ENOTTY",	ENOTTY,
				"ENXIO",	ENXIO,
				"EPERM",	EPERM,
				"EPIPE",	EPIPE,
				"ERANGE",	ERANGE,
				"EROFS",	EROFS,
				"ESPIPE",	ESPIPE,
				"ESRCH",	ESRCH,
				"EXDEV",	EXDEV,
				"",	0
			      };

void	unique(char *, int);

int	main(void)
{
    setup(E_ERR_NUMBS);
    funct(E_ERR_NUMBS);

	assertion(2,BASE);
	start
		testing("Error numbers are defined when <errno.h> is included and");
		testing("the values are non-zero, unique from each other and can");
		testing("be represented by errno.");
		start
				/*	Error numbers defined in <errno.h> is a compiler test.
					Ensure installation journal was successful when this
					module was compiled.
				*/
			unique("E2BIG", E2BIG);
			unique("EACCES", EACCES);
			unique("EAGAIN", EAGAIN);
			unique("EBADF", EBADF);
			unique("EBUSY", EBUSY);
			unique("ECHILD", ECHILD);
			unique("EDEADLK", EDEADLK);
			unique("EDOM", EDOM);
			unique("EEXIST", EEXIST);
			unique("EFAULT", EFAULT);
			unique("EFBIG", EFBIG);
			unique("EINTR", EINTR);
			unique("EINVAL", EINVAL);
			unique("EIO", EIO);
			unique("EISDIR", EISDIR);
			unique("EMFILE", EMFILE);
			unique("EMLINK", EMLINK);
			unique("ENAMETOOLONG", ENAMETOOLONG);
			unique("ENFILE", ENFILE);
			unique("ENODEV", ENODEV);
			unique("ENOENT", ENOENT);
			unique("ENOEXEC", ENOEXEC);
			unique("ENOLCK", ENOLCK);
			unique("ENOMEM", ENOMEM);
			unique("ENOSPC", ENOSPC);
			unique("ENOSYS", ENOSYS);
			unique("ENOTDIR", ENOTDIR);
			unique("ENOTEMPTY", ENOTEMPTY);
			unique("ENOTTY", ENOTTY);
			unique("ENXIO", ENXIO);
			unique("EPERM", EPERM);
			unique("EPIPE", EPIPE);
			unique("ERANGE", ERANGE);
			unique("EROFS", EROFS);
			unique("ESPIPE", ESPIPE);
			unique("ESRCH", ESRCH);
			unique("EXDEV", EXDEV);
		finis
    finis

	assertion(3, EXTENDED);

    done();
}



void	unique(char *symbol, int value)
{
	int	i;

	if(!value) {
		error("ERRNO element [%s] has a value of zero.", symbol);
		return;
	}

	errno = value;
	if(errno != value)
		error("errno - can not represent [%s].", symbol);

	for(i=0; *e_flgs[i].sym; i++) {
		if( ! (strcmp(symbol, e_flgs[i].sym)) )
			continue;
		if(value == e_flgs[i].value) 
			error("ERRNO element %s matches ERRNO element %s.",
					symbol,
			    		e_flgs[i].sym);
	}
	return;
}
