#include	<pcts_ass.h>

#include	<sv_env.h>

#undef	CHAR_BIT
#undef	CHAR_MAX
#undef	CHAR_MIN
#undef	INT_MAX
#undef	INT_MIN
#undef	LONG_MAX
#undef	LONG_MIN
#undef	MB_LEN_MAX
#undef	SCHAR_MAX
#undef	SCHAR_MIN
#undef	SHRT_MAX
#undef	SHRT_MIN
#undef	UCHAR_MAX
#undef	UINT_MAX
#undef	ULONG_MAX
#undef	USHRT_MAX
#include	<limits.h>


int	main(void)
{
    setup(E_NUM_LMTS);
    funct(E_NUM_LMTS);

	assertion(1, BASE);
    start
		testing("When <limits.h> is included, then the symbolic names");
		testing("CHAR_BIT, CHAR_MAX, CHAR_MIN, INT_MAX,");
		testing("INT_MIN, LONG_MAX, LONG_MIN, MB_LEN_MAX, SCHAR_MAX,");
		testing("SCHAR_MIN, SHRT_MAX, SHRT_MIN, UCHAR_MAX, UINT_MAX,");
		testing("ULONG_MAX, and USHRT_MAX are defined and their values meet");
		testing("the C Standard required limits.");
		start

#ifndef	CHAR_BIT
			error("Symbol CHAR_BIT not defined when <limits.h> is included,");
#else
			if(CHAR_BIT < 8)
				error("CHAR_BIT has value %d.", (int)CHAR_BIT);
#endif

#ifndef	CHAR_MAX
			error("Symbol CHAR_MAX not defined when <limits.h> is included,");

			/* CHAR_MAX value tested in CHAR_MIN. */
#endif

#ifndef	CHAR_MIN
			error("Symbol CHAR_MIN not defined when <limits.h> is included,");
#else
										/* Is char signed or unsigned? */
			if(CHAR_MIN == SCHAR_MIN) {	/* signed */
				if(CHAR_MAX != SCHAR_MAX)
					error("CHAR_MIN equal to SCHAR_MIN and CHAR_MAX not equal to SCHAR_MAX");
			} else {					/* unsigned */
				if(CHAR_MIN != 0)
					error("CHAR_MIN not equal to SCHAR_MIN and not equal to zero.");
				if(CHAR_MAX != UCHAR_MAX)
					error("CHAR_MAX not equal to SCHAR_MIN and CHAR_MAX not equal to UCHAR_MAX.");
			}
#endif

#ifndef	INT_MAX
			error("Symbol INT_MAX not defined when <limits.h> is included,");
#else
			if(INT_MAX < 32767)
				error("INT_MAX has value %d.", INT_MAX);
#endif

#ifndef	INT_MIN
			error("Symbol INT_MIN not defined when <limits.h> is included,");
#else
			if(INT_MIN > -32767)
				error("INT_MIN has value %d.", INT_MIN);
#endif

#ifndef	LONG_MAX
			error("Symbol LONG_MAX not defined when <limits.h> is included,");
#else
			if(LONG_MAX < 2147483647)
				error("LONG_MAX has value %ld.", LONG_MAX);
#endif

#ifndef	LONG_MIN
			error("Symbol LONG_MIN not defined when <limits.h> is included,");
#else
			if(LONG_MIN > -2147483647)
				error("LONG_MIN has value %ld.", LONG_MIN);
#endif

#ifndef	MB_LEN_MAX
			error("Symbol MB_LEN_MAX not defined when <limits.h> is included,");
#else
			if(MB_LEN_MAX < 1)
				error("MB_LEN_MAX has value %d.", (int)MB_LEN_MAX);
#endif

#ifndef	SCHAR_MAX
			error("Symbol SCHAR_MAX not defined when <limits.h> is included,");
#else
			if(SCHAR_MAX < 127)
				error("SCHAR_MAX has value %d.", (int)SCHAR_MAX);
#endif

#ifndef	SCHAR_MIN
			error("Symbol SCHAR_MIN not defined when <limits.h> is included,");
#else
			if(SCHAR_MIN > -127)
				error("SCHAR_MIN has value %d.", (int)SCHAR_MIN);
#endif

#ifndef	SHRT_MAX
			error("Symbol SHRT_MAX not defined when <limits.h> is included,");
#else
			if(SHRT_MAX < 32767)
				error("SHRT_MAX has value %d.", (int)SHRT_MAX);
#endif

#ifndef	SHRT_MIN
			error("Symbol SHRT_MIN not defined when <limits.h> is included,");
#else
			if(SHRT_MIN > -32767)
				error("SHRT_MIN has value %d.", (int)SHRT_MIN);
#endif

#ifndef	UCHAR_MAX
			error("Symbol UCHAR_MAX not defined when <limits.h> is included,");
#else
			if(UCHAR_MAX < 255)
				error("UCHAR_MAX has value %d.", (int)UCHAR_MAX);
#endif

#ifndef	UINT_MAX
			error("Symbol UINT_MAX not defined when <limits.h> is included,");
#else
			if(UINT_MAX < 65535)
				error("UINT_MAX has value %u.", UINT_MAX);
#endif

#ifndef	ULONG_MAX
			error("Symbol ULONG_MAX not defined when <limits.h> is included,");
#else
			if(ULONG_MAX < 4294967295)
				error("ULONG_MAX has value %lu.", ULONG_MAX);
#endif

#ifndef	USHRT_MAX
			error("Symbol USHRT_MAX not defined when <limits.h> is included,");
#else
			if(USHRT_MAX < 65535)
				error("USHRT_MAX has value %u.", (unsigned int)USHRT_MAX);
#endif
		finis
	finis

    done();
}
