#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<tar.h>
#include	<Zpwd.h>
#include	<Zgrp.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<iso646_natv.h>


/* 
#define	DEBUG_TAR
*/

void read_entry(void);
unsigned long atoo(char *, int);
int ck_str(char *, int);
void ck_field(int, char *, char *, int);
void ck_term(int, char *, char *, int);
void ck_t_sp(int, char *, char *, int);
int	ck_types(char);

#define TAR_BLOCK_SIZE	512

#define Root_uid	((uid_t **) (&sv_params[1].value))
#define Root_gid	((gid_t **) (&sv_params[2].value))
#define Bin_uid		((uid_t **) (&sv_params[3].value))
#define Bin_gid		((gid_t **) (&sv_params[4].value))
#define Uid			((uid_t **) (&sv_params[5].value))
#define Gid			((gid_t **) (&sv_params[6].value))

#define	MTIME_VALUE	"05321155400" 		/* UCT of Jan 1, 1993 */

#define	NAME_LEN	100
#define	MODE_LEN	8
#define	MODE_TERM_PAD	2		/* Size of terminating padding */
#define	UID_LEN		8
#define	GID_LEN		8
#define	SIZE_LEN	12
#define	SIZE_TERM_PAD	1		/* Size of terminating padding */
#define	MTIME_LEN	12
#define	MTIME_TERM_PAD	1		/* size of terminating padding */
#define	CKSUM_LEN	8
#define	CKSUM_TERM_PAD	1		/* Size of terminating padding */
#define	TYPEFLAG_LEN	1
#define	TYPE_REG	'0'
#define	TYPE_LINK	'1'
#define	TYPE_CHAR_SP	'3'
#define	TYPE_BLCK_SP	'4'
#define	TYPE_DIR	'5'
#define	TYPE_FIFO	'6'
#define	LINKNAME_LEN	100
#define	MAGIC_LEN	6
#define	VERSION_LEN	2
#define	UNAME_LEN	32
#define	GNAME_LEN	32
#define	DEVMAJOR_LEN	8
#define	DEVMINOR_LEN	8
#define	PREFIX_LEN	155

struct	f_entries {
    char	name[NAME_LEN];
    char	mode[MODE_LEN +1];
    uid_t	**uid;
    gid_t	**gid;
    char	size[SIZE_LEN +1];
    char	mtime[MTIME_LEN +1];
    char	cksum[CKSUM_LEN +1];
    char	typeflag[TYPEFLAG_LEN];
    char	linkname[LINKNAME_LEN];
    char	magic[MAGIC_LEN +1];
    char	version[VERSION_LEN +1];
    char	uname[UNAME_LEN];
    char	gname[GNAME_LEN];
    char	devmajor[DEVMAJOR_LEN];
    char	devminor[DEVMINOR_LEN];
    char	prefix[PREFIX_LEN];
	} f_entry[] = {
		{					/* Entry 0	*/
		  "type_link_1",				/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000001 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 1	*/
		  "type.d/",					/* name		*/
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 2	*/
		  "type.d/type_reg_L0",			/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 3	*/
		  "type.d/type_reg_L8000",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000017500 ",				/* filesize	*/
		  "04204344156 ",				/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 4	*/
		  "type.d/type_reg_L4000",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000007640 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 5	*/
		  "type.d/type_link_2",			/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize for a link	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_LINK,					/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 6	*/
		  "type.d/type_subdir.d/",		/* name		*/
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{						/* Entry 7	*/
		  "type.d/type_subdir.d/type_reg_L0",	/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 8	*/
		  "type.d/mode_cks.d/",			/* name		*/
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 9	*/
		  "type.d/mode_cks.d/S_IRUSR",	/* name		*/
		  "00000400",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{						/* Entry 10	*/
		  "type.d/mode_cks.d/S_IWUSR",	/* name		*/
		  "00000600",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 11	*/
		  "type.d/mode_cks.d/S_IXUSR",	/* name		*/
		  "00000500",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 12	*/
		  "type.d/mode_cks.d/S_IRGRP",	/* name		*/
		  "00000440",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 13	*/
		  "type.d/mode_cks.d/S_IWGRP",	/* name		*/
		  "00000420",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 14	*/
		  "type.d/mode_cks.d/S_IXGRP",	/* name		*/
		  "00000410",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",		 					/* gname	*/
		  "",	 						/* devmajor	*/
		  "", 							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 15	*/
		  "type.d/mode_cks.d/all_perm_modes",	/* name		*/
		  "00000777",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 16	*/
		  "type.d/mode_cks.d/S_IROTH",	/* name		*/
		  "00000404",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 17	*/
		  "type.d/mode_cks.d/S_IWOTH",	/* name		*/
		  "00000402",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 18	*/
		  "type.d/mode_cks.d/S_IXOTH",	/* name		*/
		  "00000401",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 19	*/
		  "type.d/mode_cks.d/S_ISUID",	/* name		*/
		  "00004500",					/* mode		*/
		  Bin_uid,						/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 20	*/
		  "type.d/mode_cks.d/S_ISGID",	/* name		*/
		  "00002410",					/* mode		*/
		  Uid,							/* uid		*/
		  Bin_gid,						/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 21	*/
		  "type.d/mode_cks.d/S_ISFIFO",	/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_FIFO,					/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 22	*/
		  "type.d/mode_cks.d/S_ISBLK",	/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_BLCK_SP,					/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 23	*/
		  "type.d/mode_cks.d/S_ISCHR",	/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "",							/* cksum	*/
		  TYPE_CHAR_SP,					/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 24	*/
		  "fnames.d/",					/* name		*/
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 25	*/
		  "fnames.d/ABCDEFGHIJLKM",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 26	*/
		  "fnames.d/NOPQRSTUVWXYZ",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 27	*/
		  "fnames.d/abcdefghijlkm",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 28	*/
		  "fnames.d/nopqrstuvwxyz",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 29	*/
		  "fnames.d/0123456789._-",		/* name		*/
		  "00000644",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 30	*/
		  "ln_gt_100_test/",				/* name		*/
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 31	*/
		  "ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 32	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 33	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 34	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 35	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "",							/* prefix	*/
		},
		{					/* Entry 36	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000000 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_DIR,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "ln_gt_100_test",
		},
		{					/* Entry 37	*/
		  "ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/ln_gt_100_test/tar_19",
		  "00000755",					/* mode		*/
		  Uid,							/* uid		*/
		  Gid,							/* gid		*/
		  "00000000016 ",				/* filesize	*/
		  "",							/* mtime	*/
		  "00000144",					/* cksum	*/
		  TYPE_REG,						/* typeflag	*/
		  "linkname",					/* linkname	*/
		  " ustar",						/* magic	*/
		  "02",							/* version	*/
		  "",							/* uname	*/
		  "",							/* gname	*/
		  "",							/* devmajor	*/
		  "",							/* devminor	*/
		  "ln_gt_100_test",
		},
	};
#define	NUM_ENTRIES	(sizeof(f_entry)/sizeof(struct f_entries))
int	num_entries = NUM_ENTRIES;

#define	NAME_OFFSET		0
#define	MODE_OFFSET		100
#define	UID_OFFSET		108
#define	GID_OFFSET		116
#define	SIZE_OFFSET		124
#define	MTIME_OFFSET		136
#define	CKSUM_OFFSET		148
#define	TYPEFLAG_OFFSET		156
#define	LINKNAME_OFFSET		157
#define	MAGIC_OFFSET		257
#define	VERSION_OFFSET		263
#define	UNAME_OFFSET		265
#define	GNAME_OFFSET		297
#define	DEVMAJOR_OFFSET		329
#define	DEVMINOR_OFFSET		337
#define	PREFIX_OFFSET		345

#define	TAR_TYPE_OFFSET	0
#define	TAR_TYPE_LEN		2
#define	TAR_ISDIR		4
#define	TAR_ISFIFO		1
#define	TAR_ISREG		010
#define	TAR_ISBLK		6
#define	TAR_ISCHR		2

#define	TAR_IRUSR		0400
#define	TAR_IWUSR		0200
#define	TAR_IXUSR		0100
#define	TAR_IRGRP		040
#define	TAR_IWGRP		020
#define	TAR_IXGRP		010
#define	TAR_IROTH		04
#define	TAR_IWOTH		02
#define	TAR_IXOTH		01

#define	TAR_SETUID_OFFSET	2
#define	TAR_SETUID_LEN		1
#define	TAR_ISUID		04000
#define	TAR_ISGID		02000

#define	S_ISDIR_ENTRY	1
#define	S_ISREG_ENTRY	3
#define	S_ISFIFO_ENTRY	21
#define	S_ISBLK_ENTRY	22
#define	S_ISCHR_ENTRY	23
#define	S_IRUSR_ENTRY	9
#define	S_IWUSR_ENTRY	10
#define	S_IXUSR_ENTRY	11
#define	S_IRGRP_ENTRY	12
#define	S_IWGRP_ENTRY	13
#define	S_IXGRP_ENTRY	14
#define	S_IROTH_ENTRY	16
#define	S_IWOTH_ENTRY	17
#define	S_IXOTH_ENTRY	18
#define	S_ISUID_ENTRY	19
#define	S_ISGID_ENTRY	20

#define BLANK_ISO646		040

#define	HDR_SIZE	500
char			*hdr_ent[NUM_ENTRIES];
int				map_ent[NUM_ENTRIES];
unsigned long	det_cksum[NUM_ENTRIES];

char	data_buf[TAR_BLOCK_SIZE];	
char	name_buf[NAME_LEN +PREFIX_LEN +1];
char	path[_POSIX_PATH_MAX +1];

int	fd, i, j;


int	main(void)
{
	struct	stat	st_buf;

	setup(E_TAR);
	funct(E_TAR);

			/*	An Extended TAR archive produces fixed size blocks of
				512 characters.
			*/
	assertion(1, BASE);
	start
		prep("Setup required storage area.");
		start
			if(BLOCK_SPECIAL == 0)
				num_entries--;
			if(CHAR_SPECIAL == 0)
				num_entries--;

			for(i=0; i<num_entries; ++i)
				if((hdr_ent[i] = (char *) Zmalloc(HDR_SIZE)) == NULL)
					error("Couldn't Zmalloc hdr_ent[%d]", i);
		finis

		prep("Initialize path to expected Extended TAR archive.");
		start
			strcpy(path, data_path());
			strcat(path, "tar_dif");
		finis

		testing("Length of archive is a multiple of 512.");
		start
			continue_on(ERROR);
			Zstat(path, &st_buf);
			if(st_buf.st_size % TAR_BLOCK_SIZE) {
				error("%s%s\n%s%lu\n",
					"Expected file size of archive to ",
					"be a multiple of TAR_BLOCK_SIZE.",
					"Actual file size is ",
					(unsigned long) st_buf.st_size);
				sv_flush();
			}
		finis
	finis
		
			/*	An Extended TAR archived file contains a header block as
				specified below:
					Field_Name		Byte_Offset		Length

					name			0				100
					mode			100				8
					uid				108				8
					gid				116				8
					size			124				12
					mtime			136				12
					cksum			148				8
					typeflag		156				1
					linkname		157				100
					magic			257				6
					version			263				2
					uname			265				32
					gname			297				32
					devmajor		329				8
					devminor		337				8
					prefix			345				155

				followed by zero or more blocks that provide the contents
				of the file and two blocks filled with binary zeros.
			*/
	assertion(2, BASE);
	start
										/*	Open IUT's created archive file. */
		Zstrcpy(path, data_path());
		Zstrcat(path, "tar_dif");
		fd = Zopen(path, O_RDONLY);

		testing("Read header files for all file entries in archive \"%s\".",
															path);
		start
			for(i=0; i<num_entries; i++) 
				read_entry();
		finis
	finis

	assertion(3, BASE);
	start
		testing("Last two blocks filled with binary zeros.");
		start
			for(i=0; i<2; i++) {
				char	*ptr;

				continue_on(ERROR);
				Zread(fd, data_buf, TAR_BLOCK_SIZE);
				for(ptr=data_buf; ptr<data_buf +TAR_BLOCK_SIZE; ptr++)
				if(*ptr) {
					error("Block %d\n%s\n%s%o%s%d.\n",
							i,
							"Expected all binary zeros.",
							"Actually contains an octal ",
							*ptr,
							" in position ",
							ptr -data_buf);
					break;
				}
			}
		finis
	finis

	assertion(4, EXTENDED);
	assertion(8, EXTENDED);

	assertion(9, BASE);
	start
		testing("Support for file names with characters of [a-zA-Z0-9.-_]");
		testing("are tested in the other assertions of this element.");
		testing("(See Entries 23-28 in f_entry structure.)");
		start
		finis
	finis

	assertion(10, BASE);
	start
		testing("Support for upper and lower case letters");
		testing("are tested in the other assertions of this element.");
		testing("(See Entries 23-28 in f_entry structure.)");
		start
		finis
	finis

	assertion(11, EXTENDED);

	assertion(12, BASE);
	start
		testing("Fields magic, uname and gname are null terminated strings.");
		start
			for(i=0; i<num_entries; i++) {
				if(ck_str(&hdr_ent[i][MAGIC_OFFSET], MAGIC_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][NAME_OFFSET],
							"Magic field is not null terminated.");

				if(ck_str(&hdr_ent[i][UNAME_OFFSET], UNAME_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][NAME_OFFSET],
							"Uname field is not null terminated.");

				if(ck_str(&hdr_ent[i][GNAME_OFFSET], GNAME_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][NAME_OFFSET],
							"Gname field is not null terminated.");
			}
		finis
	finis

	assertion(13, BASE);
	start
		testing("Fields: name, linkname, and prefix are null terminated");
		testing("character strings except when all characters in the array");
		testing("contain non-null characters including the last character.");
		start
			/* Entry names are all less than length of field. */
			for(i=0; i<num_entries; i++) {
				if(ck_str(&hdr_ent[i][NAME_OFFSET], NAME_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][NAME_OFFSET],
							"Name field is not null terminated.");

				if(ck_str(&hdr_ent[i][LINKNAME_OFFSET], LINKNAME_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][UNAME_OFFSET],
							"Linkname field is not null terminated.");

				if(ck_str(&hdr_ent[i][PREFIX_OFFSET], PREFIX_LEN))
					error("Entry %d, Filename \"%s\"\n%s\n",
							i,
							&hdr_ent[i][GNAME_OFFSET],
						"Prefix field is not null terminated.");
			}
		finis
	finis

	assertion(14, BASE);
	start
		testing("Version field is two bytes containing the characters '00'.");
		start
			for(i=0; i<num_entries; i++) {
				if(strncmp("00", &hdr_ent[i][VERSION_OFFSET], VERSION_LEN))
					error("Entry %d, Filename \"%s\",  Data \"%.2s\"\n",
							i,
							&hdr_ent[i][NAME_OFFSET],
							&hdr_ent[i][VERSION_OFFSET]);

			}
		finis
	finis

	assertion(15, BASE);
	start
		testing("Fields mode, uid, gid, size, mtime, cksum, devmajor and");
		testing("devminor are leading zero-filled octal numbers");
		testing("in ISO/IEC 646 IRV, and are terminated by one or more");
		testing("space or null characters.");
		start
					/*	NOTE: These fields are converted to the local
						codeset in read_entry() so that local character
						values can be used during testing.
					*/
			for(i=0; i<num_entries; i++) {
				ck_field(i, "Mode", &hdr_ent[i][MODE_OFFSET], MODE_LEN);
				ck_field(i, "Uid", &hdr_ent[i][UID_OFFSET], UID_LEN);
				ck_field(i, "Gid", &hdr_ent[i][GID_OFFSET], GID_LEN);
				ck_field(i, "Size", &hdr_ent[i][SIZE_OFFSET], SIZE_LEN);
				ck_field(i, "Mtime", &hdr_ent[i][MTIME_OFFSET], MTIME_LEN);
				ck_field(i, "Cksum", &hdr_ent[i][CKSUM_OFFSET], CKSUM_LEN);
						/* Only check devminor and devmajor fields for
						   block and character special files.
						*/
				if( (hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_CHAR_SP) ||
					(hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_BLCK_SP) ) {
					ck_field(i, "Devmajor", &hdr_ent[i][DEVMAJOR_OFFSET],
								 DEVMAJOR_LEN);
					ck_field(i, "Devminor", &hdr_ent[i][DEVMINOR_OFFSET],
								 DEVMINOR_LEN);
				}
			}
		finis
	finis

	assertion(16, BASE);
	start
		testing("When the prefix field is not an empty string, then the");
		testing("pathname of the file extracted by the extended tar format");
		testing("reading utility is the concatenation of the prefix,");
		testing("a slash character, and the name.");
		start
			for(i=0; i<num_entries; i++) {
						/* Determine actual pathname */
				j = map_ent[i];
				/* Don't process special files, extracted as tester. */
				if(	(hdr_ent[j][TYPEFLAG_OFFSET] == TYPE_BLCK_SP) ||
					(hdr_ent[j][TYPEFLAG_OFFSET] == TYPE_CHAR_SP) )
						continue;

				Zstrcpy(name_buf, data_path());
				if(hdr_ent[j][PREFIX_OFFSET]) {
					strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
					if(name_buf[strlen(name_buf) -1] != '/')
						strcat(name_buf, "/");
					strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);

					if(access(name_buf, F_OK))
						error("%s\n%s%d\n%s%s\n%s\"%s\"\n%s\"%s\"\n",
							"Failed access().",
							"Entry ",
							i,
							"Filename ",
							&hdr_ent[j][NAME_OFFSET],
							"Prefix ",
							&hdr_ent[j][PREFIX_OFFSET],
							"Pathname used ",
							name_buf);
				}
			}
		finis
	finis

	assertion(17, BASE);
	start
		testing("When the prefix field is an empty string, then the");
		testing("pathname of the file is name.");
		start
			for(i=0; i<num_entries; i++) {
				j = map_ent[i];
				/* Don't process special files, extracted as tester. */
				if(	(hdr_ent[j][TYPEFLAG_OFFSET] == TYPE_BLCK_SP) ||
					(hdr_ent[j][TYPEFLAG_OFFSET] == TYPE_CHAR_SP) )
						continue;

						/* Determine actual pathname */
				Zstrcpy(name_buf, data_path());
				if( ! hdr_ent[j][PREFIX_OFFSET]) {
					strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);

					if(access(name_buf, F_OK))
						error("%s\n%s%d\n%s%s\n%s\"%s\"\n%s\"%s\"\n",
							"Failed access().",
							"Entry ",
							i,
							"Filename ",
							&hdr_ent[j][NAME_OFFSET],
							"Prefix ",
							&hdr_ent[j][PREFIX_OFFSET],
							"Pathname used ",
							name_buf);
				}
			}
		finis
	finis

	assertion(18, BASE);
	start
		testing("Linkname field does not use the prefix to produce pathname.");
		start
			char	tmp_buf[_POSIX_PATH_MAX +1];

			for(i=0; i<num_entries; i++) {
						/* Only check link files */
				if(hdr_ent[i][TYPEFLAG_OFFSET] != TYPE_LINK)
					continue;

				Zstrcpy(tmp_buf, data_path());
				Zstrcat(tmp_buf, &hdr_ent[i][LINKNAME_OFFSET]);
				Zaccess(tmp_buf, F_OK);
			}
		finis
	finis

	assertion(19, BASE);
	start
		prep("Validate data path.");
		start
			strcpy(path, data_path());
			strcat(path, "ln_gt_100_test");
			expecting(SUCCESS);
			Zaccess(path, R_OK);
		finis

									/*	NOTE: The script "./bin/dif_script"
										has already performed the setup
										and most of the testing associated
										with this assertion.
									*/
		testing("When the linkname does not fit in the space provided");
		testing("(100 characters), then the extended tar format creating");
		testing("utility does not store the link on the archive.");
		start
			strcpy(path, data_path());
			strcat(path, "gt_100_link");
			expecting(ENOENT);
			Zaccess(path, R_OK);
		finis
	finis

						/*	Assertion 20 and its related documentation
							assertion D04 surely define an assertion that
							is EXTENDED with Reason #2 (The corresponding
							statement in the POSIX standard to which
							conformance is being measured is not specific
							enough to write a portable test.)
						*/
	assertion(20, EXTENDED);

	assertion(21, BASE);
	start
		testing("The user ID and group ID fields are the user ID and group ID");
		testing("of the file's owner and group respectively.");
		start
			for(i=0; i<num_entries; i++) {
				j = map_ent[i];
				if(**f_entry[i].uid !=
								(uid_t) atoo(&hdr_ent[j][UID_OFFSET],UID_LEN))
					error("Entry %d.\n%s\n%s%d\n%s\"%6.6s\"\n",
							i,
							"Incorrect value for user ID.",
							"Expected user ID value of ",
							**f_entry[i].uid,
							"Actual bytes are ",
							&hdr_ent[j][UID_OFFSET]);

				if(**f_entry[i].gid !=
								(gid_t) atoo(&hdr_ent[j][GID_OFFSET],GID_LEN))
					error("Entry %d.\n%s\n%s%d\n%s\"%6.6s\"\n",
							i,
							"Incorrect value for group ID.",
							"Expected group ID value of ",
						**f_entry[i].gid,
						"Actual bytes are ",
						&hdr_ent[j][GID_OFFSET]);
			}
		finis
	finis

	assertion(22, BASE);
	start
		testing("When the typeflag field is '0' denoting a regular file,");
		testing("then the size field is the size of the file in bytes.");
		start
			for(i=0; i<num_entries; i++) {
				if( ! (*f_entry[i].typeflag == REGTYPE) )
					continue;
				if(atoo(&hdr_ent[map_ent[i]][SIZE_OFFSET], SIZE_LEN) !=
						 					atoo(f_entry[i].size, SIZE_LEN))
					error("%s\n%s%d\n%s%s\n%s\"%11.11s\"\n%s\"%11.11s\"\n",
							"Size field incorrect.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Expected bytes ",
							f_entry[i].size,
							"Actual bytes   ",
							&hdr_ent[map_ent[i]][SIZE_OFFSET]);
			}
		finis
	finis

	assertion(23, BASE);
	start
		testing("For link files where typeflag is 1 or 2 the size field");
		testing("is zero.");
		start
			for(i=0; i<num_entries; i++) {
				if( ! ((*f_entry[i].typeflag == LNKTYPE) ||
									(*f_entry[i].typeflag == SYMTYPE)) )
					continue;
				if(atoo(&hdr_ent[map_ent[i]][SIZE_OFFSET], SIZE_LEN) !=
						 				atoo(f_entry[i].size, SIZE_LEN))
					error("%s\n%s%d\n%s%s\n%s\"%11.11s\"\n%s\"%11.11s\"\n",
							"Size field incorrect.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Expected bytes ",
							f_entry[i].size,
							"Actual bytes   ",
							&hdr_ent[map_ent[i]][SIZE_OFFSET]);
			}
		finis
	finis

	assertion(24, BASE);
	start
		testing("In the archive generated by the extended tar format creating");
		testing("utility, a typeflag field of DIRTYPE or FIFOTYPE causes no");
		testing("data blocks to be stored.");
		start
								/* Size field is zero. */
			for(i=0; i<num_entries; i++) {
				if( ! ((*f_entry[i].typeflag == DIRTYPE) ||
									(*f_entry[i].typeflag == FIFOTYPE)) )
					continue;
				if(atoo(&hdr_ent[map_ent[i]][SIZE_OFFSET], SIZE_LEN) != 0)
					error("%s\n%s%d\n%s%s\n%s\n%s\"%11.11s\"\n",
							"Size field incorrect.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Expected bytes: 0",
							"Actual bytes   ",
							&hdr_ent[map_ent[i]][SIZE_OFFSET]);
			}
		finis
	finis

	assertion(25, BASE);
	start
		if(CHAR_SPECIAL == 1) {
			testing("In the archive generated by the extended tar format");
			testing("creating utility, a typeflag field of CHRTYPE causes");
			testing("no data blocks to be stored.");
			start
					/*	If data blocks were actually stored for character
						special files, the reading of the archived "tar"
						file [by read_entry()] would report numerous
						problems and most likely abort.

						The code below only provides a warning message if
						the size field is non-zero.
					*/
								/* Size field is zero. */
				for(i=0; i<num_entries; i++) {
					if(*f_entry[i].typeflag != CHRTYPE)
						continue;
					if(atoo(&hdr_ent[map_ent[i]][SIZE_OFFSET], SIZE_LEN) != 0)
						warning("%s\n%s%d\n%s%s\n%s\n%s\"%11.11s\"\n",
							"Size field set.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Normally expected bytes: 0",
							"Actual bytes   ",
							&hdr_ent[map_ent[i]][SIZE_OFFSET]);
				}
			finis
		}
		else
			not_implemented("character special files");
	finis

	assertion(26, BASE);
	start
		if(BLOCK_SPECIAL == 1) {
			testing("In the archive generated by the extended tar format");
			testing("creating utility, a typeflag field of BLKTYPE causes");
			testing("no data blocks to be stored.");
			start
					/*	If data blocks were actually stored for block
						special files, the reading of the archived "tar"
						file [by read_entry()] would report numerous
						problems and most likely abort.

						The code below only provides a warning message if
						the size field is non-zero.
					*/
								/* Size field is zero. */
				for(i=0; i<num_entries; i++) {
					if(*f_entry[i].typeflag != BLKTYPE)
						continue;
					if(atoo(&hdr_ent[map_ent[i]][SIZE_OFFSET], SIZE_LEN) != 0)
						warning("%s\n%s%d\n%s%s\n%s\n%s\"%11.11s\"\n",
							"Size field incorrect.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Normally expected bytes: 0",
							"Actual bytes   ",
							&hdr_ent[map_ent[i]][SIZE_OFFSET]);
				}
			finis
		}
		else
			not_implemented("block special files");
	finis

	assertion(27, BASE);
	start
		testing("When a file extracted by the extended tar format reading");
		testing("utility contains a typeflag field of FIFOTYPE, then the");
		testing("size field is ignored.");
		start
			for(i=0; i<num_entries; i++) {
				if(*f_entry[i].typeflag != FIFOTYPE)
					continue;

								/* Determine actual pathname */
				j = map_ent[i];
				Zstrcpy(name_buf, data_path());
				if(hdr_ent[j][PREFIX_OFFSET]) {
					strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
					if(name_buf[strlen(name_buf) -1] != '/')
						strcat(name_buf, "/");
					strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
				} else
					strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);

							/* Size field is zero. */
				Zstat(name_buf, &st_buf);
				if(st_buf.st_size != 0)
					error("FIFO file \"%s\" extracted with a size of %lu.",
								name_buf, (unsigned long) st_buf.st_size);
			}
		finis
	finis

	assertion(28, BASE);
	start
		testing("The mtime field is the ISO/IEC 646 IRV representation of");
		testing("the octal value of the modification time of the file at");
		testing("the time it was archived.");
		start
			for(i=0; i<num_entries; i++) {
				/* Only check Regular files for proper mtime value*/
				/* Use expected entry file for determining file type */
				if( ! ((*f_entry[i].typeflag == REGTYPE) ||
								(*f_entry[i].typeflag == AREGTYPE)) )
					continue;
				if(strncmp(MTIME_VALUE, &hdr_ent[map_ent[i]][MTIME_OFFSET],
													MTIME_LEN-MTIME_TERM_PAD))
				error("Entry %d %s\"%s\".\n%s\n%s\"%11.11s\"\n%s\"%11.11s\"\n",
						i,
						"Filename ",
						&hdr_ent[map_ent[i]][NAME_OFFSET],
						"Incorrect value for mtime.",
						"Expected the bytes ",
						MTIME_VALUE,
						"Actual bytes are   ",
						&hdr_ent[map_ent[i]][MTIME_OFFSET]);
			}
		finis
	finis

	assertion(29, BASE);
	start
		testing("The chksum field is the ISO/IEC 646 IRV representation of");
		testing("the octal value of simple sum of all bytes in header block.");
			/*	Each 8 bit byte is treated as an unsigned value.
				These values are added to an unsigned integer, initialized
				to zero, the precision of which shall be no less than 17
				bits.  The chksum field is treated as if it were all blanks.
				The header block as far as the cksum value is 500 bytes long.

				The checksum (det_cksum) is computed on the ISO/IEC 646 IRV
				values for each header block in read_entry() and saved for
				use in this test.  Routine read_entry() also converts the
				cksum header block field to the local codeset.
			*/
		start
			unsigned long	hdr_cksum;

			for(i=0; i<num_entries; i++) {
				hdr_cksum = atoo(&hdr_ent[i][CKSUM_OFFSET],
												CKSUM_LEN-CKSUM_TERM_PAD);
				if(det_cksum[i] != hdr_cksum)
					error("Entry %d %s\"%s\".\n%s\n%s %#lo \n%s %s\n",
						i,
						"Filename ",
						&hdr_ent[map_ent[i]][NAME_OFFSET],
						"Incorrect value for cksum (16 bits checked).",
						"Expected the octal value ",
						det_cksum[i], 
						"Actual octal value is   ",
						&hdr_ent[i][CKSUM_OFFSET]);
			}
		finis
	finis

	assertion(30, EXTENDED);

	assertion(31, BASE);
	start
		testing("A regular file is archived with a typeflag of 0.");
		start
			ck_types('0');
		finis
	finis

	assertion(32, BASE);
	start
		testing("A linked file is archived with a typeflag of 1.");
		start
			ck_types('1');
		finis
	finis

	assertion(33, BASE);
	start
		if(CHAR_SPECIAL == 1) {
			testing("A character special file is archived with typeflag of 3.");
			start
				ck_types('3');
			finis
		}
		else
			not_implemented("character special files");
	finis

	assertion(34, BASE);
	start
		if(BLOCK_SPECIAL == 1) {
			testing("A block special file is archived with a typeflag of 4.");
			start
				ck_types('4');
			finis
		}
		else
			not_implemented("block special files");
	finis

	assertion(35, BASE);
	start
		testing("A directory file is archived with a typeflag of 5.");
		start
			ck_types('5');
		finis
	finis

	assertion(36, BASE);
	start
		testing("A FIFO file is archived with a typeflag of 6.");
		start
			ck_types('6');
		finis
	finis

	assertion(37, EXTENDED);

	assertion(38, BASE);
	start
		testing("When reading an archive a typeflag of 0 causes a regular");
		testing("file to be generated.");
		start
			for(i=0; i<num_entries; i++) {
				if(*f_entry[i].typeflag == REGTYPE) {
						/* Determine actual pathname */
					j = map_ent[i];
					Zstrcpy(name_buf, data_path());
					if(hdr_ent[j][PREFIX_OFFSET]) {
						strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
						if(name_buf[strlen(name_buf) -1] != '/')
							strcat(name_buf, "/");
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
					} else
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
	
					Zstat(name_buf, &st_buf);
					if( ! S_ISREG(st_buf.st_mode) )
						error("File %s with typeflag 0, not a regular file.",
															name_buf);
				}
			}
		finis
	finis

	assertion(39, BASE);
	start
		testing("When reading an archive a typeflag of 1 causes a linked");
		testing("file to be generated.");
		start
			for(i=0; i<num_entries; i++) {
				if(*f_entry[i].typeflag == LNKTYPE) {
						/* Determine actual pathname */
					j = map_ent[i];
					Zstrcpy(name_buf, data_path());
					if(hdr_ent[j][PREFIX_OFFSET]) {
						strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
						if(name_buf[strlen(name_buf) -1] != '/')
							strcat(name_buf, "/");
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
					} else
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
	
					if(access(name_buf, F_OK))
						error("File %s with typeflag 1, not created.",
															name_buf);
				}
			}
		finis
	finis

	assertion(40, BASE);
	start
		testing("When reading an archive a typeflag of 5 causes a directory");
		testing("file to be generated.");
		start
			for(i=0; i<num_entries; i++) {
				if(*f_entry[i].typeflag == DIRTYPE) {
						/* Determine actual pathname */
					j = map_ent[i];
					Zstrcpy(name_buf, data_path());
					if(hdr_ent[j][PREFIX_OFFSET]) {
						strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
						if(name_buf[strlen(name_buf) -1] != '/')
							strcat(name_buf, "/");
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
					} else
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
	
					Zstat(name_buf, &st_buf);
					if( ! S_ISDIR(st_buf.st_mode) )
						error("File %s with typeflag 0, not a directory file.",
															name_buf);
				}
			}
		finis
	finis

	assertion(41, BASE);
	start
		testing("When reading an archive a typeflag of 6 causes a FIFO");
		testing("file to be generated.");
		start
			for(i=0; i<num_entries; i++) {
				if(*f_entry[i].typeflag == FIFOTYPE) {
						/* Determine actual pathname */
					j = map_ent[i];
					Zstrcpy(name_buf, data_path());
					if(hdr_ent[j][PREFIX_OFFSET]) {
						strcat(name_buf, &hdr_ent[j][PREFIX_OFFSET]);
						if(name_buf[strlen(name_buf) -1] != '/')
							strcat(name_buf, "/");
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
					} else
						strcat(name_buf, &hdr_ent[j][NAME_OFFSET]);
	
					Zstat(name_buf, &st_buf);
					if( ! S_ISFIFO(st_buf.st_mode) )
						error("File %s with typeflag 6, not a FIFO file.",
															name_buf);
				}
			}
		finis
	finis

	assertion(42, EXTENDED);
	assertion(43, EXTENDED);

	assertion(44, BASE);
	start
			testing("When the magic field contains TMAGIC (\" ustar\"), then");
			testing("uname and gname fields contain the ISO/IEC 646 IRV");
			testing("representation of the owner and group of the file");
			testing("respectively.");
			start
				struct	passwd	*pw_ptr;
				struct	group	*gr_ptr;
				int	n_len;
	
				for(i=0; i<num_entries; i++) {
					pw_ptr = Zgetpwuid(**f_entry[i].uid);
					n_len = Zstrlen(&hdr_ent[map_ent[i]][UNAME_OFFSET]);
					if(strncmp(&hdr_ent[map_ent[i]][UNAME_OFFSET],
							 							pw_ptr->pw_name, n_len))
						error("%s\n%s%d\n%s%s\n%s\"%s\"\n%s\"%s\"\n",
							"Uname field incorrect.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Expected ",
							pw_ptr->pw_name,
							"Actual ",
							&hdr_ent[map_ent[i]][UNAME_OFFSET]);
	
					gr_ptr = Zgetgrgid(**f_entry[i].gid);
					n_len = strlen(&hdr_ent[map_ent[i]][GNAME_OFFSET]);
					if(! n_len)
						error("%s\n%s%d\n%s%s\n%s\n%s\n",
							"Invalid \"gname\" field.",
							"Entry ",
							i,
							"Filename ",
							f_entry[i].name,
							"Expected a group name.",
							"Actually no name was provided.");
					else
						if(strncmp(&hdr_ent[map_ent[i]][GNAME_OFFSET],
														gr_ptr->gr_name, n_len))
							error("%s\n%s%d\n%s%s\n%s\"%s\"\n%s\"%s\"\n",
								"Gname field incorrect.",
								"Entry ",
								i,
								"Filename ",
								f_entry[i].name,
								"Expected ",
								gr_ptr->gr_name,
								"Actual ",
								&hdr_ent[map_ent[i]][GNAME_OFFSET]);
				}
			finis
	finis

	assertion(45, EXTENDED);

	cleanup("Return allocated storage.");
	start
		for (i = 0; i < num_entries; ++i)
			if(hdr_ent[i] != NULL)
				Zfree(hdr_ent[i]);
	finis

	done();
}


void read_entry(void)
{
	unsigned long	cnt;
	size_t			name_len;
	int				prefix_len;

	continue_on(ERROR);

	Zread(fd, hdr_ent[i], HDR_SIZE);
	Zread(fd, data_buf, TAR_BLOCK_SIZE - HDR_SIZE);		/* Read header filler */

	/*	The chksum field is the ISO/IEC 646 IRV representation of the
		octal value of the simple sum of all bytes in the header block
		when represented as ISO/IEC 646 IRV values.  The checksum value
		is computed by treating each 8 bit byte as an unsigned value.
		These values are added to an unsigned integer, initialized to
		zero, the precision of which shall be no less than 17 bits.
		The chksum field is treated as if it were all ISO/IEC 646 IRV
		blanks.
		The header block is 500 bytes long for computing the checksum.

		Compute checksum using ISO/IEC 646 IRV values provided and save it.
	*/
	det_cksum[i] = (unsigned long) 0;
	for(j=0; j<CKSUM_OFFSET; j++)
		det_cksum[i] += hdr_ent[i][j];
	for(j=0; j<CKSUM_LEN; j++)			/* cksum field */
 		det_cksum[i] += BLANK_ISO646;
	for(j=TYPEFLAG_OFFSET; j<HDR_SIZE; j++)
		det_cksum[i] += hdr_ent[i][j];

			/*	Convert tar header data blocks to local character set.	*/
	for(j=0; j<HDR_SIZE; j++)
		hdr_ent[i][j] = cs_trans[hdr_ent[i][j]].native;

#ifdef	DEBUG_TAR
	prep("Data read:%d\n",i);
	prep("\tname\t\"%-.100s\"", &hdr_ent[i][NAME_OFFSET]);
	prep("\tmode\t\"%-8.8s\"", &hdr_ent[i][MODE_OFFSET]);
	prep("\tuid\t\"%-8.8s\"", &hdr_ent[i][UID_OFFSET]);
	prep("\tgid\t\"%-8.8s\"", &hdr_ent[i][GID_OFFSET]);
	prep("\tsize\t\"%-11.11s\"", &hdr_ent[i][SIZE_OFFSET]);
	sv_flush();
	prep("\tmtime\t\"%-12.12s\"", &hdr_ent[i][MTIME_OFFSET]);
	prep("\tcksum\t\"%-8.8s\"", &hdr_ent[i][CKSUM_OFFSET]);
	prep("\ttypeflag\t\"%1.1s\"", &hdr_ent[i][TYPEFLAG_OFFSET]);
	prep("\tlinkname\t\"%-.100s\"", &hdr_ent[i][LINKNAME_OFFSET]);
	prep("\tmagic\t\"%-6s\"", &hdr_ent[i][MAGIC_OFFSET]);
	sv_flush();
	prep("\tversion\t\"%-2.2s\"", &hdr_ent[i][VERSION_OFFSET]);
	prep("\tuname\t\"%-32s\"", &hdr_ent[i][UNAME_OFFSET]);
	prep("\tgname\t\"%-32s\"", &hdr_ent[i][GNAME_OFFSET]);
	prep("\tdevmajor\t\"%-8.8s\"", &hdr_ent[i][DEVMAJOR_OFFSET]);
	prep("\tdevminor\t\"%-8.8s\"", &hdr_ent[i][DEVMINOR_OFFSET]);
	prep("\tprefix\t\"%-.155s\"", &hdr_ent[i][PREFIX_OFFSET]);
	sv_flush();
#endif

		/*	Determine actual pathname using prefix if it exists.  */
	prefix_len = 0;
	if(hdr_ent[i][PREFIX_OFFSET]) {
		Zstrcpy(name_buf, &hdr_ent[i][PREFIX_OFFSET]);
		if(name_buf[strlen(name_buf) -1] != '/')
			Zstrcat(name_buf, "/");
		prefix_len = strlen(name_buf);
	}
	Zstrncpy(name_buf +prefix_len, &hdr_ent[i][NAME_OFFSET], NAME_LEN);

								/* Ensure name_buf string is terminated. */
	if(hdr_ent[i][NAME_OFFSET +NAME_LEN -1] != '\0')
		name_buf[NAME_LEN +prefix_len] = '\0';

							/* Ensure, when directory, trailing "/" exists. */
	name_len = Zstrlen(name_buf);
	if(		(hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_DIR) &&
			(name_buf[name_len -1] != '/') &&
			(name_len < NAME_LEN +PREFIX_LEN +1) )
		Zstrcat(name_buf, "/");

	for(j=0; j<NUM_ENTRIES; j++) { /* Determine index to duplicate file entry */
		char	t_buf[NAME_LEN +PREFIX_LEN +1];

		strcpy(t_buf, f_entry[j].prefix);
		if(*t_buf != (char) NULL)
			strcat(t_buf, "/");
		strcat(t_buf, f_entry[j].name);
		if( ! strcmp(t_buf, name_buf) ) {
			map_ent[j]= i;
#ifdef	DEBUG_TAR
			prep("Mapped Input entry %d to Expected entry %d\n", i, j);
			sv_flush();
#endif
			break;
		}
	}

#ifndef	DEBUG_TAR
	exit_on(ERROR);
#else
	prep("\tname_buf\t\"%-.255s\"", name_buf);
#endif
	if(map_ent[j] != i)
		error("%s\n%s\"%-.155s\"\n%s\"%-.*s\"",
			"Cannot locate prefix/filename extracted from expected entries.",
			"Extracted prefix of: ",
			&hdr_ent[i][PREFIX_OFFSET],
			"Extracted file name of: ",
			NAME_LEN,
			&hdr_ent[i][NAME_OFFSET]);

	continue_on(ERROR);
						/*	If file type is LNKTYPE, CHARTYPE, BLKTYPE,
							or FIFOTYPE no data blocks are stored on
							the medium.
						*/
	if( !	((hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_LINK) ||
			(hdr_ent[i][TYPEFLAG_OFFSET] == SYMTYPE) ||
			(hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_CHAR_SP) ||
			(hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_BLCK_SP) ||
			(hdr_ent[i][TYPEFLAG_OFFSET] == TYPE_FIFO)) ) {

		unsigned long d_size, r_size;

		(void) sscanf(&hdr_ent[i][SIZE_OFFSET], "%12lo", &d_size);
		(void) sscanf(f_entry[j].size, "%12lo", &r_size);
		if(d_size != r_size)
			error("%s%d, Entry %d\n%s\"%s\"\n%s\n%s%12.12s\n%s%12.12s\n",
				"Archived file entry ",
				i,
				j,
				"File name ",
				f_entry[j].name,
				"Incorrect byte string for size detected.",
				"Expected the bytes ",
				f_entry[j].size,
				"Actual bytes are ",
				&hdr_ent[i][SIZE_OFFSET]);

		cnt = atoo(&hdr_ent[i][SIZE_OFFSET], SIZE_LEN -SIZE_TERM_PAD);
		if(cnt > 0) {
			int	blk_cnt, i;

			blk_cnt = (int) (cnt/(TAR_BLOCK_SIZE)) +((cnt%TAR_BLOCK_SIZE != (unsigned long) 0) ? 1 : 0);
			expecting(TAR_BLOCK_SIZE);
			for(i=0; i<blk_cnt; i++)
				Zread(fd, data_buf, TAR_BLOCK_SIZE);
		}
	}
}


/*	Convert a native character string containing leading binary zeros and
	terminated by spaces and/or nulls into its equivalent octal value.
*/
unsigned long atoo(char *str, int len)
{
	unsigned long	value=0;
	int	j;

	for(j=0; j<len; j++, str++) {
		if( ! ((*str == '\000') || (*str == ' ')) )
			break;
	}
	for(; j<len; j++) {
		if( (*str == '\000') || (*str == ' ') )
			break;
		value = value*8 + *str++ - '0';
	}
	return(value);
}


/*	Check that character string passed is null terminated.		*/
/*		Return 0, if a null is found				*/

int ck_str(char *str, int len_str)
{
	int	j;

	for (j=0; j<len_str; j++, str++)
		if( ! *str )
		return(0);
	return(1);
}


/*	Check that field contains leading binary zeros, octal values,
	and terminates with one or more spaces and/or nulls.
*/

void ck_field(int index, char *f_name, char *str, int len_str)
{
	int		j, k, l;
	int		value = 0;
	char	tmp_buf[PREFIX_LEN +1];

	strncpy(tmp_buf, str, len_str);		/* Ensure field terminated properly. */
	tmp_buf[len_str] = '\000';

	for(j=0; j<len_str; j++, str++) {	/* Process leading binary zeroes. */
#ifdef	DEBUG_TAR
prep("1 \"%o\" \"%c\" \"%s\" \"%s\"\n", *str, *str, str, tmp_buf);
sv_flush();
#endif
		if(*str) {						/* Process value.	*/
			for(k=j; k<len_str; k++, str++) {
#ifdef	DEBUG_TAR
prep("2 \"%o\" \"%c\" \"%s\" \"%s\"\n", *str, *str, str, tmp_buf);
sv_flush();
#endif
				if( (*str == '\000') || (*str == ' ') ) {	/* End of value? */
					if(!value) {							/* Start of field */
						error("Entry %d\nFilename \"%s\"\n%s %s\n%s\"%s\"\n",
								index,
								&hdr_ent[index][NAME_OFFSET],
								f_name,
								"field formatted improperly (leading space).",
								"Actual field characters are ",
								tmp_buf);
						return;
					}
					for(l=k; l<len_str; l++, str++) { /* Process terminator? */
#ifdef	DEBUG_TAR
prep("3 \"%o\" \"%c\" \"%s\" \"%s\"\n", *str, *str, str, tmp_buf);
#endif
						if( (*str == '\000') || (*str == ' ') ) {
							if(l == len_str -1)
								return;			/* Successful */
							continue;
						}
						error("Entry %d\nFilename \"%s\"\n%s %s\n%s\"%s\"\n",
								index,
								&hdr_ent[index][NAME_OFFSET],
								f_name,
								"field terminated improperly.",
								"Actual field characters are ",
								tmp_buf);
						return;
					}
				}

				if( (*str < '0') || (*str > '7') ) {
					error("Entry %d\nFilename \"%s\"\n%s %s\n%s\"%s\"\n",
								index,
								&hdr_ent[index][NAME_OFFSET],
								f_name,
								"field contains non-octal value.",
								"Actual field characters are ",
								tmp_buf);
					return;
				}
				else
					value++;
			}
		}
	}
	error("Entry %d\nFilename \"%s\"\n%s %s\n%s\"%s\"\n",
								index,
								&hdr_ent[index][NAME_OFFSET],
								f_name,
								"field not terminated properly.",
								"Actual field characters are ",
								tmp_buf);
	return;
}


/*
	Check that field terminates with one or more space or null characters.
	A check is made that the field does contain a space followed
	by a NULL.
*/

void ck_term(int index, char *f_name, char *str, int len_str)
{
	int	j;
	char	tmp_buf[PREFIX_LEN +1];

	strncpy(tmp_buf, str, len_str);
	tmp_buf[len_str] = '\000';
	for (j=0; j<len_str -1; j++, str++) {
		if(*str == ' ') {
		if( *(str +1) == '\000' )
			return;
		}
	}
	error("Entry %d\nFilename \"%s\"\n%s\n%s\n%s\"%s\"\n",
		index,
		&hdr_ent[index][NAME_OFFSET],
		f_name,
		"field does not contain a space followed by a NULL.",
		"Actual field characters are ",
		tmp_buf);
}


/*	Check that field terminates with a space.			*/
/*	Note: These fields are required to have no imbeded spaces.	*/

void ck_t_sp(int index, char *f_name, char *str, int len_str)
{
	int	j;
	char	tmp_buf[PREFIX_LEN +1];

	strncpy(tmp_buf, str, len_str);
	tmp_buf[len_str] = '\000';
	for (j=0; j<len_str; j++, str++) {
		if(*str == ' ')
		return;
	}
	error("Entry %d, Filename \"%s\"\n%s %s\n%s\"%s\"\n",
		index,
		&hdr_ent[index][NAME_OFFSET],
		f_name,
		"field does not contain a space.",
		"Actual field characters are ",
		tmp_buf);
}

int	ck_types(char type_value)
{
	int	i;

	for(i=0; i<num_entries; i++) {
		if(*f_entry[i].typeflag != type_value)
			continue;

		if(hdr_ent[map_ent[i]][TYPEFLAG_OFFSET] != *f_entry[i].typeflag)
			error("%s\n%s%d\n%s%s\n%s\"%c\"\n%s\"%c\"\n",
					"Typeflag field incorrect.",
					"Entry ",
					i,
					"Filename ",
					f_entry[i].name,
					"Expected ",
					*f_entry[i].typeflag,
					"Actual ",
					hdr_ent[map_ent[i]][TYPEFLAG_OFFSET]);
	}
	return 0;
}
