#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
    
    setup(E_ACCESS);
    funct(E_ACCESS);

	assertion(19, BASE);
	start
		testing("When file referenced by path exists, then a call to");
		testing("access(path, F_OK) returns a value of zero.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "perms.d");
			Zstrcat(path, "/no_perms");

			expecting((int) 0);
			Zaccess(path, F_OK);
		finis
	finis

	assertion(20, BASE);
	start
		testing("Real user ID of calling processs matches owner of file,");
		testing("then the call to access() returns a value of zero.");
		testing("Read permission for owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "rd_owner");
			expecting(0);
			Zaccess(path, R_OK);
		finis

		testing("Write permission for owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "wr_owner");
			expecting(0);
			Zaccess(path, W_OK);
		finis

		testing("Execute permission for owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_owner");
			expecting(0);
			Zaccess(path, X_OK);
		finis
	finis

	assertion(21, BASE);
	start
		testing("Group ID of calling processs matches group owner of file,");
		testing("then the call to access() returns a value of zero.");
		testing("Read permission for group owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "rd_group");
			expecting(0);
			Zaccess(path, R_OK);
		finis

		testing("Write permission for group owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "wr_group");
			expecting(0);
			Zaccess(path, W_OK);
		finis

		testing("Execute permission for group owner only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_group");
			expecting(0);
			Zaccess(path, X_OK);
		finis
	finis

	assertion(22, BASE);
	start
		testing("Real user ID nor group ID of calling processs does not");
		testing("match the owner of the file referenced by path nor the");
		testing("real group ID or supplementary group IDs and permission");
		testing("is granted for others, then a call to access() returns a");
		testing("value of zero.");
		testing("Read permission for others only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "rd_other");
			expecting(0);
			Zaccess(path, R_OK);
		finis

		testing("Write permission for others only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "wr_other");
			expecting(0);
			Zaccess(path, W_OK);
		finis

		testing("Execute permission for others only.");
		start
			sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_other");
			expecting(0);
			Zaccess(path, X_OK);
		finis
	finis

	assertion(25, BASE);
	start
		prep("Create a file for testing.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "t_or");
			Zclose(Zcreat(path, PROT_ALL));
		finis

		testing("Check that independent access() calls of R_OK, W_OK and");
		testing("X_OK are all successful.");
		start
			Zaccess(path, R_OK);
			Zaccess(path, W_OK);
			Zaccess(path, X_OK);
		finis

		testing("Call to access() for amode of R_OK | W_OK,");
		testing("R_OK | X_OK, and W_OK | X_OK.");
		start
			expecting(0);
			Zaccess(path, R_OK | W_OK);

			expecting(0);
			Zaccess(path, R_OK | X_OK);

			expecting(0);
			Zaccess(path, W_OK | X_OK);
		finis
	finis

    done();
}
