#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has the S_ISUID mode set to ROOT. */

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	
	setup(E_ACCESS);
	funct(E_ACCESS);

	assertion(23, BASE);
	start
		if(APP_ACCESS) {
								/* The access() element functions based
									based on the real user ID and the real
									group ID.
								*/
			prep("Set real user ID to user ID providing appropriate privilege");
			prep("access override.");
			start
				uid_t	e_uid;
	
				e_uid = geteuid();
				Zsetuid(e_uid);
			finis

			prep("Initialize path to data file with no permissions.");
			start
				sprintf(path, "%s%s/%s", data_path(), "perms.d", "no_perms");
			finis

			testing("Process containing appropriate privilge access override");
			testing("will always succeed for modes of F_OK, R_OK, and W_OK.");
			start
				Zaccess(path, F_OK);
				Zaccess(path, R_OK);
				Zaccess(path, W_OK);
			finis
		}
		else
			not_implemented("appropriate privilege access override");
	finis

	assertion(24, BASE);
	start
		if(APP_ACCESS) {
			testing("Process containing appropriate privilege access");
			testing("override, an execute bit is set, and access mode is set");
			testing("to X_OK will always succeed.");
			start
				sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_owner");
				Zaccess(path, X_OK);
				sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_group");
				Zaccess(path, X_OK);
				sprintf(path, "%s%s/%s", data_path(), "perms.d", "ex_other");
				Zaccess(path, X_OK);
			finis

			testing("Process containing appropriate privilege access");
			testing("override, file is a directory, and access mode is set");
			testing("to X_OK will always succeed.");
			start
				sprintf(path, "%s%s/%s", data_path(), "perms.d", "no_perm.d");
				Zaccess(path, X_OK);
			finis
		}
		else
			not_implemented("appropriate privilege access override");
	finis

	done();
}
