#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module is set user-ID to ROOT */

#define	FILENAME	"5.2.1_acc"
#define	DIRNAME		"/5.2.1_acc.d"


int main(void)
{
	pid_t	pid;
	char	path[_POSIX_PATH_MAX +1];
	char	path1[_POSIX_PATH_MAX +1];

	setup(E_CHDIR);
	funct(E_CHDIR);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path1, temp_path());
			Zstrcat(path1, FILENAME);
			Zstrcpy(path, path1);
			Zstrcat(path, DIRNAME);
		finis

		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to a directory such that search access");
			prep("exists on path prefix and on directory.");
			start
				Zmkdir(path1, PROT_ALL);
				Zmkdir(path, S_IXUSR);		/* Search access on directory */
				Zchmod(path1, S_IXUSR);		/* Search access on path prefix */
			finis
				
			testing("For owner of file, chdir() is successful.");
			start
				expecting(SUCCESS);
				Zchdir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for group owner only and search");
			prep("access exists on directory for group owner only.");
			start
				Zchown(path1, BIN_UID, GID);
				Zchown(path, BIN_UID, GID);
				Zchmod(path1, S_IXGRP);		/* Search access on path prefix */
				Zchmod(path, S_IXGRP);		/* Search access on directory */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, chdir() is successful.");
			start
				expecting(SUCCESS);
				Zchdir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory and its path prefix.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for others only and search access");
			prep("exists on directory for others only.");
			start
				Zchown(path1, BIN_UID, BIN_GID);
				Zchown(path, BIN_UID, BIN_GID);
				Zchmod(path1, S_IXOTH);		/* Search access on path prefix */
				Zchmod(path, S_IXOTH);		/* Search access on directory */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, chdir() is successful.");
			start
				expecting(SUCCESS);
				Zchdir(path);
			finis
		KROF

		cleanup("Remove test directories.");
		start
			rmdir(path);
			rmdir(path1);
		finis
	finis
	
	done();
}
