#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module is set user ID to ROOT. */

#define	DIRNAME		"5.3.4_23.d"
#define	DIRNAME_NEW	"5.3.4_23.dir"


int main(void)
{
	struct	stat st_bf1, st_bf2;
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_LINK);
	funct(E_LINK);

	assertion(23, BASE);
	start
		prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_LINK].e_name);
		prep("Create known directory entries and files in working directory.");
		start
			exit_on(ERROR);
			Zstrcpy(path_cwd, temp_path());
			path_cwd[strlen(path_cwd) -1] = '\000'; /* delete trailing '/' */
			Zchdir(path_cwd);
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);

			Zmkdir(DIRNAME, PROT_ALL);

										/*
												   Working_Directory
											              |
											              |
										               DIRNAME
										*/
		finis

		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			testing("Filename argument points to the string \"F1/\" and");
			testing("F1 is a directory.");
			start
				Zstat(DIRNAME, &st_bf1);

				sprintf(path_ref, "%s/", DIRNAME_NEW);
				Zlink(DIRNAME, path_ref);
				Zstat(DIRNAME_NEW, &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) 
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
				Zunlink(path_ref);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	assertion(24, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			testing("Filename argument points to the string \"F1//\" and");
			testing("F1 is a directory.");
			start
				Zstat(DIRNAME, &st_bf1);

				sprintf(path_ref, "%s//", DIRNAME_NEW);
				Zlink(DIRNAME, path_ref);
				Zstat(DIRNAME_NEW, &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) 
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
				Zunlink(path_ref);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");

		cleanup("Remove directory created.");
		start
			Zrmdir(DIRNAME);
		finis
	finis

	done();
}
