#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	*pathm;
	pid_t	pid;
	time_t	s_time;

	setup(E_MKFIFO);
	funct(E_MKFIFO);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(33, BASE);
		start
			not_implemented("read-only file systems");
		finis

		done();
	}

	assertion(33, BASE);
	start
		pathm = fs_mount(MOUNT_RO, ROFS_DIR);

		abstract("Ensure mounted file system gets mounted.");
		start
			break_on(ERROR);
			prep("Establish path to implementation provided ROFS_TESTFILE");
			prep("and obtain a starting time.");
			start
				Zstrcpy(path, pathm);
				Zstrcat(path, "/mkfifo.d" );

				Ztime(&s_time);			/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);		/* Delay a fixed interval.			*/
			finis
	
			testing("Call to mkfifo(), by process with appropriate");
			testing("privileges, to make a FIFO on a read-only file system.");
			testing("mkfifo(%s)", path);
			start
				expecting(-1);
				expecting(EROFS);
				Zmkfifo(path, PROT_ALL);
			finis

			testing("No FIFO is created.");
			start
				expecting(ENOENT);
				Zaccess(path, F_OK);
			finis
	
			FORK
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis
	
				testing("Call to mkfifo(), by process without appropriate");
				testing("privileges, to make a FIFO on read-only file system.");
				testing("mkfifo(%s)", path);
				start
					expecting(EROFS);
					Zmkfifo(path, PROT_ALL);
				finis

				testing("No FIFO is created.");
				start
					expecting(ENOENT);
					Zaccess(path, F_OK);
				finis

				testing("Time related elements \"st_atime\", \"st_ctime\" and");
				testing("\"st_mtime\" of the parent directory are not changed");
				start
					trf_ck(CHK_ATIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_CTIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_MTIME, FALSE, s_time, NO_FILDES, pathm);
				finis
			KROF
		finis
	
		fs_umount(ROFS_DIR);
	
	finis

	done();
}
