#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	DIRNAME		"5.7.1a_pth.d"
#define	FILENAME	"5.7.1a_pth"

static char	*file_names[] = {
							"ABCDEFGHIJLKM",
							"NOPQRSTUVWXYZ",
							"abcdefghijlkm",
							"nopqrstuvwxyz",
							"0123456789._-"
						   };


static	int	err_ass;
int	ck_ul(char *);

int main(void)
{
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_PATHCONF);
	funct(E_PATHCONF);

	assertion(4, EXTENDED);
	assertion(5, EXTENDED);
	assertion(6, EXTENDED);
	assertion(7, EXTENDED);
	assertion(8, EXTENDED);
	assertion(9, EXTENDED);
	assertion(10, EXTENDED);
	assertion(11, EXTENDED);
	assertion(12, EXTENDED);
	assertion(13, EXTENDED);
	assertion(14, EXTENDED);

	assertion(16, BASE);
	start
		int	i;

		prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_PATHCONF].e_name);
		prep("Create directory DIRNAME in working directory.");
		start
			exit_on(ERROR);
			Zstrcpy(path_cwd, temp_path());
			path_cwd[strlen(path_cwd) -1] = '\000'; /* delete trailing '/' */
			Zchdir(path_cwd);

			Zmkdir(DIRNAME, S_IRWXU);
		finis

		for(i=0; i<5; i++) {
			testing("Filename of \"%s\" is supported and", file_names[i]);
			testing("the unique identity of upper and lower case");
			testing("letters are retained.");
			start
				sprintf(path_ref, "%s/%s", DIRNAME, file_names[i]);
				Zmkdir(path_ref, PROT_ALL);
				ck_ul(file_names[i]);

				Zpathconf(path_ref, _PC_PATH_MAX);

				Zrmdir(path_ref);
			finis
		}
	finis

	assertion(17, EXTENDED_TESTED);
	start
		testing("Filename retains the unique identity of its upper and lower");
		testing("case letters.");
		start
			if(err_ass)
				error("See previous assertion for specifics of failure.");
		finis
	finis

	if(pathconf(DIRNAME, _PC_NO_TRUNC) == (long) -1) {
		assertion(15, BASE);
		start
			testing("Dirname component is a string of more than {NAME_MAX}");
			testing("bytes in a directory for which {_POSIX_NO_TRUNC} is not");
			testing("supported.");
			start
				error("{_POSIX_NO_TRUNC} not supported.");
			finis
		finis
	}
	else
		assertion(15, NOT_APPLICABLE);

	done();
}


		/*	For the Filename tests, check that the upper and lower case
			letters are preserved.  Read the directory and match with 
			the expected names.  This procedure is not performed for
			each element, but each element is covered, if all the filename
			tests are successful.
		*/

int	ck_ul(char *f_name)
{
	DIR		*dirp;
	struct	dirent *dirent;
	int	i;
	
	dirp = Zopendir(DIRNAME);
	dirent = Zreaddir(dirp);
	for(i=0; i<2; i++) {	/* Skip dot and dot-dot entries if they exist */
		if( ! ((dirent->d_name)[0] == '.') )
			break;
		dirent = Zreaddir(dirp);
	}
											/* Compare only filename */
	if(strcmp(dirent->d_name, f_name)) {
		error("%s\n%s\"%s\"\n%s\"%s\"\n",
			"Filename entry obtained not what was expected.",
			"Expected:	",
			f_name,
			"Actual:	",
			dirent->d_name);
		err_ass++;
	}
	Zclosedir(dirp);
}
