#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has S_ISUID set to ROOT */

#define	FILENAME		"5.5.3_acc"
#define	FILENAME_NEW	"5.5.3_acc_n"
#define	DIRNAME			"5.5.3_acc.d"

int main(void)
{
	pid_t	pid;
	char	path_old[_POSIX_PATH_MAX +1], path_new[_POSIX_PATH_MAX +1];
	char	path_dir[_POSIX_PATH_MAX +1];

	setup(E_RENAME);
	funct(E_RENAME);

	assertion(32, BASE);
	start
		prep("Establish test files and paths.");
		start
			sprintf(path_dir, "%s%s", temp_path(), DIRNAME);
			sprintf(path_old, "%s%s/%s", temp_path(), DIRNAME, FILENAME);
			sprintf(path_new, "%s%s/%s", temp_path(), DIRNAME, FILENAME_NEW);
			Zmkdir(path_dir, PROT_ALL);
			Zclose(Zcreat(path_old, PROT_ALL));
		finis

		FORK
			prep("For user only, set search access on path prefix");
			prep("for both old and new and write permission on path");
			prep("prefix for new.");
			start
				Zchown(path_dir, UID, GID);
				Zchmod(path_dir, S_IXUSR | S_IWUSR);
				Zsetuid(getuid());
			finis
				
			testing("For owner of file, rename() is successful.");
			start
				expecting(SUCCESS);
				Zrename(path_old, path_new);
												/* Reset */
				Zrename(path_new, path_old);
			finis
		KROF

		FORK
			prep("For group owner only, set search access on path prefix");
			prep("for both old and new and write permission on path");
			prep("prefix for new.  Change owner of file.");
			start
				Zchown(path_dir, BIN_UID, GID);
				Zchmod(path_dir, S_IXGRP | S_IWGRP);

				Zsetuid(getuid());
			finis

			testing("For group owner of file, rename() is successful.");
			start
				expecting(SUCCESS);
				Zrename(path_old, path_new);
												/* Reset */
				Zrename(path_new, path_old);
			finis
		KROF

		FORK
			prep("For others only, set search access on path prefix");
			prep("for old and new existing and write permission on path");
			prep("prefix for new.  Change owner of file.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
				Zchmod(path_dir, S_IXOTH | S_IWOTH);

				Zsetuid(getuid());
			finis
				
			testing("For others, rename() is successful.");
			start
				expecting(SUCCESS);
				Zrename(path_old, path_new);
			finis
		KROF

		cleanup("Remove test files.");
		start
			Zunlink(path_new);
			Zrmdir(path_dir);
		finis
	finis

	done();
}
