#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module has S_ISUID set to ROOT. */

#define	FILENAME	"5.5.2_acc"
#define	DIRNAME		"5.5.2_acc.d"

int main(void)
{
	pid_t	pid;
	char	path[_POSIX_PATH_MAX +1], path_dir[_POSIX_PATH_MAX +1];

	setup(E_RMDIR);
	funct(E_RMDIR);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path_dir, temp_path());
			Zstrcat(path_dir, DIRNAME);
			Zstrcpy(path, path_dir);
			Zstrcat(path, "/");
			Zstrcat(path, FILENAME);
		finis

		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish permissions such that write access exists to the");
			prep("parent directory of path and search access exists to the");
			prep("path prefix of path.");
			start
				Zmkdir(path_dir, PROT_ALL);
				Zchmod(path_dir, S_IWUSR | S_IXUSR);
				Zmkdir(path, PROT_ALL);
			finis
				
			testing("For owner of file, rmdir() is successful.");
			start
				expecting(SUCCESS);
				Zrmdir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory.");
			prep("Change mode of test directory such that write and search");
			prep("access exists on path prefix for group owner only.");
			start
				Zchown(path_dir, BIN_UID, GID);
				Zchmod(path_dir, S_IWGRP | S_IXGRP);
			finis
				
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
				Zmkdir(path, PROT_ALL);
			finis
				
			testing("For group owner of file, rmdir() is successful.");
			start
				expecting(SUCCESS);
				Zrmdir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory and its path prefix.");
			prep("Change mode of test directory such that write and search");
			prep("access exists on path prefix for others only.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
				Zchmod(path_dir, S_IWOTH | S_IXOTH);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
				Zmkdir(path, PROT_ALL);
			finis
				
			testing("For others, rmdir() is successful.");
			start
				expecting(SUCCESS);
				Zrmdir(path);
			finis
		KROF

		cleanup("Remove test directory.");
		start
			Zrmdir(path_dir);
		finis
	finis

	done();
}
