#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define 	TMP_FILE	"dup2.tmp"
#define 	TMP_FILE2	"dup2.tmp2"

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int 	fd, fd2;
	struct	stat st_buf;

	setup(E_DUP2);
	funct(E_DUP2);

	assertion(6, BASE);
	start
		break_on(ERROR);
		prep("Prepare for test.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, TMP_FILE);
			fd = Zopen(path, O_RDWR | O_CREAT | O_APPEND, PROT_ALL);

			Zstrcpy(path, temp_path());
			Zstrcat(path, TMP_FILE2);
			fd2 = Zopen(path, O_RDWR | O_CREAT | O_APPEND, PROT_ALL);

			Zclose(fd);
		finis

		testing("Call to dup2(fildes, fildes2) returns -1 and sets errno");
		testing("to [EBADF] for invalid file descriptor \"fildes\".");
		start
			expecting(-1);
			expecting(EBADF);
			Zdup2(fd, fd2);
		finis

		testing("File descriptor \"fildes2\" not closed.");
		start
			Zfstat(fd2, &st_buf);
		finis
	finis

	assertion(7, BASE);
	start
		testing("Call to dup2(fildes, -1) returns -1 and sets errno");
		testing("to [EBADF].");
		start
			expecting(-1);
			expecting(EBADF);
			Zdup2(fd2, -1);
		finis
	finis

	assertion(8, BASE);
	start
		int	open_max;

		errno = 0;				/* If value not defined, errno unchanged. */
		open_max = (int)sysconf(_SC_OPEN_MAX);

		if(open_max != -1) {
			testing("When fildes2 >= {OPEN_MAX}, then a call to dup2()");
			testing("returns -1 and sets errno to [EBADF].");
			start
				expecting(-1);
				expecting(EBADF);
				Zdup2(STDOUT_FILENO, open_max);

				expecting(-1);
				expecting(EBADF);
				Zdup2(STDOUT_FILENO, open_max +1);
			finis
		}
		else {
			if(errno == 0) {
				testing("When fildes2 = {PCTS_OPEN_MAX}, then a call to");
				testing("dup2() does not give an [EBADF] error.");
				start
					expecting(SUCCESS);
					Zdup2(STDOUT_FILENO, PCTS_OPEN_MAX);
				finis
			}
			else
				error("%s\n%s[%s]",
					"Implementation is not specifying a value for {OPEN_MAX}.",
					"A call to sysconf(_SC_OPEN_MAX) returns -1 with errno of ",
					err_lookup(errno));

		}
	finis

	assertion(9, EXTENDED);

	done();
}
