#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"6.5.2_05"
#define	FILENAME_x	"./6.5.2_06x"


int main(void)
{
	int 	fd1;
	pid_t	pid;
	char	a_ino[25], a_dev[25];
	char	a_fd1[10], a_num[10];
	struct stat	st_buf;

	setup(E_FCNTL);
	funct(E_FCNTL);

	assertion(5, BASE);
	start
		exit_on(ERROR);
		prep("Create a test file.");
		start
			fd1 = temp_open(FILENAME, O_WRONLY | O_CREAT | O_TRUNC, PROT_ALL);
		finis

		testing("Call to fcntl(fildes, F_GETFD) returns the status of the");
		testing("file descriptor flag FD_CLOEXEC.");
		start
			Zfcntl(fd1, F_SETFD, 0);			/* Clear the FD_CLOEXEC bit. */
			if((Zfcntl(fd1, F_GETFD, 0) & FD_CLOEXEC) != 0)
				error("FD_CLOEXEC flag set!");

			Zfcntl(fd1, F_SETFD, FD_CLOEXEC);	/* Set the FD_CLOEXEC bit. */
			if((Zfcntl(fd1, F_GETFD, 0) & FD_CLOEXEC) != FD_CLOEXEC)
				error("FD_CLOEXEC flag is not set.");
		finis
	finis

	assertion(6, BASE);
	start
		break_on(ERROR);

		FORK
			prep("Set the FD_CLOEXEC bit, then execute a module.");
			start
				Zfcntl(fd1, F_SETFD, FD_CLOEXEC);
										/*	Ensure file associated with file
											descriptor is tested.
										*/ 
				Zfstat(fd1, &st_buf);
				sprintf(a_ino, "%ul", (unsigned long)st_buf.st_ino);
				sprintf(a_dev, "%ul", (unsigned long)st_buf.st_dev);
				sprintf(a_num, "%d", ass_nu);
				sprintf(a_fd1, "%d", fd1);
				Zexecl(FILENAME_x, FILENAME_x, a_num, "CLOSED", a_fd1,
													a_dev, a_ino, (char *) 0);
				error("%s failed to exec.", FILENAME_x);
			finis
		KROF
	finis

	assertion(7, BASE);
	start
		FORK
			prep("Clear the FD_CLOEXEC bit, then execute a module.");
			start
				char	a_fd1[10], a_num[10];
				struct	stat st_buf;

				Zfcntl(fd1, F_SETFD, 0);
										/*	Ensure file associated with file
											descriptor is tested.
										*/ 
				Zfstat(fd1, &st_buf);
				sprintf(a_ino, "%ul", (unsigned long)st_buf.st_ino);
				sprintf(a_dev, "%ul", (unsigned long)st_buf.st_dev);
				sprintf(a_num, "%d", ass_nu);
				sprintf(a_fd1, "%d", fd1);
				Zexecl(FILENAME_x, FILENAME_x, a_num, "OPEN", a_fd1,
													a_dev, a_ino, (char *) 0);
				error("%s failed to exec.", FILENAME_x);
			finis
		KROF
	finis

	done();
}
