#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], *pathm;
	int 	fd;
	pid_t	pid;

	setup(E_WRITE);
	funct(E_WRITE);

		/*	A call to write() requesting more bytes be written than
			there is room for, writes only as many bytes as there is
			room for and then successfully returns.
		*/
	if(strlen(PCTS_FS) == 0) {
		assertion(11, EXTENDED);

		done();
	}

	assertion(11, EXTENDED_TESTED);
	start
		int	nbytes;
		off_t	free_space;
		struct	stat	statbuf;

		pathm = fs_mount(MOUNT_RW, ENOSPC_FILE);

		prep("Fork a child.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			exit_on(ERROR);
			prep("Run rest of test as normal user.");
			start
				Zsetuid(UID);
				Zstrcpy(path, pathm);
				Zstrcat(path, "/");
				Zstrcat(path, ENOSPC_TESTFILE);

				Zstat(path, &statbuf);
				free_space = statbuf.st_size;
			finis

			prep("Unlink the file to free up %ld bytes", free_space);
			prep("Recreate file on mounted file system");
			prep("Fill up the file system to within 10 bytes.");
			start
				Zunlink(path);
				fd = Zopen(path, O_RDWR|O_CREAT, PROT_ALL);
				for(free_space -= 10; free_space > 0; free_space -= nbytes) {
					nbytes = (free_space > _POSIX_PATH_MAX) ?
											_POSIX_PATH_MAX : free_space;
					if (write(fd, path, nbytes) == -1) {
						error("Error %s from write\n",
						err_lookup(errno));
						break;
					}
				}
			finis

			testing("A write() of more than 10 bytes returns a value of 10.");
			start
				continue_on(ERROR);
				errno = 0;
				nbytes = write(fd, path, (unsigned) _POSIX_PATH_MAX);
				if(nbytes != 10)
					error("%s\n%s\n%s%d.\n%s%s.\n",
						"The write() returned an unexpected count.",
						"Expected a count of 10.",
						"Actual return was ",
						nbytes,
						"Errno was ",
						err_lookup(errno) );
			finis

			done();
		}
		wait_for(pid, TIME_PCTS_FS_TESTING);

		cleanup("Dismount file system.");
		start
			fs_umount(ENOSPC_FILE);
		finis
	finis

	done();
}
