#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int main(void)
{
	int		pipfd[2];
	char	*buf_in, *buf_out;
	size_t	pipe_buf_sz, fifo_buf_sz, max_buf_sz, pipe_max, fifo_max;

	setup(E_WRITE);
	funct(E_WRITE);

	exit_on(ERROR);

							/*	When the write() is terminated due to receipt
								of a signal and no data was transferred, then
								write() returns [(ssize_t)-1] and sets errno
								to [EINTR].
							*/
	assertion(39, BASE);
	start
							/* Maximum bytes written in pipe and FIFO */
		max_buf_sz=g_max_pipe(&pipe_buf_sz, &fifo_buf_sz, &pipe_max, &fifo_max);

		prep("Allocate and initialize I/O buffers.");
		start
			buf_in = (char *) Zmalloc(max_buf_sz);
			buf_out = (char *) Zmalloc(max_buf_sz);
			memset(buf_in, 'Z', max_buf_sz);
		finis

		prep("Create a pipe and fill it up.");
		start
			size_t	n_bytes;
			size_t	nb_wr = 0;

			Zpipe(pipfd);
			SET_TIMEOUT
				for(n_bytes = pipe_buf_sz; n_bytes; n_bytes /= 2)
					while(pipe_max -nb_wr >= n_bytes) {
						expecting(n_bytes);
						nb_wr += Zwrite(pipfd[1], buf_out, n_bytes);
					}
			CLEAR_ALARM
		finis

		testing("When write() is terminated by a signal and no data was");
		testing("transferred, write() returns [(ssize_t)-1] and sets errno");
		testing("to [EINTR].");
		start
			SIGNAL(SIGALRM, sig_int);
			alarm(2);
			expecting(-1);
			expecting(EINTR);
			Zwrite(pipfd[1], buf_out, pipe_buf_sz/2);
			alarm(0);
		finis
	finis
	done();
}
