#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], *pathm;
	int 	fd;
	pid_t	pid;

	setup(E_WRITE);
	funct(E_WRITE);

		/*	Write() request that more bytes be written than there is
			room for writes only as many bytes as there is room
			for and then successfully return.
		*/
	if(strlen(PCTS_FS) == 0) {
		assertion(41, EXTENDED);

		done();
	}

	assertion(41, EXTENDED_TESTED);
	start

		prep("Mount file system and fill up file system.");
		start
			pathm = fs_mount(MOUNT_RW, ENOSPC_FILE);
		finis

		prep("Fork a child.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			exit_on(ERROR);
			prep("Run rest of test as normal user.");
			prep("Open file on mounted file system.");
			start
				Zsetuid(UID);
				Zstrcpy(path, pathm);
				Zstrcat(path, "/");
				Zstrcat(path, ENOSPC_TESTFILE);
				fd = Zopen(path, O_WRONLY | O_APPEND, PROT_ALL);
			finis

			testing("Try writing after file system is full.");
			start
				expecting(ENOSPC);
				Zwrite(fd, path, (unsigned) _POSIX_PATH_MAX);
			finis

			cleanup("Close file descriptor.");
			start
				Zclose(fd);
			finis

			done();
		}
		wait_for(pid, TIME_PCTS_FS_TESTING);

		cleanup("Dismount file system.");
		start
			fs_umount(ENOSPC_FILE);
		finis
	finis

	done();
}
