#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define		CORE		"./core"
#define		FILE_EXISTS	0

static	int	shup_cnt;
void	sig_hup(int isig)
{
	shup_cnt++;
}


int	main(void)
{
	pid_t	pid;
	struct	sigaction	act1;
	int		i;
	sigset_t	set;

	setup(E_ABORT);
	funct(E_ABORT);

	assertion(14, BASE);
	start
		ENABLE_PSYNC

		for(i=0; i<3; i++) {
			prep("Fork a process to test with.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Establish a new process group, then fork a child");
				prep("process.");
				start
					Zsetpgid((pid_t)0, (pid_t)0);
					sv_flush();
					pid = Zfork();
				finis

	
				if(pid == (pid_t)0) {		/* child process */
					prep("Have child process catch SIGHUP and SIGCONT.");
					start
						SIGNAL(SIGCONT, sig_int);
						Zsigemptyset(&act1.sa_mask);
						act1.sa_handler = sig_hup;
						act1.sa_flags = 0;
						Zsigaction(SIGHUP, &act1, (struct sigaction *)0);
					finis
	
					prep("Fork a grandchild process.");
					start
						sv_flush();
						pid = Zfork();
					finis
	
					if(pid == (pid_t)0) {	/* grandchild */
						prep("Have grandchild send SIGSTOP signal");
						prep("to itself.");
						start
							SEND_PSYNC
							sv_flush();
							Zkill(getpid(), SIGSTOP);
						finis
	
						testing("SIGABRT signal is %s.",
								(i==0) ? "being ignored" :
								(i==1) ? "being blocked" :
								"caught and returns");
						testing("SIGHUP and SIGCONT received by stopped");
						testing("grandchild when orphaned.");
						start
							if( ! shup_cnt)
								error("SIGHUP not received by grandchild.");
							if( ! sig_rcvd)
								error("SIGCONT not received by grandchild.");
						finis
	
						done();
					}
	
					/* child process */
					prep("Child process sends SIGSTOP signal to itself.");
					start
						sv_flush();
						Zkill(getpid(), SIGSTOP);
					finis
	
					testing("SIGHUP and SIGCONT received by child process.");
					start
						if( ! shup_cnt)
							error("SIGHUP not received by child process.");
						if( ! sig_rcvd)
							error("SIGCONT not received by child process.");
					finis
	
					done();
				}
	
				prep("Parent process calls abort().");
				start
					if(i==0) {
						SIGNAL(SIGABRT, SIG_IGN);
					} else {
						if(i==1) {
							SIGBLOCK(set, SIGABRT);
												/* Ignore expected SIGABRT. */
							SIGNAL(SIGABRT, SIG_IGN);
						} else {
							SIGNAL(SIGABRT, sig_int);
						}
					}

					SET_ALARM(2 * WAIT_FOR_TIME)
						WAIT_PSYNC
					CLEAR_ALARM
					SLEEP(1);			/* Allow time to process SIGSTOP. */
				finis
	
				abort();
				error("Process continued after abort() was called.");
				done();
			}
			WAIT_FOR_PID(pid);			/* Setup orphaned process group. */
			SLEEP(3 * WAIT_FOR_TIME);
		}
		DISABLE_PSYNC

		cleanup("If SIGABRT caused a core dump file, remove it.");
		start
			if(access(CORE, F_OK) == FILE_EXISTS) {
				Zunlink(CORE);
			}
		finis
	finis
	
	done();
}
