#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME "8.1.19_04"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	buffer[_POSIX_PIPE_BUF];
	FILE	*sfd;

	setup(E_FSEEK);
	funct(E_FSEEK);

	assertion(4, BASE);
	start
		struct	stat st_buf;
		off_t	cur_size;

		prep("Create test file with data.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w+");
			Zfwrite(String, sizeof(char), Strlen, sfd);
			Zfflush(sfd);
			Zstat(path, &st_buf);
			cur_size = st_buf.st_size;
		finis

		testing("An fseek() beyond the end-of-file does no increase the");
		testing("size of the file.");
		start
			Zfseek(sfd, 10, SEEK_END);
			Zfclose(sfd);

			Zstat(path, &st_buf);
			if(st_buf.st_size != cur_size)
				error("File size changed from %lu to %lu.",
										(unsigned long) cur_size,
										(unsigned long) st_buf.st_size);

		finis
	finis

	assertion(5, BASE);
	start
		time_t	s_time;

		prep("Create a test file with data.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			setvbuf(sfd, buffer, _IOFBF, _POSIX_PIPE_BUF);
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
		finis

		testing("A call to fseek() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			Zfseek(sfd, 0L, SEEK_SET);
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
			Zfclose(sfd);
		finis
	finis


#define	SEEK_LOCATION	8
	assertion(6, BASE);
	start
		int	cur_loc;

		prep("Create a test file with data.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w+");
			setvbuf(sfd, buffer, _IOFBF, _POSIX_PIPE_BUF);
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
		finis

		prep("Perform an fflush(stream)");
		start
			Zfflush(sfd);
		finis

		testing("Call to fseek() adjusts the offset in the underlying open");
		testing("file description to reflect the location specified by the");
		testing("fseek() call.");
		start
			Zfseek(sfd, (long)SEEK_LOCATION, SEEK_SET);
			cur_loc = Zlseek(fileno(sfd), 0, SEEK_CUR);

			if(SEEK_LOCATION != (int)cur_loc)
				error("%s\n%s%d\n%s%d",
					"Call to fseek() did not adjust to the proper location.",
					"The offset returned by lseek() was ",
					cur_loc,
					"The offset expected was ",
					SEEK_LOCATION);
		finis
	finis

	done();
}
