#include	<pcts.h>

#include	<sv_env.h>
#include	"../ctime/c_locale.h"

int	main(void)
{
	time_t	timer;
	char	tz_env[100];				/* Contains TZ environment */
	int		hours, minutes, seconds;
					/*	jst_day, jend_day ->  Julian day of the year (1-365)
						st_day, jend_day  ->  Zero based day of the year (0-365)
					*/
	int		jst_day, jend_day, st_day, end_day;
	int		leap;

	setup(E_LOCALTIME);
	funct(E_LOCALTIME);

	assertion(9, BASE);
	start
		for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		  for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																jst_day++){
			jend_day=jst_day +2;

			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std,J%3.3d,J%3.3d", jst_day, jend_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 1, 59, 59);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jstart_day time.",(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 00);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 01);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
													1 +UCT_DST_COR, 59, 59);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
													2 +UCT_DST_COR, 00, 00);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
													2 +UCT_DST_COR, 00, 01);
				UTC_TIME_TM
				LOC_TIME(0)
			finis
		  }
		}
	finis


	assertion(10, BASE);
	start
	  for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																	jst_day++){
		  jend_day = jst_day +2;

	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std-%2.2d,J%3.3d,J%3.3d", hours,
															jst_day, jend_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 1, 59, 59);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jstart_day time.",(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 00);
				UTC_TIME_TM
				LOC_TIME(hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 01);
				UTC_TIME_TM
				LOC_TIME(hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
												1 +UCT_DST_COR_HRS, 59, 59);
				UTC_TIME_TM
				LOC_TIME(hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
												2 +UCT_DST_COR_HRS, 00, 00);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
												2 +UCT_DST_COR_HRS, 00, 01);
				UTC_TIME_TM
				LOC_TIME(0)
			finis
		  }
		}
	  }
	finis


	assertion(11, BASE);
	start
	  int	hours_end;

	  hours_end = minutes = seconds = 10;

	  for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																	jst_day++){
		  jend_day = jst_day +1;

	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env,
						"TZ=dst0std,J%3.3d/%2.2d,J%3.3d/%2.2d:%2.2d:%2.2d",
						jst_day, hours, jend_day, hours_end, minutes, seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, (hours==0)?STday-1:STday,
											(hours==0)?23:hours-1, 59, 59);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jstart_day time.",(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, hours, 00, 00);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, STday, hours, 00, 01);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end +UCT_DST_COR, minutes, seconds -1);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end +UCT_DST_COR, minutes, seconds);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end +UCT_DST_COR, minutes, seconds +1);
				UTC_TIME_TM
				LOC_TIME(0)
			finis
		  }
		}
	  }
	finis


	assertion(12, BASE);			/* Similar to assertion #9. */
	start
		for(leap=0; leap<2; leap++) {
						/* Test for start_day before and after Feb 28th. */
		  for(st_day=LEAP_DAY_MINUS+leap; st_day<LEAP_DAY_PLUS+leap; st_day++){
			end_day = st_day +2;

			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std,%3.3d,%3.3d", st_day, end_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, 1, 59, 59);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at start_day time.",(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, 2, 00, 00);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, 2, 00, 01);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
												1 +UCT_DST_COR, 59, 59);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at end_day time.", (leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
												2 +UCT_DST_COR, 00, 00);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
												2 +UCT_DST_COR, 00, 01);
				UTC_TIME_TM
				LOC_TIME(0)
			finis
		  }
		}
	finis


	assertion(13, BASE);			/* Similar to assertion #11. */
	start
	  int	hours_end;

	  hours_end = minutes = seconds = 10;

	  for(leap=0; leap<2; leap++) {
		for(st_day=LEAP_DAY_MINUS+leap; st_day<LEAP_DAY_PLUS+leap; st_day++){
		  end_day = st_day +2;
	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env,
						"TZ=dst0std,%3.3d/%2.2d,%3.3d/%2.2d:%2.2d:%2.2d",
						st_day, hours, end_day, hours_end, minutes, seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, hours -1, 59, 59);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at start_day time.",(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, hours, 00, 00);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, st_day, hours, 00, 01);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end +UCT_DST_COR, minutes, seconds -1);
				UTC_TIME_TM
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at end_day time.", (leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end +UCT_DST_COR, minutes, seconds);
				UTC_TIME_TM
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end +UCT_DST_COR, minutes, seconds +1);
				UTC_TIME_TM
				LOC_TIME(0)
			finis
		  }
		}
	  }
	finis

	done();
}
