#include	<pcts.h>

#include	<locale.h>
#include	<sv_env.h>

void	v_c_env(void);


int main(void)
{
	setup(E_SETLOCALE);
	funct(E_SETLOCALE);

	assertion(6, BASE);
	start
		testing("When no call has been made to setlocale() by the");
		testing("application, then the \"C\" locale is the locale associated");
		testing("with the process.");
		start
			char	*cur_locale, hold_locale[100];;

			cur_locale = setlocale(LC_ALL, "C");		/* Get prior locale. */
			strcpy(hold_locale, cur_locale);
			cur_locale = setlocale(LC_ALL, NULL);		/* Get curent locale. */

			if(strcmp(cur_locale, hold_locale))
				error("Expected: \"%s\"\nActual: \"%s\"",
						cur_locale,
						hold_locale);
		finis
	finis

	assertion(4, BASE);
	start
		testing("When locale is a pointer to the string \"C\", then a call");
		testing("to setlocale() sets the locale for the specified category");
		testing("to the minimal environment for C-language translation.");
		start
			setlocale(LC_ALL, "C");
			v_c_env();
		finis
	finis

	assertion(5, BASE);
	start
		testing("When locale is a pointer to the string \"POSIX\", then a");
		testing("call to setlocale() sets the locale for the specified");
		testing("category to an environment that includes the minimal");
		testing("environment for C-language translation.");
		start
			setlocale(LC_ALL, "POSIX");
			v_c_env();
		finis
	finis

	done();
}

void v_c_env()
{
	struct	lconv *l_conv;

	if((l_conv = localeconv()) == NULL)
		error("NULL pointer returned by localeconv().");

	if(strcmp(l_conv->decimal_point, "."))
		error("Element lconv.decimal_point is \"%s\" expected \".\".",
												l_conv->decimal_point);
	if(*(l_conv->thousands_sep) != '\000')
		error("Element lconv.thousands_sep is \"%s\" expected \"\".",
													l_conv->thousands_sep);
	if(*(l_conv->grouping) != '\000')
	if(!strcmp(l_conv->grouping, ""))
		error("Element lconv.grouping is \"%s\" expected \"\".",
													l_conv->grouping);
	if(*(l_conv->int_curr_symbol) != '\000')
		error("Element lconv.int_curr_symbol is \"%s\" expected \"\".",
													l_conv->int_curr_symbol);
	if(*(l_conv->currency_symbol) != '\000')
		error("Element lconv.currency_symbol is \"%s\" expected \"\".",
													l_conv->currency_symbol);
	if(*(l_conv->mon_decimal_point) != '\000')
		error("Element lconv.mon_decimal_point is \"%s\" expected \"\".",
													l_conv->mon_decimal_point);
	if(*(l_conv->mon_thousands_sep) != '\000')
		error("Element lconv.mon_thousands_sep is \"%s\" expected \"\".",
													l_conv->mon_thousands_sep);
	if(*(l_conv->mon_grouping) != '\000')
		error("Element lconv.mon_grouping is \"%s\" expected \"\".",
													l_conv->mon_grouping);
	if(*(l_conv->positive_sign) != '\000')
		error("Element lconv.positive_sign is \"%s\" expected \"\".",
													l_conv->positive_sign);
	if(*(l_conv->negative_sign) != '\000')
		error("Element lconv.negative_sign is \"%s\" expected \"\".",
													l_conv->negative_sign);
	if(l_conv->int_frac_digits != CHAR_MAX)
		error("Element lconv.int_frac_digits is \"%d\" expected \"%d\".",
										(int)l_conv->int_frac_digits, CHAR_MAX);
	if(l_conv->frac_digits != CHAR_MAX)
		error("Element lconv.frac_digits is \"%d\" expected \"%d\".",
										(int)l_conv->frac_digits, CHAR_MAX);
	if(l_conv->p_cs_precedes != CHAR_MAX)
		error("Element lconv.p_cs_precedes is \"%d\" expected \"%d\".",
										(int)l_conv->p_cs_precedes, CHAR_MAX);
	if(l_conv->p_sep_by_space != CHAR_MAX)
		error("Element lconv.p_sep_by_space is \"%d\" expected \"%d\".",
										(int)l_conv->p_sep_by_space, CHAR_MAX);
	if(l_conv->n_cs_precedes != CHAR_MAX)
		error("Element lconv.n_cs_precedes is \"%d\" expected \"%d\".",
										(int)l_conv->n_cs_precedes, CHAR_MAX);
	if(l_conv->n_sep_by_space != CHAR_MAX)
		error("Element lconv.n_sep_by_space is \"%d\" expected \"%d\".",
										(int)l_conv->n_sep_by_space, CHAR_MAX);
	if(l_conv->p_sign_posn != CHAR_MAX)
		error("Element lconv.p_sign_posn is \"%d\" expected \"%d\".",
										(int)l_conv->p_sign_posn, CHAR_MAX);
	if(l_conv->n_sign_posn != CHAR_MAX)
		error("Element lconv.n_sign_posn is \"%d\" expected \"%d\".",
										(int)l_conv->n_sign_posn, CHAR_MAX);
}
