#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME	"8.1.30_05"


static	struct	stat st_buf;
void	trf_cks(time_t);
static	int vfprtargs(char *, ...);
static	int	ret_val;
static	FILE	*sfd;


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	pid_t	pid;
	time_t	s_time;

	setup(E_VFPRINTF);
	funct(E_VFPRINTF);

								/*	This assertion test contains code similar
									to that of fputc(). */
	assertion(5, BASE);
	start
		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
		finis

		testing("A call to vfprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		testing("Call to vfprintf() used in conjunction with fflush().");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			vfprtargs("%s %s\n", "Do", "it!");
			Zfflush(sfd);
			Zstat(path, &st_buf);
			trf_cks(s_time);
		finis

		testing("A call to vfprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		testing("Call to vfprintf() used in conjunction with fclose().");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			vfprtargs("%s %s\n", "Do", "it!");
			Zfclose(sfd);
			Zstat(path, &st_buf);
			trf_cks(s_time);
		finis

		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
		finis
	
		FORK
			prep("Call to vfprintf() used in conjunction with exit().");
			start
				vfprtargs("%s %s\n", "Do", "it!");
			finis
			done_e();					/* done_e() calls exit(). */
		KROF

		testing("A call to vfprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		start
			Zstat(path, &st_buf);
			trf_cks(s_time);
		finis
	
		prep("Establish minimum reference time.");
		prep("Catch SIGABRT signal.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			SIGNAL(SIGABRT, sig_int);
		finis
	
		FORK
			prep("Call to vfprintf() used in conjunction with abort().");
			start
				vfprtargs("%s %s\n", "Do", "it!");
			finis
			abort();
		KROF

		testing("A call to vfprintf() marks for update the \"st_ctime\" and");
		testing("\"st_mtime\" time-related fields of the underlying file");
		testing("when data is caused to be written.");
		start
			Zstat(path, &st_buf);
			trf_cks(s_time);
		finis
	finis

	done();
}


void trf_cks(time_t s_time)
{
	time_t	cur_time;
	char	s1[26]; /* Avoid calling ctime() twice in single function call. */

	dt_secs(TRF_DELAY);
	Ztime(&cur_time);

	strcpy(s1, ctime(&st_buf.st_mtime) +4);
	if(st_buf.st_mtime <= s_time)
		error("%s\n%s%20.20s.\n%s%20.20s.\n",
				"Time-related field \"st_mtime\" in error?.",
				"Expected minimum time is ",
				ctime(&s_time) +4,
				"Actual time recorded is ",
				s1);

	if(st_buf.st_mtime > cur_time)
		error("%s\n%s%20.20s.\n%s%20.20s.\n",
				"Time-related field \"st_mtime\" larger than current time.",
				"Current time is ",
				ctime(&cur_time) +4,
				"Time-related field \"st_mtime\" is ",
				s1);

	strcpy(s1, ctime(&st_buf.st_ctime) +4);
	if(st_buf.st_ctime <= s_time)
		error("%s\n%s%20.20s.\n%s%20.20s.\n",
				"Time-related field \"st_ctime\" in error?.",
				"Expected minimum time is ",
				ctime(&s_time) +4,
				"Actual time recorded is ",
				s1);

	if(st_buf.st_ctime > cur_time)
		error("%s\n%s%20.20s.\n%s%20.20s.\n",
				"Time-related field \"st_ctime\" larger than current time.",
				"Current time is ",
				ctime(&cur_time) +4,
				"Time-related field \"st_ctime\" is ",
				s1);
}


static	int vfprtargs(char *format, ...)
{
	va_list	ap;
	va_start(ap, format);

	errno = 0;
	ret_val = vfprintf(sfd, format, ap);
	if(ret_val < 0)
		error("%s\n%s%s\n",
				"Expected call to vfprintf() to be successful.",
				"Actually vfprintf() failed with errno set to ",
				err_lookup(errno));
	va_end(ap);
}
