#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<termios.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

char String[]	= "ctermid() check\n";
#define Strlen	(sizeof(String)-1)

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char 	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;
	int		tty_ctid;

	setup(E_CTERMID);
	funct(E_CTERMID);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(4, BASE)
		GTI_NOT_PROVIDED_RESULT(5, BASE)
		done();
	}

				/*	ctermid() generates a string that when used as a pathname
					refers to the controlling terminal for the current process.
				*/
	assertion(4, BASE);
	start
		char	path_ctid[L_ctermid];

		FORK
			prep("Acquire a controlling terminal and setup TTY lines.");
			start
				termios_prep(&tty_fildes, tty_termios_p,
									&loop_fildes, loop_termios_p);
										/* Enable SIGNALS */
				loop_termios_p->c_lflag |= ISIG;
				Ztcsetattr(loop_fildes, TCSANOW, loop_termios_p);
			finis

			prep("Ensure a controlling terminal has been established.");
			prep("Send special character INTR to all processes in");
			prep("foreground process group for which the terminal sent");
			prep("the INTR is the controlling terminal.");
			start
				SIGNAL(SIGINT, sig_int);

				sig_rcvd = 0;
				SET_ALARM(WAIT_FOR_TIME)
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
					if(sig_rcvd == 0)
						pause();
				IGNORE_ALARM

				if(sig_rcvd == 0)
					error("This process did not receive SIGINT.");
			finis

			prep("Obtain file descriptor that references controlling");
			prep("terminal from ctermid() provided info.");
			start
				Zctermid(path_ctid);
				SET_ALARM(WAIT_FOR_TIME)
					tty_ctid = Zopen(path_ctid, O_RDWR);
				CLEAR_ALARM
			finis

			testing("ctermid() generates a string that when used as a");
			testing("pathname refers to the controlling terminal for the");
			testing("current process.");
			start
				SET_ALARM(2 * WAIT_FOR_TIME)
					expecting(Strlen);
					Zwrite(tty_ctid, String, Strlen);
					Ztcdrain(tty_ctid);
					SLEEP(1);
				CLEAR_ALARM

				SET_ALARM(WAIT_FOR_TIME)
					expecting(Strlen);
					Zread(loop_fildes, inbuf, sizeof(inbuf));
				CLEAR_ALARM
			finis
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis


				/*	ctermid() with a NULL pointer as parameter returns
					a string that refers to the controlling terminal of
					the process.
				*/
	assertion(5, BASE);
	start
		char	*path_ctid;

		FORK
			prep("Acquire a controlling terminal and setup TTY lines.");
			start
				termios_prep(&tty_fildes, tty_termios_p,
									&loop_fildes, loop_termios_p);
										/* Enable SIGNALS */
				loop_termios_p->c_lflag |= ISIG;
				Ztcsetattr(loop_fildes, TCSANOW, loop_termios_p);
				Ztcflush(tty_fildes, TCIOFLUSH);
				Ztcflush(loop_fildes, TCIOFLUSH);
			finis

			prep("Ensure a controlling terminal has been established.");
			prep("Send special character INTR to all processes in");
			prep("foreground process group for which the terminal sent");
			prep("the INTR is the controlling terminal.");
			start
				SIGNAL(SIGINT, sig_int);

				sig_rcvd = 0;
				SET_ALARM(WAIT_FOR_TIME)
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
					if(sig_rcvd == 0)
						pause();
				IGNORE_ALARM

				if(sig_rcvd == 0)
					error("This process did not receive SIGINT.");
			finis

			prep("Obtain file descriptor that references controlling");
			prep("terminal from ctermid() provided info.");
			start
				path_ctid = Zctermid((char *)0);
				SET_ALARM(WAIT_FOR_TIME)
					tty_ctid = Zopen(path_ctid, O_RDWR);
				CLEAR_ALARM
			finis

			testing("ctermid() with a NULL pointer as parameter returns");
			testing("a string that when used as a pathname refers to the");
			testing("controlling terminal for the current process.");
			start
				SET_ALARM(2 * WAIT_FOR_TIME)
					expecting(Strlen);
					Zwrite(tty_ctid, String, Strlen);
					Ztcdrain(tty_ctid);
					SLEEP(1);
				CLEAR_ALARM

				SET_ALARM(WAIT_FOR_TIME)
					expecting(Strlen);
					Zread(loop_fildes, inbuf, sizeof(inbuf));
				CLEAR_ALARM
			finis
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
