#include	<pcts.h>

#include	<Zunistd.h>
#include	<Ztermios.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

void interrupt(int);
static	int		tty_fildes, loop_fildes;
static	struct	termios tty_termios, *tty_termios_p = &tty_termios,
						loop_termios, *loop_termios_p = &loop_termios;


int	main(void)
{
	pid_t pid;

	setup(E_SETSID);
	funct(E_SETSID);

	if(GTI_NOT_PROVIDED) {
		assertion(6, NOT_TESTABLE); 
		done();
	}

	assertion(6, BASE); 
	start
		exit_on(ERROR);
		FORK
			prep("Create a new session and establish a controlling terminal.");
			start
				Zsetsid();
				tty_prep(&tty_fildes, tty_termios_p);
				loop_prep(&loop_fildes,loop_termios_p);
			finis

			interrupt(TRUE);

			SIGNAL(SIGINT, SIG_IGN);

			FORK
				prep("Create another new session.");
				start
					Zsetsid();
				finis

				interrupt(FALSE);

			KROF
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}



void interrupt(int toggle)
{
							/*	Send SIGINT via INTR is received by
								process with controlling terminal.
							*/
	if(toggle == FALSE)
		testing("Process has no controlling terminal.");
	else
		prep("Availability of a controlling terminal demonstrated.");
	start
		SIGNAL(SIGINT, sig_int);
		SLEEP(WAIT_FOR_TIME);
		sig_rcvd = 0;

		SET_TIMEOUT
			expecting(sizeof(char));
			WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
		IGNORE_ALARM

		if(sig_rcvd == 0)
			sleep(WAIT_FOR_TIME);
	
		if (toggle == TRUE && sig_rcvd == 0)
			error("Process did not receive SIGINT.");
	
		if (toggle == FALSE && sig_rcvd != 0)
			error("Process received SIGINT.");
	finis
}
