#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>

int	main(void)
{
	setup(E_SETUID);
	funct(E_SETUID);

	assertion(8, BASE);
	start
		if(INVALID_UID_VALUE) {
			prep("Ensure process's real and effective user ID is UID.");
			start
				expecting(UID);
				Zgetuid();

				expecting(UID);
				Zgeteuid();
			finis

			testing("[EINVAL] supported for setuid().");
			start
				expecting(-1);
				expecting(EINVAL);
				Zsetuid((uid_t)INVALID_UID_VALUE);
			finis

			testing("Process's real and effective user ID is still UID.");
			start
				expecting(UID);
				Zgetuid();

				expecting(UID);
				Zgeteuid();
			finis
		}
		else {
			prep("Call setuid() with \"-1\" as the parameter.");
			start
				expecting(-1);
				expecting(EPERM);
				Zsetuid((uid_t)-1);
			finis

			not_implemented("[EINVAL] is not supported for setuid()");
		}
	finis

	assertion(9, BASE);
	start
		testing("User does not have the appropriate privileges for calling");
		testing("setuid() and the setuid() argument does not match either the");
		testing("real user ID or the saved set-user-ID.");
		start
			expecting(-1);
			expecting(EPERM);
			(void) Zsetuid(ROOT_UID);
		finis

		testing("Process's real and effective user ID is still UID.");
		start
			expecting(UID);
			Zgetuid();

			expecting(UID);
			Zgeteuid();
		finis
	finis

	done();
}
