#include	<pcts_ass.h>

#include	<limits.h>

#include	<sv_env.h>

extern	int	errno;

#include	<Zunistd.h>
#define		DUM_ERRNO	62

int	main(void)
{
	long	ret_val;

	setup(E_SYSCONF);
	funct(E_SYSCONF);

							/* These tests correspond to the asertions of 
								Draft 12.0.  These assertions in Draft 13.0
								may revert to that stated in Draft 12.0.
							*/
	assertion(5, BASE);
	start
#ifdef	ARG_MAX
		testing("Call to sysconf(_SC_ARG_MAX) returns a value >= value of");
		testing("ARG_MAX in <limits.h>.");
		start
			ret_val = Zsysconf(_SC_ARG_MAX);
			if(ret_val < ARG_MAX)
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value is >= to ",
					(long) ARG_MAX,
					"Actual return value was ",
					ret_val);
		finis
#else
		testing("Call to sysconf(_SC_ARG_MAX) returns a value >=");
		testing("{_POSIX_ARG_MAX} or -1 without changing the value of errno.");
		start
			errno = DUM_ERRNO;
			ret_val = sysconf(_SC_ARG_MAX);
			if((ret_val != -1) && (ret_val < _POSIX_ARG_MAX))
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf(_SC_ARG_MAX) call.",
					"Expected value is \"-1\" or >= ",
					(long) _POSIX_ARG_MAX,
					"Actual return value was ",
					ret_val);
			
			if(errno != DUM_ERRNO)
				error("%s\n%s%d.\n%s%d.",
						"Value of errno was changed.",
						"Expected value is ",
						DUM_ERRNO,
						"Actual value was ",
						errno);
		finis
#endif
	finis

	assertion(6, BASE);
	start
#ifdef	CHILD_MAX
		testing("Call to sysconf(_SC_CHILD_MAX) returns a value >= value of");
		testing("CHILD_MAX in <limits.h>.");
		start
			ret_val = Zsysconf(_SC_CHILD_MAX);
			if(ret_val < CHILD_MAX)
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value is >= to ",
					(long) CHILD_MAX,
					"Actual return value was ",
					ret_val);
		finis
#else
		testing("Call to sysconf(_SC_CHILD_MAX) returns a value >=");
		testing("{_POSIX_CHILD_MAX} or -1 without changing value of errno.");
		start
			errno = DUM_ERRNO;
			ret_val = sysconf(_SC_CHILD_MAX);
			if((ret_val != -1) && (ret_val < _POSIX_CHILD_MAX))
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf(_SC_CHILD_MAX) call.",
					"Expected value is \"-1\" or >= ",
					(long) _POSIX_CHILD_MAX,
					"Actual return value was ",
					ret_val);
			
			if(errno != DUM_ERRNO)
				error("%s\n%s%d.\n%s%d.",
						"Value of errno was changed.",
						"Expected value is ",
						DUM_ERRNO,
						"Actual value was ",
						errno);
		finis
#endif
	finis

	assertion(9, BASE);
	start
#ifdef	OPEN_MAX
		testing("Call to sysconf(_SC_OPEN_MAX) returns a value >= value of");
		testing("OPEN_MAX in <limits.h>.");
		start
			ret_val = Zsysconf(_SC_OPEN_MAX);
			if(ret_val < OPEN_MAX)
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value is >= to ",
					(long) OPEN_MAX,
					"Actual return value was ",
					ret_val);
		finis
#else
		testing("Call to sysconf(_SC_OPEN_MAX) returns a value >=");
		testing("{_POSIX_OPEN_MAX} or -1 without changing the value of errno.");
		start
			errno = DUM_ERRNO;
			ret_val = sysconf(_SC_OPEN_MAX);
			if((ret_val != -1) && (ret_val < _POSIX_OPEN_MAX))
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf(_SC_OPEN_MAX) call.",
					"Expected value is \"-1\" or >= ",
					(long) _POSIX_OPEN_MAX,
					"Actual return value was ",
					ret_val);
			
			if(errno != DUM_ERRNO)
				error("%s\n%s%d.\n%s%d.",
						"Value of errno was changed.",
						"Expected value is ",
						DUM_ERRNO,
						"Actual value was ",
						errno);
		finis
#endif
	finis

	assertion(10, BASE);
	start
#ifdef	STREAM_MAX
		testing("Call to sysconf(_SC_STREAM_MAX) returns a value >= value of");
		testing("STREAM_MAX in <limits.h>.");
		start
			ret_val = Zsysconf(_SC_STREAM_MAX);
			if(ret_val < STREAM_MAX)
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value is >= to ",
					(long) STREAM_MAX,
					"Actual return value was ",
					ret_val);
		finis
#else
		testing("Call to sysconf(_SC_STREAM_MAX) returns a value >=");
		testing("{_POSIX_STREAM_MAX} or -1 without changing the value of errno.");
		start
			errno = DUM_ERRNO;
			ret_val = sysconf(_SC_STREAM_MAX);
			if((ret_val != -1) && (ret_val < _POSIX_STREAM_MAX))
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf(_SC_STREAM_MAX) call.",
					"Expected value is \"-1\" or >= ",
					(long) _POSIX_STREAM_MAX,
					"Actual return value was ",
					ret_val);
			
			if(errno != DUM_ERRNO)
				error("%s\n%s%d.\n%s%d.",
						"Value of errno was changed.",
						"Expected value is ",
						DUM_ERRNO,
						"Actual value was ",
						errno);
		finis
#endif
	finis

	assertion(11, BASE);
	start
#ifdef	TZNAME_MAX
		testing("Call to sysconf(_SC_TZNAME_MAX) returns a value >= value of");
		testing("TZNAME_MAX in <limits.h>.");
		start
			ret_val = Zsysconf(_SC_TZNAME_MAX);
			if(ret_val < TZNAME_MAX)
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value is >= to ",
					(long) TZNAME_MAX,
					"Actual return value was ",
					ret_val);
		finis
#else
		testing("Call to sysconf(_SC_TZNAME_MAX) returns a value >=");
		testing("{_POSIX_TZNAME_MAX} or -1 without changing value of errno.");
		start
			errno = DUM_ERRNO;
			ret_val = sysconf(_SC_TZNAME_MAX);
			if((ret_val != -1) && (ret_val < _POSIX_TZNAME_MAX))
				error("%s\n%s%ld.\n%s%ld.\n",
					"Incorrect return value from sysconf(_SC_TZNAME_MAX) call.",
					"Expected value is \"-1\" or >= ",
					(long) _POSIX_TZNAME_MAX,
					"Actual return value was ",
					ret_val);
			
			if(errno != DUM_ERRNO)
				error("%s\n%s%d.\n%s%d.",
						"Value of errno was changed.",
						"Expected value is ",
						DUM_ERRNO,
						"Actual value was ",
						errno);
		finis
#endif
	finis

	done();
}
