#include	<pcts.h>

#include	<sys/Zutsname.h>

#include	<sv_env.h>

char	*uname_tok(void);


int	main(void)
{
	struct	utsname name;
	char	*s_ptr;
	int		ret_val;

	setup(E_UNAME);
	funct(E_UNAME);

    	/*	Uname stores information identifying the current operating
    		system in the structure pointed to by its argument.
		*/
	assertion(4, BASE);
	start
		testing("Call to uname() returns a non-negative value.");
		start
			ret_val = Zuname(&name);
			if(ret_val < 0)
				error("Call to uname() returned %d.", ret_val);
		finis
	finis

	assertion(6, BASE);
	start
		exit_on(ERROR);
		testing("Validate sysname field is a null terminated character array.");
		start
			s_ptr = uname_tok();
			if(strcmp(name.sysname, s_ptr) != 0)
				error("%s%s\n%s\"%s\".\n%s\"%s\".",
					"Value for sysname returned by uname() does ",
					"not match SYSNAME.",
					"The expected string was ",
					s_ptr,
					"The actual string was ",
					name.sysname);
		finis

		testing("Nodename field is a null terminated character array.");
		start
			s_ptr = uname_tok();
			if(strcmp(name.nodename, s_ptr) != 0)
				error("%s%s\n%s\"%s\".\n%s\"%s\".",
					"Value for nodename returned by uname() does ",
					"not match NODENAME.",
					"The expected string was ",
					s_ptr,
					"The actual string was ",
					name.nodename);
		finis

		testing("Validate release field is a null terminated character array.");
		start
			s_ptr = uname_tok();
			if(strcmp(name.release, s_ptr) != 0)
				error("%s%s\n%s\"%s\".\n%s\"%s\".",
					"Value for release returned by uname() does ",
					"not match RELEASE.",
					"The expected string was ",
					s_ptr,
					"The actual string was ",
					name.release);
		finis

		testing("Validate version field is a null terminated character array.");
		start
			s_ptr = uname_tok();
			if(strcmp(name.version, s_ptr) != 0)
				error("%s%s\n%s\"%s\".\n%s\"%s\".",
					"Value for version returned by uname() does ",
					"not match VERSION.",
					"The expected string was ",
					s_ptr,
					"The actual string was ",
					name.version);
		finis

		testing("Validate machine field is a null terminated character array.");
		start
			s_ptr = uname_tok();
			if(strcmp(name.machine, s_ptr) != 0)
				error("%s%s\n%s\"%s\".\n%s\"%s\".",
					"Value for machine returned by uname() does ",
					"not match MACHINE.",
					"The expected string was ",
					s_ptr,
					"The actual string was ",
					name.machine);
		finis
	finis

	assertion(5, BASE);
	start
		testing("The struct utsname elements are included in header");
		testing("<sys/utsname.h>.  Compilation test.  These elements are");
		testing("referenced in Assertion #6.");
		start
		finis
	finis

	assertion(7, EXTENDED);

	done();
}

/*	uname_tok() returns the next token in UNAME_INFO which is delimited
				by the next ','.  If a ',' is to be retained as a 
				character of the token, then precede the ',' by two '\'
				backslash characters.
				Each token provided by UNAME_INFO must consist of
				one or more characters and must not end with "\\,".
*/

char	*uname_tok(void)
{
	static	int	first = TRUE;
	static	char s_token[100];
	char	*s_del, *s_ptr;

	s_token[0] = '\000';
	if(first == TRUE)
		s_ptr = Zstrtok(UNAME_INFO, ",");
	else
		s_ptr = Zstrtok(NULL, ",");
	first = FALSE;

				/*	Assume,  If '\' exists, then it delimits a ','.	*/
	while((s_del = strstr(s_ptr, "\\")) != NULL) {
		Zstrncat(s_token, s_ptr, strlen(s_ptr) -1);
		Zstrcat(s_token, ",");
		s_ptr = Zstrtok(NULL, ",");
	}
	Zstrcat(s_token, s_ptr);
	return(s_token);
}
