#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

extern	char	**environ;
static	int		e_index;

void env_test(char *, char **);

int	main(int argc, char *argv[])
{
	char	*ptr;
	char	*varg_set[2];
	char	path[_POSIX_PATH_MAX +1];
	pid_t	pid;

	e_index = atoi(*++argv);
	setup(e_index);
	funct(e_index);

	if((e_index != (int)E_EXECLP) && (e_index != (int)E_EXECVP)) {
		assertion(9,  UNUSED);
		assertion(10, UNUSED);
		assertion(11, UNUSED);
		assertion(12, UNUSED);
		assertion(13, UNUSED);
		assertion(14, UNUSED);
		assertion(15, UNUSED);
		done();
	}

				/*	The execvp() and execlp() functions use the Environment's
	 				PATH variable to locate the proper files to exec.
	 
	 				The test modules are located in the directories:
	 						./STD/PP/bin/exec_p/good
	 						./STD/PP/bin/exec_p/bad
	 
	   				The "bad" directory are files which should never get
					executed.
				*/
	assertion(9, BASE);
	start
		prep("Establish the PATH environment for the following test.");
		start
			exit_on(ERROR);
			varg_set[1] = (char *)0;
			environ[0] = (char *)0;
			put_env(path);

			Zstrcpy(path, "PATH=");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX -Zstrlen(path));
			Zstrcat(path, "/exec_p/good");
		finis

		testing("PATH prefixes are used when the argument file does not");
		testing("contain a '/'.");
		start
			env_test("ex_p_good", varg_set);

			sv_flush();
			if((pid = Zfork()) == 0) {
				expecting(FAILURE);
				if(e_index == (int)E_EXECLP)
					Zexeclp("ex_p_bad", "ex_p_bad", (char *) 0);
				else {
										/*	EXECVP	*/
					varg_set[0] = "ex_p_bad";
					Zexecvp("ex_p_bad", varg_set);
				}
				done();
			}
			wait_for(pid, MAX_TIME_TO_RUN);
		finis
	finis

	assertion(10, BASE);
	start
		prep("Establish the PATH environment for the following test.");
		start
			Zstrcpy(path, "PATH=");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX -Zstrlen(path));
			Zstrcat(path, "/exec_p/good");
			Zstrcat(path, ":");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX - Zstrlen(path));
			Zstrcat(path, "/exec_p/good");
		finis

		testing("PATH prefixes are separated by a colon(:).");
		start
			env_test("ex_p_good", varg_set);
		finis
	finis


	assertion(11, BASE);
	start
		testing("For a non-zero length prefix applied to a filename,");
		testing("a slash is inserted between the prefix and the filename.");
		start
							/*  The path of last test is fine for testing. */
			env_test("ex_p_good", varg_set);
		finis
	finis

	assertion(12, BASE);
	start
		testing("PATH prefix specified as '::' indicates the current");
		testing("working directory.");
		start
			Zstrcpy(path, "PATH=::");
			env_test("ex_p_good", varg_set);
		finis
	finis

	assertion(13, BASE);
	start
		prep("Establish the PATH environment for the following test.");
		start
			Zstrcpy(path, "PATH=:");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX -Zstrlen(path));
			Zstrcat(path, "/execp");
		finis

		testing("PATH beginning with an initial ':' indicates the current");
		testing("working directory");
		start
			env_test("ex_p_good", varg_set);
		finis
	finis

	assertion(14, BASE);
	start
		prep("Establish the PATH environment for the following test.");
		start
			Zstrcpy(path, "PATH=");
			Zgetcwd(path +strlen(path), _POSIX_PATH_MAX -strlen(path));
			Zstrcat(path, "/execp");
			Zstrcat(path, ":");
		finis

		testing("PATH that has a trailing ':' indicates the current");
		testing("working directory");
		start
			env_test("ex_p_good", varg_set);
		finis
	finis

	assertion(15, BASE);
	start
		prep("Establish the PATH environment for the following test.");
		start
			Zstrcpy(path, "PATH=");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX -Zstrlen(path));
			Zstrcat(path, "/exec_p/good");
			Zstrcat(path, ":");
			Zgetcwd(path +Zstrlen(path), _POSIX_PATH_MAX - Zstrlen(path));
			Zstrcat(path, "/exec_p/bad");
			ptr = Zgetenv("PATH");
		finis
	
		testing("%s\n\t%s\n\t\t\"%s\"\n",
				"PATH environment is searched from beginning to end.",
				"Path environment is:",
				ptr);
		start
			env_test("ex_p_test", varg_set);
		finis
	finis

	done();
}


void env_test(char *file, char **varg_set)
{
	pid_t	pid;

	if((pid = Zfork()) == (pid_t)0) {
		if(e_index == (int)E_EXECLP)
			Zexeclp(file, file, (char *) 0);
		else {
								/*	EXECVP	*/
			varg_set[0] = file;
			Zexecvp(file, varg_set);
		}
		done();
	}
	wait_for(pid, MAX_TIME_TO_RUN);
}
