#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

extern	char	**environ;

#define	FILENAME	"./3.1.2_19x"

#define	ID_LENGTH	4
static	char	a_indx[ID_LENGTH];
static	char	*p_arg;
static	int		e_index;


int	main(int argc, char *argv[])
{
	pid_t	pid;
	char	*args[3];

	e_index = atoi(*++argv);
	strcpy(a_indx, *argv);
	setup(e_index);
	funct(e_index);

  		/*
  			The exec elements accept arguments including environment data of
  			{ARG_MAX} bytes allowing for NULL terminators, pointers or
			alignment bytes as defined in the implementation.
  		*/
	assertion(18, BASE);
	start
		char	*ptr;
		long	arg_max;

		exit_on(ERROR);
		prep("Initialize argument array.");
		start
			args[0] = a_indx;
			args[1] = p_arg;
			args[2] = (char *)0;
		finis

		prep("Initialize \"environ\" to NULL.");
		prep("Determine {ARG_MAX}.");
		start
			environ[0] = (char *)0;
			arg_max = Zsysconf(_SC_ARG_MAX);
		finis

		if( (arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1) ) {
			prep("Initialize an array of length PCTS_ARG_MAX.");
		}
		else
			prep("Initialize an array of length {ARG_MAX} (%lu).",
						(unsigned long) arg_max);
		start
			char	*p_limit;

			p_arg = (char *) Zmalloc((size_t)((arg_max > PCTS_ARG_MAX) ?
										PCTS_ARG_MAX :
										arg_max));
				/*
				   Determine number of filler bytes (p_limit) needed.

				   Total exec data, in bytes, to be passed:
						Argument zero:
							Pointer to arg[0]	sizeof(char *),
							Data				strlen(a_indx),
							Null character      sizeof(char),
						Argument one:
							Pointer to arg[1]	sizeof(char *),
							Filler bytes needed p_limit,
							Null character      sizeof(char),
						Argument two:
							NULL pointer		sizeof(NULL),
						Environment:
							NULL pointer		sizeof(NULL),
				*/
			args[1] = p_arg;
			p_limit = p_arg +((arg_max > PCTS_ARG_MAX) ?
								PCTS_ARG_MAX : arg_max)
								-Zstrlen(a_indx)
								-(sizeof(char) * 2)
								-(sizeof(char *) * 2)
								-(sizeof(NULL) * 2);
			for(ptr = p_arg; ptr <p_limit; ptr++)
				*ptr = 'z';
			*ptr = '\0';
		finis

		prep("Fork a child.");
		start
			sv_flush ();
			pid = Zfork();
		finis
	
		if (pid == 0) {
			testing("The exec elements accept arguments including.");
			testing("environment data of %s (%lu) bytes.",
						((arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1)) ?
										"PCTS_ARG_MAX" : "{ARG_MAX}",
						((arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1)) ?
										(unsigned long) PCTS_ARG_MAX :
										(unsigned long) arg_max);
			start
				switch(e_index) {
					case E_EXECL:
						Zexecl(FILENAME, a_indx, p_arg, (char *) 0);
						break;
					case E_EXECLE:
						Zexecle(FILENAME, a_indx, p_arg, (char *) 0, environ);
						break;
					case E_EXECV:
    					Zexecv(FILENAME, args);
						break;
					case E_EXECVE:
    					Zexecve(FILENAME, args, environ);
						break;
					case E_EXECLP:
    					Zexeclp(FILENAME, a_indx, p_arg, (char *) 0);
						break;
					case E_EXECVP:
    					Zexecvp(FILENAME, args);
						break;
					default:
						error("Bad indx \"%d\" passed to module.", e_index);
				}
			finis
			done();
		}
		wait_for(pid, 5 * MAX_TIME_TO_RUN);
	finis

	done();
}
