#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

/*	This module has S_ISGID mode set to BIN_GID. */


int main(int argc, char *argv[])
{
	int e_index;

	e_index = atoi(*argv);
	setup(e_index);
	ass_nu = 45;

	testing("Effective group ID is set to group ID of the file executed.");
	start
		expecting(BIN_GID);
		Zgetegid();
	finis

	testing("Real group ID remains unchanged.");
	start
		if(getgid() != (uid_t) atoi(*++argv))
			error("%s%d\n%s%d",
					"Expected real group ID of: ",
					(uid_t) atoi(*argv),
					"Actual real group ID is: ",
					getgid());
	finis

	testing("Supplementary groups remain unchanged.");
	start
		int		i=0, fd;
		int		egid_test = TRUE;
		gid_t	*g_beg, s_gid;
		int		n_grps;
		char	path[_POSIX_PATH_MAX +1];

		n_grps = Zgetgroups(0, (gid_t *)0);		/* Get number of groups */
		g_beg = (gid_t *) Zmalloc((unsigned int) (sizeof(gid_t) * n_grps));
		(void) Zgetgroups(n_grps, g_beg);

		Zstrcpy(path, temp_path());
		Zstrcat(path, "sup_grps");
		fd = Zopen(path, O_RDONLY);

		while(read(fd, (char *)&s_gid, sizeof(gid_t)) > 0) {
								/*	Since the effective GID may be returned
									from getgroups(), for the parent process
									the real GID of the child process is the
									effective GID of the parent process.  The
									effective GID of this child process is
									established by setaccess.
								*/
message("%d: par_sgid %ld,  chld_sgid %ld,  chld_gid %ld,  chld_egid %ld\n",
		i, (long) s_gid, g_beg[i], (long) getgid(), (long) getegid() );

			if(egid_test) {
				if(g_beg[i] == getegid()) {	/* getgroups() returns EGID. */
						/*	Ensure the effective group ID of parent process
							occupies same entry in getgroups() for parent.*/
					if(s_gid != getgid())
						error("%s\n%s%ld\n%s%ld\n",
			"Entries from getgroups() not consistent for parent and child.",
								"Expected effective group ID:	",
								(long) getgid(),
								"Actual GID located in expected entry is:	",
								(long) s_gid);
					else
						egid_test = FALSE;
					i++;
					continue;
				}
			}
			if(s_gid != g_beg[i++])
				error("%s\n%s%ld\n%s%ld\n",
						"Supplementary GID not the same.",
						"Expected GID:	",
						(long) s_gid,
						"Actual GID located in its place is:	",
						(long) g_beg[i -1]);
		}
	finis

	done();
}
