#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

/* This module has S_ISUID set to ROOT. */


int	main(void)
{
	pid_t	pid;

	setup(E_FORK);
	funct(E_FORK);

	assertion(26, EXTENDED);

/*
		P1003.3.1 Draft 14.0 has a testing constraint on this assertion.
		We expect this testing constraint not to apply to either 
		FIPS 151-1 nor POSIX.1.

	if(PCTS_PROCESS_LIMIT != -1) {
*/
	  assertion(27, BASE);
	  start
		long	child_max, proc_gen, i;

		FORK
							/*	Change the real user ID to allow this
								test to acquire {CHILD_MAX} processes.
								This avoids having to know the number
								of processes already inuse at this time.
							*/
			Zsetuid(BIN_UID);
			child_max = Zsysconf(_SC_CHILD_MAX);
			if( ((long)PCTS_CHILD_MAX > child_max) && (child_max != (long)-1) )
				proc_gen = child_max;
			else
				proc_gen = PCTS_CHILD_MAX;		/* Limit not attainable. */

			prep("Setup ones own process group.");
			prep("This makes it easier to cleanup.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
			finis

			if( ((long)PCTS_CHILD_MAX > child_max) && (child_max != (long)-1) )
				prep("Generate %ld additional processes.", proc_gen -1);
			else {
				testing("Implementation can generate {PCTS_CHILD_MAX}");
				testing("processes.");
			}
			start
				continue_on(ERROR);
				for(i=1; i<proc_gen; i++) {
					pid = fork();
					if( pid == (pid_t)0 ) {
						pause();
						done();
					}
					if(pid == (pid_t)-1) {
						error("%s\n%s %ld.",
							"Call to fork() failed while attempting to",
							"generate process",
							i);
						break;
					}
				}
			finis

			if( ((long)PCTS_CHILD_MAX > child_max) && (child_max != (long)-1) ){
				testing("Call to fork() on the %ld ({CHILD_MAX} +1) process.",
											i);
				start
					pid = fork();
					if(pid == (pid_t)0) {
						pause();
						done();
					}
					if(pid != (pid_t) -1) {
						warning("Call to fork() succeeded unexpectedly.");

								/* Try one more process, Extended Assertion */
						pid = fork();
						if( pid == (pid_t)0 ) {
							pause();
							done();
						}
						if(pid != (pid_t)-1)
							error("%s%s",
									"Call to fork() succeeded unexpectedly on",
									"{CHILD_MAX} +2.");
						else
							if(errno != EAGAIN)
								error("%s\n%s[%s].",
									"Expected: errrno of [EAGAIN].",
									"Actual: errno set to ",
									err_lookup(errno));
					}
					else
						if(errno != EAGAIN)
							error("%s\n%s[%s].",
								"Expected: errrno of [EAGAIN].",
								"Actual: errno set to ",
								err_lookup(errno));
				finis

			}

			cleanup("Terminate all child processes.");
			start
				Zkill((pid_t)(-1*getpgrp()), SIGKILL);
			finis
		KROF
	  finis
/*
	} else
	  assertion(27, NOT_TESTABLE);
*/

	assertion(28, EXTENDED);

	done();
}
