#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>


int	main(void)
{
	pid_t	pid;
	int		stat_val, i;
	sigset_t	set;

	setup(E_KILL);
	funct(E_KILL);

	assertion(4, BASE);
	start
		for(i=0; i < NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

			ENABLE_PSYNC
			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid ==(pid_t)0) {
				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);

					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();
			}

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			testing("Signal %s can be sent via kill() to a process.",
														sigs[i].signame);
			testing("Return value from kill() is zero.");
			start
				pid_t	r_pid;

				expecting(0);
				Zkill(pid, sigs[i].sig);
				if((r_pid = Zwait(&stat_val)) != pid)
					error("%s%s.\n%s%ld\n%s%ld",
							"Incorrect child pid returned while testing ",
							sigs[i].signame,
							"Expected pid of ",
							(long) pid,
							"Actual pid returned ",
							(long) r_pid);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
			finis

			DISABLE_PSYNC
		}
	finis

	assertion(5, BASE);
	start
		ENABLE_PSYNC
		for(i = NSIGS_JC; i < NSIGS; i++) {
			prep("Fork a child.");
			start
				sv_flush();
				pid = fork();
			finis

			if(pid ==(pid_t)0) {
				if(sigs[i].sig == SIGSTOP) {
					SEND_PSYNC
					pause();
				}
				else {
					prep("Block the %s signal.", sigs[i].signame);
					start
						SIGNAL(sigs[i].sig, sig_int);
						SIGBLOCK(set, sigs[i].sig);
					finis

					SEND_PSYNC
					SET_TIMEOUT
						WAIT_PSYNCA
					CLEAR_ALARM
					SLEEP(WAIT_FOR_TIME);

					testing("Signal %s delivered to child process.",
														sigs[i].signame);
					start
						Zsigpending(&set);
						if( ! sigismember(&set, sigs[i].sig) )
							error("Signal %s not delivered.",
														sigs[i].signame);
					finis
				}
				done();
			}

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			testing("Signal %s can be sent via kill() to a process.",
														sigs[i].signame);
			start
				Zkill(pid, sigs[i].sig);
			finis

			SEND_PSYNCA

			if(sigs[i].sig == SIGSTOP) {
				testing("Child process is stopped.");
				start
					SLEEP(WAIT_FOR_TIME);
					Zwaitpid(pid, &stat_val, WNOHANG | WUNTRACED);
					if( ! WIFSTOPPED(stat_val))
						error("Child process not stopped.");
					Zkill(pid, SIGKILL);
				finis
			}
			WAIT_FOR_PID(pid);
		}
		DISABLE_PSYNC
	finis

	assertion(6, BASE);
	start
		ENABLE_PSYNC
		prep("Fork a child.");
		start
			sv_flush();
			pid = fork();
		finis

		if(pid ==(pid_t)0) {
			SEND_PSYNC
			SLEEP(WAIT_FOR_TIME);
			done();
		}

		SET_TIMEOUT
			WAIT_PSYNC
		CLEAR_ALARM

		testing("call of kill(pid, 0) returns a value of 0 while process");
		testing("with ID of pid exists.");
		start
			expecting(0);
			Zkill(pid, 0);
		finis

		WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis
	
	done();
}
