#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>
#include	"./kill.h"

/* This module has S_ISUID set to BIN_UID.  */


int	main(int argc, char *argv[])
{
	pid_t	pid;
	int		sig;

	setup(E_KILL);
	ass_nu = 7;

	exit_on(ERROR);
	prep("Ensure receiving process user IDs are set properly.");
	prep("Real user ID is UID and effective user ID is BIN_UID.");
	start
		if(getuid() != UID)
			error("%s\n%s%lu.",
					"Expected real user ID to be UID.",
					"Actual real user ID is ",
					(unsigned long) getuid());

		if(geteuid() !=  BIN_UID)
			error("%s\n%s%lu.",
					"Expected effective user ID to be BIN_UID.",
					"Actual effective user ID is ",
					(unsigned long) geteuid());
		sig = atoi(*++argv);
	finis

	prep("Establish SIG_DFL for %s signal.", sig_lookup(sig));
	start
		SIGNAL(sig, SIG_DFL);
		pid = getpid();
	finis

	prep("Pass receiving process's ID (%ld) to sending process.", (long)pid);
	start
		char	old[_POSIX_PATH_MAX +1], new[_POSIX_PATH_MAX +1];
		int		fd;

		Zstrcpy(old, temp_path());
		Zstrcat(old, "psynch_t");
		fd = Zcreat(old, PROT_ALL);
		Zwrite(fd, (char *)&pid, (unsigned)sizeof(pid_t));
		Zclose(fd);
		Zstrcpy(new, temp_path());
		Zstrcat(new, FILENAME);
		Zrename(old, new);
		sv_flush();
	finis

	pause();
	
	done();			/* Just in case */
}
