#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

/* This module has S_ISUID set to ROOT.  */

int	main(void)
{
	pid_t	pid;
	int		stat_val, i;

	setup(E_KILL);
	funct(E_KILL);

	assertion(11, BASE);
	start
		ENABLE_PSYNC
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid ==(pid_t)0) {
				prep("Change process IDs for child process."); 
				start
					Zsetuid(BIN_UID);
				finis

				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);

					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();			/* Just in case */
			}

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			testing("Process with appropriate privileges can send a");
			testing("signal %s via kill() to a process where the",
														sigs[i].signame);
			testing("receiving processes IDs do not match the");
			testing("sending process's IDs.");
			start
				Zkill(pid, sigs[i].sig);
				Zwait(&stat_val);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
			finis
		}
		DISABLE_PSYNC
	finis

	done();
}
