#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

int	main(void)
{
	pid_t	pid1, pid2, pid3, pid4;
	int		stat_val, i;

	setup(E_KILL);
	funct(E_KILL);

	assertion(12, BASE);
	start
		prep("Establish a new controlling process.");
		start
			pid1 = getpid();
			Zsetpgid(pid1, pid1);
		finis

		ENABLE_PSYNC
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

			prep("Fork a child.");
			start
				sv_flush();
				pid1 = Zfork();
			finis

			if(pid1 == (pid_t)0) {
				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();			/* Just in case */
			}

			prep("Fork a child.");
			start
				sv_flush();
				pid2 = Zfork();
			finis


			if(pid2 ==(pid_t)0) {
				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();			/* Just in case */
			}

			SET_TIMEOUT
				WAIT_PSYNC
				WAIT_PSYNC
			CLEAR_ALARM

			prep("Establish SIG_IGN for %s signal for parent.",sigs[i].signame);
			start
				SIGNAL(sigs[i].sig, SIG_IGN);
			finis

			testing("Call of kill((pid_t)0, %s) from a process",
														sigs[i].signame);
			testing("will send the signal to all processes whose");
			testing("process group ID is equal to the process group ID");
			testing("of the sender.");
			start
				Zkill((pid_t)0, sigs[i].sig);
				pid3 = Zwait(&stat_val);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
				pid4 = Zwait(&stat_val);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
				if( ! (
						((pid1==pid3) && (pid2==pid4)) ||
						((pid1==pid4) && (pid2==pid3)) ) )
					error("Processes terminated not reported correctly.");
			finis
		}
		DISABLE_PSYNC
	finis

	assertion(13, BASE);
	start
		prep("Establish a new controlling process.");
		start
			pid1 = getpid();
			Zsetpgid(pid1, pid1);
		finis

		ENABLE_PSYNC
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

			prep("Fork a child.");
			start
				sv_flush();
				pid1 = Zfork();
			finis

			if(pid1 ==(pid_t)0) {
				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();			/* Just in case */
			}

			prep("Fork a child.");
			start
				sv_flush();
				pid2 = Zfork();
			finis


			if(pid2 ==(pid_t)0) {
				prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
					sv_flush();
					SEND_PSYNC
					pause();
				finis

				done();			/* Just in case */
			}

			SET_TIMEOUT
				WAIT_PSYNC
				WAIT_PSYNC
			CLEAR_ALARM

			prep("Establish SIG_IGN for %s signal for parent.",sigs[i].signame);
			start
				SIGNAL(sigs[i].sig, SIG_IGN);
			finis

			testing("Call of kill((pid, %s) when pid is", sigs[i].signame);
			testing("negative but not -1, from a process");
			testing("will send the signal to all processes whose");
			testing("process group ID is equal to the absolute value");
			testing("of pid.");
			start
				Zkill(((pid_t)-1) * Zgetpgrp(), sigs[i].sig);
				pid3 = Zwait(&stat_val);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
				pid4 = Zwait(&stat_val);
				if( ! WIFSIGNALED(stat_val)) 
					error("Process not terminated by receipt of signal.");
				else {
					if(sigs[i].sig != WTERMSIG(stat_val))
						error("Process terminated by signal %s\n",
										sig_lookup(WTERMSIG(stat_val)) );
				}
				if( ! (
						((pid1==pid3) && (pid2==pid4)) ||
						((pid1==pid4) && (pid2==pid3)) ) )
					error("Processes terminated not reported correctly.");
			finis
		}
		DISABLE_PSYNC
	finis

	done();
}
