#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  kill() is reentrant with respect to signals. */

static int	catch_sig;
void sig_catch2(int i)
{	
	prep("Entering second signal catching routine.");
	start
		catch_sig++;
	finis
}

void sig_catch(int i)
{	
	prep("Unblock SIGINT in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGINT);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGINT.");
	start
		expecting(SUCCESS);
		SIGNAL(SIGINT , sig_catch2);
	finis

	prep("Signal catcher calls kill()");
	start
		catch_sig++;
		Zkill(getpid(), SIGINT);
	finis

	catch_sig++;
}

int main(void)
{
	pid_t	pid;
	
	setup(E_SIGNAL_CON);
	ass_nu = 45;

	FORK
		prep("Set signal catcher for SIGINT, then call kill().");
		start
			SIGNAL(SIGINT, sig_catch);

			Zkill(getpid(), SIGINT);
		finis

		testing("The function kill() is reentrant with respect to signals.");
		start
			if(catch_sig != 3)
				error("The kill() function is not reentrant.");
		finis
	KROF

	done();
}
