#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  sigsuspend() is reentrant with respect to signals. */

static	sigset_t	set;
static	int	catch_sig;
void sig_catch2(int i)
{	
	prep("Entering second signal catching routine.");
	start
		catch_sig++;
	finis
}

void sig_catch(int i)
{	
	prep("Unblock SIGINT in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGINT);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGINT.");
	start
		SIGNAL(SIGINT , sig_catch2);
		catch_sig++;
	finis

	prep("Signal catcher calls sigsuspend()");
	start
		errno = 0;
		sigsuspend(&set);
		if(errno != EINTR)
			error("%s\n%s\n%s%s",
				"Value of errno incorrect from sigsuspend() in sig_catch().",
				"Expected value corresponding to [EINTR].",
				"Actual value corresponds to ",
				sig_lookup(errno) );
		errno = 0;
		catch_sig++;
	finis
}

int main(void)
{
	pid_t	pid;
	
	setup(E_SIGNAL_CON);
	ass_nu = 45;

	prep("Block signal SIGUSR1.");
	start
		SIGBLOCK(set, SIGUSR1);
	finis

 	prep("Fork a child process to test sigsuspend() is reentrant.");
	   start
		sv_flush();
		pid = Zfork();
	finis

	if(pid == (pid_t)0) {
		prep("Set signal catcher for SIGINT, then call sigsuspend().");
		start
			SIGNAL(SIGINT, sig_catch);

			errno = 0;
			sigsuspend(&set);
			if(errno != EINTR)
				error("%s\n%s\n%s%s",
					"Value of errno incorrect from sigsuspend() in main().",
					"Expected value corresponding to [EINTR].",
					"Actual value corresponds to ",
					sig_lookup(errno) );
		errno = 0;
		finis

		testing("Function sigsuspend() is reentrant with respect to signals.");
		start
			if(catch_sig != 3)
				error("The sigsuspend() function is not reentrant.");
		finis

		done();
	}


	prep("Issue SIGINT to child.");
	start
		SLEEP(WAIT_FOR_TIME);	/* Allow time for child to call sigsuspend(). */
		Zkill(pid, SIGINT);
	finis

	prep("Issue a second SIGINT to child to interrupt the interrupt.");
	start
		SLEEP(WAIT_FOR_TIME);	/* Allow time sig_catch() call sigsuspend(). */
		Zkill(pid, SIGINT);
	finis 

	WAIT_FOR_PID(pid);

	done();
}
