#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  write() is reentrant with respect to signals. */

static	int		pipfd[2];
#define	String	"Test"
#define	Strlen	(sizeof(String) -1)

static int	catch_sig;
void sig_catch2(int i)
{	
	prep("Entering second signal catching routine.");
	start
		catch_sig++;
	finis
}

void sig_catch(int i)
{	
	prep("Unblock SIGPIPE in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGPIPE);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGPIPE.");
	start
		SIGNAL(SIGPIPE , sig_catch2);
		catch_sig++;
	finis

	prep("Signal catcher calls write().");
	start
		SET_ALARM(TIMEOUT)
			errno = 0;
			write(pipfd[1], String, Strlen);
			if(errno != EPIPE)
				error("%s\n%s\n%s%s",
					"Value of errno incorrect from write() in sig_catch().",
					"Expected value corresponding to EPIPE.",
					"Actual value corresponds to ",
					err_lookup(errno) );
			errno = 0;
		CLEAR_ALARM
		catch_sig++;
	finis

}

int main(void)
{
	pid_t	pid;

	setup(E_SIGNAL_CON);
	ass_nu = 45;
	
	prep("Create a pipe and close the read descriptor.");
	start
		Zpipe(pipfd);
		Zclose(pipfd[0]);
	finis

	FORK
		prep("Set signal catcher for SIGPIPE.");
		start
			SIGNAL(SIGPIPE, sig_catch);
		finis
		
		prep("Write should receive SIGPIPE.");
		start
			SET_ALARM(TIMEOUT)
				errno = 0;
				write(pipfd[1], String, Strlen);
				if(errno != EPIPE)
					error("%s\n%s\n%s%s",
						"Value of errno incorrect from write() in main().",
						"Expected value corresponding to [EPIPE].",
						"Actual value corresponds to ",
						err_lookup(errno) );
			CLEAR_ALARM
		finis

		testing("The function write() is reentrant with respect to signals.");
		start
			if(catch_sig != 3)
				error("The write() function is not reentrant.");
		finis
	KROF

	done();
}
