#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

#define	FILENAME	"./3.2.1a_04x"

int	main(void)
{
	time_t	time_beg, time_end;
	int		stat_val;
	pid_t	pid;
	struct	sigaction	act1, act2;

	setup(E_WAIT);
	funct(E_WAIT);

	assertion(4, BASE);
	start
		break_on(ERROR);
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			testing("Have child sleep a fixed time.");
			start
				sv_flush();
				SLEEP(WAIT_FOR_TIME +1);
			finis

			done();
		}

		testing("Call to wait() suspends execution until child terminates.");
		start
			Ztime(&time_beg);
			Zwait(&stat_val);
			Ztime(&time_end);

			if((time_end -time_beg) < (time_t)(WAIT_FOR_TIME +1 -WAIT_FOR_TIME))
				error("%s\n%s%lu\n%s%lu\n",
					"Child process suspended for too short a time.",
					"Expected a time >= to ",
					(unsigned long) (WAIT_FOR_TIME +1 -WAIT_FOR_TIME),
					"Actual time was: ",
					(unsigned long) time_end -time_beg);
		finis

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Fork a grandchild process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Have grandchild send child a signal.");
				start
					sv_flush();
					SLEEP(WAIT_FOR_TIME)
					Zkill(getppid(), SIGINT);
					SLEEP(MAX_TIME_TO_RUN);
				finis

				done();
			}

			prep("Establish an action to terminate on signal.");
			start
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = SIG_DFL;
				act1.sa_flags = 0;
				Zsigaction(SIGINT, &act1, &act2);
			finis

			wait(&stat_val);		/* Signal expected to terminate wait(). */

			done();
		}

		SLEEP(WAIT_FOR_TIME);

		testing("Call to wait() suspends execution until child process");
		testing("received a signal whose action was to terminate.");
		start
			Ztime(&time_beg);
			Zwait(&stat_val);
			Ztime(&time_end);

			if((time_end -time_beg) > WAIT_FOR_TIME)
				error("%s\n%s%lu\n%s%lu\n",
					"Child process suspended for too long a time.",
					"Expected a time <= to ",
					(unsigned long) WAIT_FOR_TIME,
					"Actual time was: ",
					(unsigned long) (time_end -time_beg));
		finis

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Fork a grandchild process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Have grandchild send child a signal.");
				start
					sv_flush();
					SLEEP(WAIT_FOR_TIME);
					Zkill(getppid(), SIGINT);
					SLEEP(MAX_TIME_TO_RUN);
				finis

				done();
			}

			prep("Establish an action to catch a signal.");
			start
				sv_flush();
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = sig_int;
				act1.sa_flags = 0;
				Zsigaction(SIGINT, &act1, &act2);
			finis

			wait(&stat_val);

			done();
		}

		SLEEP(WAIT_FOR_TIME);

		testing("Call to wait() suspends execution until calling process");
		testing("received a signal whose action was to catch a signal.");
		start
			Ztime(&time_beg);
			Zwait(&stat_val);
			Ztime(&time_end);

			if((time_end -time_beg) > WAIT_FOR_TIME)
				error("%s\n%s%lu\n%s%lu\n",
					"Child process suspended for too long a time.",
					"Expected a time <= to ",
					(unsigned long) WAIT_FOR_TIME,
					"Actual time was: ",
					(unsigned long) (time_end -time_beg));
		finis
	finis

	assertion(5, BASE);
	start
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child process exits.");
			start
			finis

			done();
		}

		SLEEP(WAIT_FOR_TIME);

		testing("When status information is available prior to a call to");
		testing("wait(), return shall be immediate.");
		start
			Ztime(&time_beg);
			Zwait(&stat_val);
			Ztime(&time_end);

			if((time_end -time_beg) > 1)
				error("%s\n%s%lu\n",
					"Call to wait() did not return immediately.",
					"Actual time was: ",
					(unsigned long) (time_end -time_beg));
		finis
	finis

	assertion(6, BASE);
	start
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls exit().");
			start
				sv_flush();
			finis

			done();
		}

		testing("Call to wait(&stat_loc) returns the child process ID.");
		start
			pid_t ret;

			ret = wait(&stat_val);
			if(ret != pid)
				error("%s\n%s%ld\n%s%ld\n",
					"Return from wait(&stat_loc) incorrect.",
					"Expected: child process ID of ",
					(long) pid,
					"Actual: value returned was ",
					(long) ret);
		finis

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls exit().");
			start
				sv_flush();
			finis

			done();
		}

		SLEEP(WAIT_FOR_TIME); /* Ensure prep() is outputted before testing(). */

		testing("Call to wait(NULL) returns the child process ID.");
		start
			pid_t ret;

			ret = wait((int *)0);
			if(ret != pid)
				error("%s\n%s%ld\n%s%ld",
					"Return from wait(NULL) is incorrect.",
					"Expected: child process ID of ",
					(long) pid,
					"Actual: value returned was ",
					(long) ret);
		finis
	finis

	assertion(7, BASE);
	start
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls exit() with an argument of zero.");
			start
			finis

			exit(0);
		}

		wait(&stat_val);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls _exit() with an argument of zero.");
			start
			finis

			_exit(0);
		}

		wait(&stat_val);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis


		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module with return from main() of value zero.");
			start
				sv_flush();
				Zexecl(FILENAME, "0", (char *)0);
				done();		/* Just in case. */
			finis
		}

		wait(&stat_val);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis
	finis

	done();
}
