#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

#define	EXIT_VALUE	5
#define	FILENAME	"./3.2.1a_04x"


int	main(void)
{
	int		stat_val;
	pid_t	ret, pid;

	setup(E_WAIT);
	funct(E_WAIT);

	assertion(9, BASE);
	start
											/* 1 of 3:  Test for _exit(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit().");
			start
			finis

			done();
		}

		wait(&stat_val);

		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 2 of 3:  Test for exit(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call exit().");
			start
			finis

			done_e();
		}

		wait(&stat_val);

		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 3 of 3:  Test for main(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module and wait for return from main().");
			start
				sv_flush();
				Zexecl(FILENAME, "0", (char *)0);
				done();				/* Just in case. */
			finis
		}

		wait(&stat_val);

		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis
	finis

	assertion(10, BASE);
	start
											/* 1 of 3:  Test for _exit(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit() with known argument value.");
			start
			finis

			_exit(EXIT_VALUE);
		}

		wait(&stat_val);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 2 of 3:  Test for exit(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call exit() with known argument value.");
			start
			finis

			exit(EXIT_VALUE);
		}

		wait(&stat_val);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 3 of 3:  Test for main(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module with return from main() of predefined value.");
			start
				char	a_value[10];

				sv_flush();
				sprintf(a_value, "%d", EXIT_VALUE);
				Zexecl(FILENAME, a_value, (char *)0);
				done();				/* Just in case. */
			finis
		}

		wait(&stat_val);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis
	finis

	assertion(11, BASE);
	start
		struct	sigaction	act1, act2;

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Establish an action to terminate on SIGINT.");
			start
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = SIG_DFL;
				act1.sa_flags = 0;
				Zsigaction(SIGINT, &act1, &act2);
			finis

			prep("Have child send itself a signal.");
			start
				sv_flush();
				kill(getpid(), SIGINT);
			finis

			done();
		}

		ret = wait(&stat_val);

		testing("Macro WIFSIGNALED() evaluates to non-zero.");
		testing("Macros WIFEXITED() and WIFSTOPPED() evaluate to zero.");
		start
			if(WIFSIGNALED(stat_val) == 0)
				error("WIFSIGNALED() evaluated to zero.");

			if(WIFEXITED(stat_val) != 0)
				error("WIFEXITED() evaluated to non-zero.");

			if(WIFSTOPPED(stat_val) != 0)
				error("WIFSTOPPED() evaluated to non-zero.");
		finis
	finis

	assertion(12, BASE);
	start
		testing("When WIFSIGNALED() is non-zero, WTERMSIG() evaluates to the");
		testing("number of the signal that caused the termination of the");
		testing("child process.");
		start
			if(WIFSIGNALED(stat_val)) {
				if(WTERMSIG(stat_val) != SIGINT)
					error("%s\n%s%d",
						"Expected: child process to be terminated by SIGINT. ",
						"Actual: value returned from macro WTERMSIG is ",
						WTERMSIG(stat_val) );
			}
			else
				error("WIFSIGNALED reports no signal terminated the child.");
		finis
	finis

	assertion(13, BASE);
	start
		if(sysconf(_SC_JOB_CONTROL) != (long)-1) {
			ENABLE_PSYNC
			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Have process wait awhile before continuing.");
				start
					sv_flush();
					SEND_PSYNC
					WAIT_PSYNCA
				finis

				done();
			}

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			prep("Send SIGSTOP to child.");
			start
				Zkill(pid, SIGSTOP);
			finis

			testing("Call to wait() does not return when child is stopped.");
			start
				SET_TIMEOUT
					wait(&stat_val);
				EXPECT_ALARM
			finis

			cleanup("Send child SIGCONT so it can exit.");
			start
				Zkill(pid, SIGCONT);
				SEND_PSYNCA
			finis

			WAIT_FOR_PID(pid);
			DISABLE_PSYNC
		}
		else
			error("FIPS required option {_POSIX_JOB_CONTROL} not supported.");
	finis

	done();
}
