#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int	main(void)
{
	int		stat_val;
	pid_t	ret, pid;
	struct	sigaction	act1, act2;

	setup(E_WAIT);
	funct(E_WAIT);

	assertion(14, BASE);
	start
		testing("When the wait() call has no existing unwaited-for child");
		testing("processes, value returned is -1 and errno set to [ECHILD].");
		start
			ret = wait(&stat_val);

			if(ret != (pid_t)-1)
				error("%s\n%s%ld",
					"Expected: return value of -1.",
					"Actual: return value was ",
					(long) ret);
			if(errno != ECHILD)
				error("%s\n%s%s",
					"Expected: errno set to [ECHILD].",
					"Actual: errno is ",
					err_lookup(errno) );
		finis
	finis

	assertion(15, BASE);
	start
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Establish an action to catch a signal.");
			start
				sv_flush();
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = sig_int;
				act1.sa_flags = 0;
				Zsigaction(SIGINT, &act1, &act2);
			finis

			ENABLE_PSYNC
				prep("Fork a grandchild process.");
				start
					sv_flush();
					pid = Zfork();
				finis

				if(pid == (pid_t)0) {
					prep("Have grandchild send parent process a signal.");
					start
						sv_flush();
						SET_TIMEOUT
							WAIT_PSYNC
						CLEAR_ALARM
						SLEEP(1);		/* Delay a bit more */
						Zkill(getppid(), SIGINT);
								/* Allow time for parent to process wait() */
						SLEEP(WAIT_FOR_TIME);
					finis

					done();
				}

							/* Allow child's prep message to get out first. */
				SLEEP(WAIT_FOR_TIME);
				testing("wait() interrupted by a signal, returns -1 and");
				testing("sets errno to [EINTR].");
				start
					SEND_PSYNC
					expecting(EINTR);
					expecting(-1);
					Zwait(&stat_val);
				finis

			DISABLE_PSYNC

			done();
		}
		wait_for(pid, MAX_TIME_TO_RUN);
	finis

	done();
}
