#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

#define	EXIT_VALUE	5
#define	FILENAME	"./3.2.1a_04x"


int	main(void)
{
	int		stat_val;
	pid_t	pid, ret;

	setup(E_WAITPID);
	funct(E_WAITPID);

	assertion(11, BASE);
	start
		ENABLE_PSYNC
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child delay awhile.");
			start
				sv_flush();
				SET_TIMEOUT
					WAIT_PSYNC
				CLEAR_ALARM
			finis

			done();
		}

		SLEEP(1);

		testing("Call to waitpid(pid, stat_loc, WNOHANG) and");
		testing("waitpid(pid, stat_loc, WNOHANG | WUNTRACED) does not");
		testing("suspend execution of calling process when status is not");
		testing("available and a value of zero is returned.");
		start
			SET_ALARM(TIMEOUT)
			  ret = Zwaitpid(pid, &stat_val, WNOHANG);
			  if(ret != (pid_t)0)
				error("%s\n%s\n%s%ld",
					"Return from waitpid(pid, &stat_loc, WNOHANG) incorrect.",
					"Expected: return of 0",
					"Actual: value returned was ",
					(long) ret);

			  ret = Zwaitpid(pid, &stat_val, WNOHANG | WUNTRACED);
			  if(ret != (pid_t)0)
				error("%s\n%s\n%s%ld",
					"Return from waitpid(pid, &stat_loc, WNOHANG | WUNTRACED) incorrect.",
					"Expected: return of 0",
					"Actual: value returned was ",
					(long) ret);

			  SEND_PSYNC
			  Zwaitpid(pid, &stat_val, 0);
			CLEAR_ALARM
		finis
		DISABLE_PSYNC
	finis

	assertion(12, BASE);
	start
		if(sysconf(_SC_JOB_CONTROL) != (long)-1) {
			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Stop child process.");
				start
					Zkill(getpid(), SIGSTOP);
					SLEEP(WAIT_FOR_TIME);
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			testing("Call to waitpid(pid, stat_loc, WUNTRACED) reports");
			testing("to the calling process status of stopped children.");
			start
				SET_ALARM(TIMEOUT)
					ret = Zwaitpid(pid, &stat_val, WUNTRACED);
					if(ret != pid)
						error("%s\n%s%ld\n%s%ld\n",
							"Return from waitpid(pid, &stat_loc, WUNTRACED) incorrect.",
							"Expected: return of ",
							(long) pid,
							"Actual: value returned was ",
							(long) ret);
					else
						if( ! WIFSTOPPED(stat_val)) 
							error("Child status reported active, expected STOPPED.");
				CLEAR_ALARM
			finis

			cleanup("Terminate stopped child.");
			start
				Zkill(pid, SIGKILL);
				WAIT_FOR_PID(pid);
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Stop child process.");
				start
					Zkill(getpid(), SIGSTOP);
					SLEEP(WAIT_FOR_TIME);
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			testing("Call to waitpid(pid, stat_loc, WNOHANG | WUNTRACED)");
			testing("reports to calling process status of stopped children.");
			start
				SET_ALARM(TIMEOUT)
					ret = Zwaitpid(pid, &stat_val, WNOHANG | WUNTRACED);
					if(ret != pid)
						error("%s\n%s%ld\n%s%ld\n",
							"Return from waitpid(pid, &stat_loc, WNOHANG | WUNTRACED) incorrect.",
							"Expected: return of ",
							(long) pid,
							"Actual: value returned was ",
							(long) ret);
					else
						if( ! WIFSTOPPED(stat_val)) 
							error("Child status reported active, expected STOPPED.");
				CLEAR_ALARM
			finis

			cleanup("Terminate stopped child.");
			start
				Zkill(pid, SIGKILL);
				WAIT_FOR_PID(pid);
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Stop child process.");
				start
					Zkill(getpid(), SIGSTOP);
					SLEEP(WAIT_FOR_TIME);
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			prep("Terminate stopped child.");
			start
				Zkill(pid, SIGKILL);
				SLEEP(WAIT_FOR_TIME);
			finis

			testing("Call to waitpid(pid, stat_loc, WUNTRACED) reports");
			testing("to the calling process status of children that have");
			testing("exited and whose status has not yet been reported");
			testing("since they stopped.");
			start
				SET_ALARM(TIMEOUT)
					Zwaitpid(pid, &stat_val, WUNTRACED);
					if( ! WIFSIGNALED(stat_val)) 
						error("%s%s",
							"Child status did not report that it was",
							"terminated by a signal.");
				CLEAR_ALARM
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Stop child process.");
				start
					Zkill(getpid(), SIGSTOP);
					SLEEP(WAIT_FOR_TIME);
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			prep("Terminate stopped child.");
			start
				Zkill(pid, SIGKILL);
				SLEEP(WAIT_FOR_TIME);		/* Allow kill() to be processed */
			finis

			testing("Call to waitpid(pid, stat_loc, WNOHANG | WUNTRACED)");
			testing("reports to the calling process status of children that");
			testing("have exited and whose status has not yet been reported");
			testing("since they stopped.");
			start
				SET_ALARM(TIMEOUT)
					Zwaitpid(pid, &stat_val, WNOHANG | WUNTRACED);
					if( ! WIFSIGNALED(stat_val)) 
						error("%s%s",
							"Child status did not report that it was",
							"terminated by a signal.");
				CLEAR_ALARM
			finis

			cleanup("Terminate any unwaited for children.");
			start
				waitpid((pid_t)-1, &stat_val, WNOHANG | WUNTRACED);
				waitpid((pid_t)-1, &stat_val, WNOHANG);
			finis
		}
		else
			error("FIPS 151-2 option {_POSIX_JOB_CONTROL} not supported");
	finis

	assertion(13, BASE);
	start
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls exit() with an argument of zero.");
			start
			finis

			exit(0);
		}

		waitpid(pid, &stat_val, 0);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis

		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Child calls _exit() with an argument of zero.");
			start
			finis

			_exit(0);
		}

		waitpid(pid, &stat_val, 0);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis


		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module with return from main() of value zero.");
			start
				sv_flush();
				Zexecl(FILENAME, "0", (char *)0);
				done();		/* Just in case. */
			finis
		}

		waitpid(pid, &stat_val, 0);

		testing("Value stored at location pointed to by stat_loc is zero.");
		start
			if(stat_val)
				error("%s\n%s\n%s%d\n",
					"Value of stat_val incorrect",
					"Expected: 0",
					"Actual: value is ",
					stat_val);
		finis
	finis

	assertion(14, BASE);
	start
											/* 1 of 3:  Test for _exit(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit().");
			start
			finis

			done();
		}

		waitpid(pid, &stat_val, 0);


		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 2 of 3:  Test for exit(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call exit().");
			start
			finis

			done_e();
		}

		waitpid(pid, &stat_val, 0);

		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 3 of 3:  Test for main(). */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module and wait for return from main().");
			start
				sv_flush();
				Zexecl(FILENAME, "0", (char *)0);
				done();				/* Just in case. */
			finis
		}

		waitpid(pid, &stat_val, 0);

		testing("Status of child process that terminated normally");
		testing("WIFEXITED is non-zero and WIFSIGNALED and WIFSTOPPED");
		testing("are zero.");
		start
			if(WIFEXITED(stat_val)) {
				if(WIFSIGNALED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSIGNALED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSIGNALED is: ",
						WIFSIGNALED(stat_val) );
				if(WIFSTOPPED(stat_val)) 
					error("%s\n%s%d\n%s%d\n",
						"Both WIFSTOPPED and WIFEXITED evaluate to non-zero.",
						"WIFEXITED is: ",
						WIFEXITED(stat_val),
						"WIFSTOPPED is: ",
						WIFSTOPPED(stat_val) );
			}
			else
				error("WIFEXITED returned zero.");
		finis
	finis

	assertion(15, BASE);
	start
											/* 1 of 3:  Test for _exit(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit() with known argument value.");
			start
			finis

			_exit(EXIT_VALUE);
		}

		waitpid(pid, &stat_val, 0);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 2 of 3:  Test for exit(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call exit() with known argument value.");
			start
			finis

			exit(EXIT_VALUE);
		}

		waitpid(pid, &stat_val, 0);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis

											/* 3 of 3:  Test for main(). */
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Exec a module with return from main() of predefined value.");
			start
				char	a_value[10];

				sv_flush();
				sprintf(a_value, "%d", EXIT_VALUE);
				Zexecl(FILENAME, a_value, (char *)0);
				done();				/* Just in case. */
			finis
		}

		waitpid(pid, &stat_val, 0);

		testing("WEXITSTATUS() evaluation of low-order 8 bits.");
		start
			if(WIFEXITED(stat_val)) {
				if(WEXITSTATUS(stat_val) != EXIT_VALUE) 
					error("%s%d\n%s%d\n",
						"WEXITSTATUS() exited with value of ",
						WEXITSTATUS(stat_val),
						"Expected an exit value of ",
						EXIT_VALUE);
			}
			else
				error("WIFEXITED returned zero.");
		finis
	finis

	done();
}
