#define	_POSIX_SOURCE

#include	<sys/types.h>
#include	<unistd.h>
#include	<stdio.h>
#include	<sys/stat.h>

#include	<sv_conf.h>

extern void    sv_config(void);

#define Root_uid	((uid_t **) (&sv_params[1].value))
#define Root_gid	((gid_t **) (&sv_params[2].value))
#define Bin_uid		((uid_t **) (&sv_params[3].value))
#define Bin_gid		((gid_t **) (&sv_params[4].value))
#define Uid			((uid_t **) (&sv_params[5].value))
#define Gid			((gid_t **) (&sv_params[6].value))
#define Other_uid	((uid_t **) (&sv_params[7].value))
#define Sup_gid		((gid_t **) (&sv_params[8].value))

#define	S_IRXUSR	S_IRUSR | S_IXUSR
#define	S_IRWUSR	S_IRUSR | S_IWUSR
#define	S_IRXGRP	S_IRGRP | S_IXGRP
#define	S_IRWGRP	S_IRGRP | S_IWGRP
#define	S_IRXOTH	S_IROTH | S_IXOTH
#define	S_IRWOTH	S_IROTH | S_IWOTH
#define	S_NULL		0

struct	perms {
	mode_t	mode;
 	uid_t	**owner;
 	gid_t	**group;
	char	*file;
} perms[] = {


	/***************************************************************
	**		     Support Tools		              **
	***************************************************************/


	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
			Root_uid, Root_gid, "bin/clraccess" },


	/***************************************************************
	**		    Definitions		                      **
	***************************************************************/



	/***************************************************************
	**		Process Primitives		              **
	***************************************************************/

	/* fork */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH | S_ISGID,
		 	Bin_uid, Bin_gid,  "STD/PP/bin/3.1.1_17" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.1.1_26" },

	/* exec */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.1.2_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Gid,  "STD/PP/bin/3.1.2_44x" },
	{ S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Bin_gid,  "STD/PP/bin/3.1.2_45x" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH | S_ISGID,
		 	Bin_uid, Bin_gid,  "STD/PP/bin/3.1.2_46x" },

	/* execl */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execl.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execl.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execl.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execl.d/no_exec" },

	/* execv */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execv.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execv.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execv.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execv.d/no_exec" },


	/* execle */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execle.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execle.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execle.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execle.d/no_exec" },


	/* execve */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execve.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execve.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execve.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execve.d/no_exec" },


	/* execvp */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execvp.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execvp.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execvp.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execvp.d/no_exec" },


	/* execlp */
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execlp.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/PP/data/execlp.d/no_srch.d/test" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execlp.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/PP/data/execlp.d/no_exec" },

	/* STD/PP/bin */
	{ S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Gid,  "STD/PP/bin/exec_p" },


	/* kill */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.3.2_07" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Gid,  "STD/PP/bin/3.3.2_07xr" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Other_uid, Gid,  "STD/PP/bin/3.3.2_07xs" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Other_uid, Gid,  "STD/PP/bin/3.3.2_08xr" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Gid,  "STD/PP/bin/3.3.2_08xs" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Gid,  "STD/PP/bin/3.3.2_09xr" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Gid,  "STD/PP/bin/3.3.2_09xs" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Gid,  "STD/PP/bin/3.3.2_10xr" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Uid, Gid,  "STD/PP/bin/3.3.2_10xs" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.3.2_11" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.3.2_15" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PP/bin/3.3.2_17" },

	/***************************************************************
	**		Process Environment		              **
	***************************************************************/

	/* getuid */
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Bin_gid,  "STD/PE/bin/4.2.1a_04" },

	/* geteuid */
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Bin_gid,  "STD/PE/bin/4.2.1b_04" },

	/* getgid */
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Bin_gid,  "STD/PE/bin/4.2.1c_04" },

	/* getegid */
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Bin_gid,  "STD/PE/bin/4.2.1d_04" },
	
	/* setuid */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/PE/bin/4.2.2a_04" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Gid,  "STD/PE/bin/4.2.2a_05x" },

	/* setgid */
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Root_gid,  "STD/PE/bin/4.2.2b_04" },
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Bin_gid,  "STD/PE/bin/4.2.2b_05x" },
	
	/* getlogin */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Bin_uid, Gid,  "STD/PE/bin/4.2.4_04" },

	/* time */
	{ S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH,
		 	Uid, Gid,  "STD/PE/data/time.d/regular_file" },

	/* ttyname */
	{ S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH,
		 	Uid, Gid,  "STD/PE/data/ttyname.d/regular_file" },

	/* isatty */
	{ S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH,
		 	Uid, Gid,  "STD/PE/data/isatty.d/regular_file" },

	/***************************************************************
	**		Files and Directories		              **
	***************************************************************/

	/* Directory */

	/* opendir */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.1.2a_acc" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/data.d/first" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/data.d/second" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/data.d/third" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/no_dir" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/no_srch.d/test1" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/no_srch.d" },
	{ S_IWUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/opendir.d/no_read.d" },

	/* chdir */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.2.1_acc" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/chdir.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/chdir.d/no_perm.d/chdir_tryme" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/chdir.d/no_perm.d" },

	/* open */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.1_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.1_32" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.3.1_65" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/open.d/Open_Test" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/open.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perm.d/open_tryme" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perms.d" },
	{ S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perms.d/no_read" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_perms.d/no_write" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_write" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/open.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Bin_uid,      Bin_gid,
			"STD/FD/data/open.d/ownership" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/open.d/test.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/open.d/test.d/test_file" },
	{ S_IRWXU,
		 	Uid,      Bin_gid,
		 	"STD/FD/data/open.d/group_bin.d" },

	/* creat */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.2_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.2_29" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.3.2_52" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/creat.d/Open_Test" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/creat.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/no_perm.d/open_tryme" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/no_perm.d" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/no_write" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Bin_uid,      Bin_gid,
			"STD/FD/data/creat.d/ownership" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/creat.d/test.d/test_file" },
	{ S_IRWXU,
		 	Uid,      Bin_gid,
		 	"STD/FD/data/creat.d/group_bin.d" },

	/* link */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.4_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.3.4_09" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.3.4_23" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.4_37" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.3.4_61" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/link.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/link.d/no_srch.d/link_tryme" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/link.d/no_srch.d" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/link.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/link.d/mnt_rofs.d" },

	/* mkdir */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.4.1_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.4.1_21" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.4.1_36" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/mkdir.d/no_srch.d" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/mkdir.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/mkdir.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Bin_gid,
		 	"STD/FD/data/mkdir.d/group_bin.d" },

	/* mkfifo */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.4.2_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.4.2_21" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.4.2_33" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/mkfifo.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/mkfifo.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/mkfifo.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Bin_gid,
		 	"STD/FD/data/mkfifo.d/group_bin.d" },

	/* unlink */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.5.1_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.5.1_09" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.5.1_23" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.5.1_37" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_srch.d/unlink_tryme" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_srch.d" },
	{ S_IRXUSR | S_IRXGRP | S_IRXOTH,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_write.d/unlink_tryme" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/unlink.d/mnt_rofs.d" },

	/* rmdir */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.5.2_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.5.2_36" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_srch.d/rmdir_tryme" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_srch.d" },
	{ S_IRXUSR | S_IRXGRP | S_IRXOTH,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_write.d/rmdir_tryme" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/no_write.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/not_empty.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rmdir.d/not_empty.d/data_file" },

	/* rename */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid, "STD/FD/bin/5.5.3_acc" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid, "STD/FD/bin/5.5.3_42" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid, "STD/FD/bin/5.5.3_67" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/rename.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_srch.d/_tryme_" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_write.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_write.d/_tryme_" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/FD/data/rename.d/no_write.d" },

	/* stat.h */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.1_09" },

	/* stat */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.6.2a_acc" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/stat.d/no_srch.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/stat.d/no_srch.d/_tryme_" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/stat.d/no_srch.d" },

	/* fstat */

	/* access */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.3_23" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.3_35" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/mnt_rofs.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/no_srch.d/_tryme_" },
	{ S_IRUSR,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/no_srch.d" },
	{ S_NULL,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/no_perms" },
	{ S_IRUSR,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/rd_owner" },
	{ S_IWUSR,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/wr_owner" },
	{ S_IXUSR,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/ex_owner" },
	{ S_IRGRP,
		 	Bin_uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/rd_group" },
	{ S_IWGRP,
		 	Bin_uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/wr_group" },
	{ S_IXGRP,
		 	Bin_uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/ex_group" },
	{ S_IROTH,
		 	Bin_uid,      Bin_gid,
		 	"STD/FD/data/access.d/perms.d/rd_other" },
	{ S_IWOTH,
		 	Bin_uid,      Bin_gid,
		 	"STD/FD/data/access.d/perms.d/wr_other" },
	{ S_IXOTH,
		 	Bin_uid,      Bin_gid,
		 	"STD/FD/data/access.d/perms.d/ex_other" },
	{ S_NULL,
		 	Uid,      Gid,
		 	"STD/FD/data/access.d/perms.d/no_perm.d" },

	/* chmod */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.4_19" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.4_34" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Bin_uid,      Bin_gid,
		 	"STD/FD/data/chmod.d/mode_tests_su" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/chmod.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/chmod.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/chmod.d/no_srch.d/_tryme_" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/chmod.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Root_uid, Bin_gid,
			"STD/FD/data/chmod.d/chmod_root" },
	{ S_ISGID | S_IRWXU | S_IRWXG | S_IRWXO,
			Uid,      Bin_gid,
			"STD/FD/data/chmod.d/chmod_setgid" },

	/* chown */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.6.5_19" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.6.5_35" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/chown.d/t_chown_res" },
	{ S_ISUID | S_ISGID | S_IRWXU | S_IRWXG | S_IRWXO,
			Uid,      Gid,
			"STD/FD/data/chown.d/suid_mode_test" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/chown.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/chown.d/no_srch.d/_tryme_" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Bin_gid,
			"STD/FD/data/chown.d/gid_bin" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Bin_uid,      Gid,
			"STD/FD/data/chown.d/uid_bin" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Bin_uid,      Bin_gid,
			"STD/FD/data/chown.d/t_chown_bin" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/chown.d/mnt_rofs.d" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/chown.d/no_srch.d" },

	/* utime */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.6_22" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/FD/bin/5.6.6_36" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/FD/data/utime.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/FD/data/utime.d/no_srch.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/FD/data/utime.d/no_srch.d/_tryme_" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/utime.d/no_srch.d" },
	{ S_IRUSR | S_IRGRP,
		 	Bin_uid,      Gid,
			"STD/FD/data/utime.d/bin_nowrite" },
	{ S_IRUSR | S_IRWXO,
		 	Bin_uid,      Bin_gid,
			"STD/FD/data/utime.d/utime_write" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/FD/data/utime.d/utime_owner" },
	{ S_IRUSR | S_IROTH,
		 	Bin_uid,      Bin_gid,
			"STD/FD/data/utime.d/utime_bin" },

	/* pathconf */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/FD/bin/5.7.1a_acc" },
	{ S_IRWXU,
		 	Uid, Gid,
			"STD/FD/data/pathconf.d/no_srch.d" },
	{ S_IRWXU,
		 	Uid, Gid,
			"STD/FD/data/pathconf.d/no_srch.d/_tryme_" },
	{ S_IRUSR | S_IWUSR,
		 	Uid,      Gid,
			"STD/FD/data/pathconf.d/no_srch.d" },

	/* fpathconf */

	/***************************************************************
	**		     Input and Output		              **
	***************************************************************/


	/* write */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/IO/bin/6.4.2_11" },
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Gid,  "STD/IO/bin/6.4.2_41" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/IO/data/write.d/mnt_rofs.d" },


	/***************************************************************
	**		 Device and Class Specific	              **
	***************************************************************/

	/* termios */

	/***************************************************************
	**		     C Language Library		              **
	***************************************************************/

	/* fopen */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/LS/bin/8.1.14_34" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/LS/data/fopen.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perm.d/fopen_tryme" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perms.d" },
	{ S_IWUSR,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perms.d/no_read" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_perms.d/no_write" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/LS/data/fopen.d/no_write.d" },

	/* freopen */
	{ S_ISUID | S_IRWXU | S_IRXGRP | S_IRXOTH,
		 	Root_uid, Bin_gid,  "STD/LS/bin/8.1.18_43" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
		 	"STD/LS/data/freopen.d/mnt_rofs.d" },
	{ S_IRWXU,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_perm.d" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_perm.d" },
	{ S_IRWXU | S_IRWXG | S_IRWXO,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_perms.d" },
	{ S_IWUSR,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_perms.d/no_read" },
	{ S_IRUSR,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_perms.d/no_write" },
	{ S_IRUSR | S_IXUSR,
		 	Uid,      Gid,
			"STD/LS/data/freopen.d/no_write.d" },


	/***************************************************************
	**		      Passwords		                     **
	***************************************************************/



	/***************************************************************
	**		Data Interchange Format		              **
	***************************************************************/
	{ S_IRUSR | S_IXGRP | S_ISGID,
		 	Uid, Bin_gid,
			"STD/DIF/data/dif.d/type.d/mode_cks.d/S_ISGID" },
	{ S_IRUSR | S_IXUSR | S_ISUID | S_IRGRP,
		 	Bin_uid, Gid,
			"STD/DIF/data/dif.d/type.d/mode_cks.d/S_ISUID" },
	/* Ensure these files exist. */
	{ S_IRUSR | S_IWUSR,
		 	Uid, Gid,
			"STD/DIF/data/dif.d/type.d/mode_cks.d/S_ISFIFO" },
	{ S_IRUSR | S_IWUSR,
		 	Uid, Gid,
			"STD/DIF/data/dif.d/gt_100_link" },
};

#define	NPERMS	(sizeof(perms)/sizeof(struct perms))


int	main(int argc, char *argv[])
{
	int	i;
	void 	exit();

	sv_config();

	if(geteuid() != ROOT_UID) {
		fprintf(stderr,"%s: Must be executed with user ID of ROOT.\n", argv[0]);
		exit(1);
	}

	if (chdir(PCTS_PATH)) {
		fprintf(stderr,"%s: Can't chdir() to \"%s\"\n", argv[0], PCTS_PATH);
		exit(1);
	}
	printf("%s: Setting access modes for \"%s\"\n", argv[0], PCTS_PATH);
	umask(S_NULL);
	for(i=0; i<NPERMS ; i++) {
		if(access(perms[i].file, F_OK) ) {
			fprintf(stderr,"%s: Can't access() \"%s\".\n", argv[0],
																perms[i].file);
			continue;
		}

		if(chown(perms[i].file, **perms[i].owner, **perms[i].group)) {
			fprintf(stderr,"%s: Can't chown() \"%s\".\n", argv[0],
																perms[i].file);
			exit(1);
		}

		if(chmod(perms[i].file, perms[i].mode)) {
			fprintf(stderr,"%s: Can't chmod() \"%s\".\n", argv[0],
																perms[i].file);
			exit(1);
		}
	}

	exit(0);
}
