#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

/*	errlookup():	return char str representation of errno value */

#include <stdio.h>
#include <errno.h>

static struct errz {
	int errr;
	char *errrname;
} errz[] = {
	{ E2BIG,		"[E2BIG] - Arg list too long"	},
	{ EACCES,		"[EACCES] - Permission denied"	},
	{ EAGAIN,		"[EAGAIN] - Resource temporarily unavailable"	},
	{ EBADF,		"[EBADF] - Bad file number"	},
	{ EBUSY,		"[EBUSY] - Resource busy"		},
	{ ECHILD,		"[ECHILD] - No child processes"	},
	{ EDEADLK,		"[EDEADLK] - Resource Deadlock would occur"	},
	{ EDOM,			"[EDOM] - Domain error"	},
	{ EEXIST,		"[EEXIST] - File exists"	},
	{ EFAULT,		"[EFAULT] - Bad address"	},
	{ EFBIG,		"[EFBIG] - File too large"	},
	{ EINTR,		"[EINTR] - Interrupted system call"	},
	{ EINVAL,		"[EINVAL] - Invalid argument"	},
	{ EIO,			"[EIO] - Input/output error"	},
	{ EISDIR,		"[EISDIR] - Is a directory"	},
	{ EMFILE, 		"[EMFILE] - Too many open files"	},
	{ EMLINK, 		"[EMLINK] - To many links"	},
	{ ENAMETOOLONG,	"[ENAMETOOLONG] - Filename too long"	},
	{ ENFILE, 		"[ENFILE] - Too many open files in system"	},
	{ ENODEV, 		"[ENODEV] - No such device"	},
	{ ENOENT, 		"[ENOENT] - No such file or directory"	},
	{ ENOEXEC,		"[ENOEXEC] - Exec format error"	},
	{ ENOLCK,		"[ENOLCK] - No locks available"	},
	{ ENOMEM,		"[ENOMEM] - Not enough space"	},
	{ ENOSPC,		"[ENOSPC] - No space left on device"	},
	{ ENOSYS,		"[ENOSYS] - Function not implemented"	},
	{ ENOTDIR,		"[ENOTDIR] - Not a directory"	},
	{ ENOTEMPTY,	"[ENOTEMPTY] - Directory not empty"	},
	{ ENOTTY,		"[ENOTTY] - Inappropriate I/O control operation"	},
	{ ENXIO,		"[ENXIO] - No such device or address"	},
	{ EPERM,		"[EPERM] - Operation not permitted"	},
	{ EPIPE,		"[EPIPE] - Broken pipe"	},
	{ ERANGE,		"[ERANGE] - Result too large"	},
	{ EROFS,		"[EROFS] - Read only file system"	},
	{ ESPIPE,		"[ESPIPE] - Invalid seek"	},
	{ ESRCH,		"[ESRCH] - No such process"	},
	{ EXDEV,		"[EXDEV] - Improper link"	},
	{ 0,			"0 - No Error"	},
};


/*
** err_lookup
**	Look up the symbolic name for an error.
**
** Arguments
**	num	Error number (probably from errno).
*/
char *err_lookup(int num)
{
	register struct errz *p = &errz[0];
	static char foo[24];

	while(1) {
		if(p->errr == num)
			return(p->errrname);
		if(!((p++)->errr)) {
			(void) sprintf(foo,"%d - Unknown Error",num);
			return(foo);
		}
	}
}
