#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <stdarg.h>

#include <sv_env.h>

extern char *sv_getlev(char *);
extern int sv_sid(int);
extern void sv_vprintf(char *, va_list);
void sv_vprerr(int, char *, va_list);
extern int sv_act(int, int, sigjmp_buf);

static void foo_cpy(char *p1, char *p2)
{
	char *p = p1;
	while((*p1 = *p2)) {
		if( (p1 - p) >= 509 ) {
			goto done;
		}
		p1++;
		if(*p2++ == '\n') 	/* tab out error message		*/
			if(*p2) 			/* no tab if msg ends w/ '\n'	*/
				*p1++ = '\t';	
	}
done:
/*
 *	add '\n' to end of msg if empty msg ("") or does not end with '\n'
 */	
	if(!(p1 - p) || ( *(p1-1) != '\n'))
		*p1++ = '\n';
	*p1 = '\0';
}

void sv_message(char *format, ...)
{
	va_list	ap;

	va_start(ap, format);
	sv_vprerr(MESSAGE, format, ap);
	va_end(ap);
}

void sv_warning(char *format, ...)
{
	va_list	ap;

	va_start(ap, format);
	sv_vprerr(WARNING, format, ap);
	va_end(ap);
}

void sv_error(char *format, ...)
{
	va_list	ap;

	va_start(ap, format);
	sv_vprerr(ERROR, format, ap);
	va_end(ap);
}

void sv_severr(char *format, ...)
{
	va_list	ap;

	va_start(ap, format);
	sv_vprerr(SEVERR, format, ap);
	va_end(ap);
}


void sv_prerr(int sev, char *format, ...)
{
	va_list	ap;

	va_start(ap, format);
	sv_vprerr(sev, format, ap);
	va_end(ap);
}


void sv_vprerr(int sev, char *format, va_list ap)
{
	char buf[512];
	char *msg_name;
	int	msg_type;
	extern	char	*sv_snm(int);

	buf[0] = '\0';
	msg_name = sv_snm(sev);
	msg_type = sv_sid(sev);
	sv_printf("\n%s (%s):\n\t",msg_name,sv_getlev(buf));
	foo_cpy(buf, format);
	sv_vprintf(buf, ap);
	sv_act(sev, sv_xenv->sv_act[msg_type], sv_xenv->sv_jmpb[msg_type]);
}
