#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>


/*	Compare two flock structure for being identical. */
void same_lock(struct flock *one, struct flock *two)
{
	if(one->l_type != two->l_type) 
		error("%s\n%s%s\n%s%s\n",
			"l_type not correct.",
			"Expected:	",
			(two->l_type == F_UNLCK) ? "F_UNLCK" :
					(two->l_type == F_RDLCK) ? "F_RDLCK" :
					(two->l_type == F_WRLCK) ? "F_WRLCK" :
					"Unknown LOCK type",
			"Actual:	",
			(one->l_type == F_UNLCK) ? "F_UNLCK" :
					(one->l_type == F_RDLCK) ? "F_RDLCK" :
					(one->l_type == F_WRLCK) ? "F_WRLCK" :
					"Unknown LOCK type");

	
	if(one->l_whence != two->l_whence) 
		error("%s\n%s%s\n%s%s\n",
			"l_whence not correct.",
			"Expected:	",
			(two->l_whence == SEEK_SET) ? "SEEK_SET" :
					(two->l_whence == SEEK_CUR) ? "SEEK_CUR" :
					(two->l_whence == SEEK_END) ? "SEEK_END" :
					"Unknown l_whence value",
			"Actual:	",
			(one->l_whence == SEEK_SET) ? "SEEK_SET" :
					(one->l_whence == SEEK_CUR) ? "SEEK_CUR" :
					(one->l_whence == SEEK_END) ? "SEEK_END" :
					"Unknown l_whence value");

	if(one->l_start != two->l_start) 
		error("%s\n%s%lu\n%s%lu\n",
			"l_start not correct.",
			"Expected:	",
			(unsigned long) two->l_start,
			"Actual:	",
			(unsigned long) one->l_start);

	if(one->l_len != two->l_len) 
		error("%s\n%s%lu\n%s%lu\n",
			"l_len not correct.",
			"Expected:	",
			(unsigned long) two->l_len,
			"Actual:	",
			(unsigned long) one->l_len);

	if(one->l_pid != two->l_pid) 
		error("%s\n%s%ld\n%s%ld\n",
			"l_pid not correct.",
			"Expected:	",
			(long) two->l_pid,
			"Actual:	",
			(long) one->l_pid);
	return;
}
