#include	<pcts.h>
#include	<pcts_testv.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

static	char path[_POSIX_PATH_MAX +1];

/*	Determine if DIR is implemented using a file descriptor.
	Assume: If it is, then the next available file descriptor is alloted.

	Return TRUE if DIR is implemented using a file descriptor.

	This module is no longer used since the documentation symbol {PCD_DIR_TYPE}
	and the requirement in FIPS 151-2 requiring all features be documented
	resolved this issue.
*/
int	DIR_impl(void)
{
	int		fd1, fd2;
	DIR		*dirp;

	Zstrcpy(path, temp_path());
	Zstrcat(path, "dummy");
	fd1 = Zcreat(path, PROT_ALL);
	Zclose(fd1);
	Zunlink(path);
		
	Zstrcpy(path, temp_path());
	dirp = Zopendir(path);

	Zstrcat(path, "dummy");
	fd2 = Zcreat(path, PROT_ALL);
	Zclose(fd2);
	Zunlink(path);
	Zclosedir(dirp);

	if(fd1 != fd2)
		return(TRUE);
	else
		return(FALSE);
}


/*
	Return TRUE if {NAME_MAX} <= {PCTS_NAME_MAX}
    	Otherwise
	Return FALSE
*/

int	tc_name_max()
{
	long	name_lng;

	Zstrcpy(path, temp_path());
	name_lng = pathconf(path, _PC_NAME_MAX);
	if((name_lng == (long) -1) || (name_lng > PCTS_NAME_MAX)) {
		return(FALSE);
	}
	else
		return(TRUE);
}


/*
	Return TRUE if {PATH_MAX} <= {PCTS_PATH_MAX}
    	Otherwise
	Return FALSE
*/

int tc_path_max(void)
{
	long	path_lng;
	int		fd;

	Zstrcpy(path, temp_path());
	fd = Zopen(path, O_RDONLY);
	path_lng = fpathconf(fd, _PC_PATH_MAX);
	if(path_lng == (long) -1)
		error("%s\n%s\n",
			"fpathconf(_PC_PATH_MAX) failed.",
			"Expected value for {PATH_MAX}.");
	close(fd);
	if((path_lng == (long) -1) || (path_lng > PCTS_PATH_MAX)) {
		return(FALSE);
	}
	else
		return(TRUE);
}
