#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <unistd.h>
#include <config.h>

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <sv_env.h>

/*
 *	Z funct for commands
 */

static int success(int *val)
{
	return((*val) == 0);
}

static int failure(int *val)
{
	return((*val) != 0);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern int *sv_geti(void);

static struct ftable Tcommand = {
	"                                ",	/* reserve space for cmd_name */
	"an exit status of 0",
	"a non-zero exit status",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

#define cmd_name Tcommand.sv_name
static char *sv_argv[64];
static char stdoutfile[512] ="";
static char stderrfile[512] ="";


char *sv_stdoutfile(void)
{
	return(stdoutfile);
}	


char *sv_stderrfile(void)
{
	return(stderrfile);
}	


char *sv_cmdname(void)
{
	return(cmd_name);
}	

sv_cmd(char *arg0, ...)
{
	va_list	ap;
	int cpid;
	int wpid;
	int sts;
	int i;
	
	va_start(ap, arg0);
	for(i= 1; (sv_argv[i] = va_arg(ap, char *)); i++);
	va_end(ap);
	sv_argv[0]= arg0;
	if(!*stdoutfile) {
		strcpy(stdoutfile, sv_temp_path());
		strcat(stdoutfile, "stdout");
		strcpy(stderrfile, sv_temp_path());
		strcat(stderrfile, "stderr");
	}
	if(!(cpid = fork())) {
		expecting(VOID);
		unlink(stdoutfile);
		unlink(stderrfile);
		exit_on(SEVERR | ERROR);
		expecting(SUCCESS);
		if(!freopen(stderrfile,"w",stderr))
			severr("Redirection of stderr with freopen failed.");
		if(!freopen(stdoutfile,"w",stdout))
			severr("Redirection of stdout with freopen failed.");
		execvp(arg0, sv_argv);
		severr("exec failed.");	/* won't print, still exit w/ fail */
	}
	if(cpid < 0)
		severr("Cannot fork.");
	wpid = wait(&sts);
	if(wpid != cpid) {
		severr("wait(): returned unexpected value: %d",wpid);
	}
	evaluate(&Tcommand, (pointer)&sts);
	return(sts);
}
