/* z_execve.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef execve
#endif

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern int *sv_geti(void);
extern void sv_mproc(void);

static struct ftable Texecve = {
	"execve",
	"no return from the function",
	"a return value of (-1)",
	format,
	compare,
	GONE,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zexecve(const char *path, char *const argv[], char *const envp[])
{
	int ret_val;

	sv_mproc();
	errno = 0;
	ret_val = execve(path, argv, envp);
	evaluate(&Texecve, (pointer)&ret_val);
	return(ret_val);
}
