#include <z_pcts.h>

#include <fcntl.h>
#include <stdarg.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	fcntl
#endif

static int success0(int *val)
{
	return((*val) >= 0);
}

static int success3(int *val)
{
	return((*val) != (-1));
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static char *format1(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", (*val) & 1);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

static int compare1(int *a, int *b)
{
	return(((*a) & 1) == ((*b) & 1));
}

extern	int *sv_geti(void);

static struct ftable Tfcntl0 = {
	"fcntl",
	"a return value greater than or equal to 0",
	"a return value of (-1)",
	format,
	compare,
	success0,
	failure,
	(pfunctptr)sv_geti,
	1,
};

static struct ftable Tfcntl1 = {
	"fcntl",
	"a return value greater than or equal to 0",
	"a return value of (-1)",
	format1,
	compare1,
	success0,
	failure,
	(pfunctptr)sv_geti,
	1,
};

static struct ftable Tfcntl3 = {
	"fcntl",
	"a return value other than (-1)",
	"a return value of (-1)",
	format,
	compare,
	success3,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int	Zfcntl(int fildes, int cmd, ...)
{
	int ret_val;
	va_list v;
	struct flock *farg;
	int iarg;

	va_start(v, cmd);
	errno = 0;
	if (cmd == F_GETLK || cmd == F_SETLK || cmd == F_SETLKW)
	{
		farg = va_arg(v, struct flock *);
		ret_val = fcntl(fildes, cmd, farg);
	}
	else if (cmd == F_DUPFD || cmd == F_SETFD || cmd == F_SETFL)
	{
		iarg = va_arg(v, int);
		ret_val = fcntl(fildes, cmd, iarg);
	}
	else
		ret_val = fcntl(fildes, cmd);
	va_end(v);
	switch(cmd) {

	case F_GETFL:
	case F_DUPFD:
		evaluate(&Tfcntl0, (pointer)&ret_val);
		break;
	case F_GETFD:
		evaluate(&Tfcntl1, (pointer)&ret_val);
		break;

	case F_SETFD:
	case F_SETFL:
	case F_GETLK:
	case F_SETLK:
	case F_SETLKW:
		evaluate(&Tfcntl3, (pointer)&ret_val);
		break;

	}
	return(ret_val);
}
