/* z_fork.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef fork
#endif

static int success(pid_t *val)
{
	return((*val) >= 0);
}

static int failure(pid_t *val)
{
	return((*val) == (-1));
}

static char *format(pid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(pid_t *a, pid_t *b)
{
	return(*a == *b);
}

extern pid_t *sv_gpid_t(void);
extern void sv_pproc(void);
extern void sv_cproc(void);
extern void sv_flush(void);

static struct ftable Tfork = {
	"fork",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gpid_t,
	1,
};

pid_t  Zfork(void)
{
	pid_t ret_val;
	int saved_errno;

	sv_flush();
	errno = 0;
	ret_val = fork();
	saved_errno = errno;
	if(ret_val)
		sv_pproc();
	else
		sv_cproc();
	errno = saved_errno;
	evaluate(&Tfork, (pointer)&ret_val);
	return(ret_val);
}
