/* z_fseek.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef fseek
#endif

static int success(int *val)
{
	return((*val) ? 0 : 1);
}

static int failure(int *val)
{
	return((*val) ? 1 : 0);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tfseek = {
	"fseek",
	"a return value of 0",
	"a return value other than 0",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zfseek(FILE *stream, long offset, int ptrname)
{
	int ret_val;

	errno = 0;
	ret_val = fseek(stream, offset, ptrname);
	evaluate(&Tfseek, (pointer)&ret_val);
	return(ret_val);
}
