/* z_pathconf.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	pathconf
#endif

static int success(long *val)
{
	return((*val) >= 0);
}

static int failure(long *val)
{
	return((*val) == (-1));
}

static char *format(long *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", *val);
	return(buf);
}

static int compare(long *a, long *b)
{
	return(*a == *b);
}

extern	long *sv_getl(void);

static struct ftable Tpathconf = {
	"pathconf",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getl,
	1,
};

long  Zpathconf(const char *path, int name)
{
	long ret_val;

	errno = 0;
	ret_val = pathconf(path, name);
							/* Handle special case for pathconf() */
	if((ret_val == -1) && (errno == 0))
		return(ret_val);
	evaluate(&Tpathconf, (pointer)&ret_val);
	return(ret_val);
}
