/* z_puts.c */

#include <z_pcts.h>
#include <unistd.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef puts
#endif

static int success(int *val)
{
	return((*val) >= 0);
}

static int failure(int *val)
{
	return((*val) == EOF);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tputs = {
	"puts",
	"a return value of at least 0",
	"a return value of EOF",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zputs(char *s)
{
	int ret_val;

	errno = 0;
	ret_val = puts(s);
	evaluate(&Tputs, (pointer)&ret_val);
	return(ret_val);
}
