/* z_read.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	read
#endif

static int success(ssize_t *val)
{
	return((*val) >= 0);
}

static int failure(ssize_t *val)
{
	return((*val) == (-1));
}

static char *format(ssize_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(ssize_t *a, ssize_t *b)
{
	return(*a == *b);
}

extern	ssize_t *sv_gssize_t(void);

static struct ftable Tread = {
	"read",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gssize_t,
	1,
};

ssize_t  Zread(int fildes, void *buf, size_t nbyte)
{
	ssize_t ret_val;

	errno = 0;
	ret_val = read(fildes, buf, nbyte);
	evaluate(&Tread, (pointer)&ret_val);
	return(ret_val);
}
