/* z_strtok.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef strtok
#endif

static int success(char **val)
{
	return((*val) ? 1 : 0);
}

static int failure(char **val)
{
	return((*val) ? 0 : 1);
}

static char *format(char **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(char **a, char **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a) ? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Tstrtok = {
	"strtok",
	"a return value other than NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	0,
};

char *Zstrtok(char *s1, const char *s2)
{
	char *ret_val;

	errno = 0;
	ret_val = strtok(s1, s2);
	evaluate(&Tstrtok, (pointer)&ret_val);
	return(ret_val);
}
