/* z_tcgetpgrp.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	tcgetpgrp
#endif

static int success(pid_t *val)
{
	return((*val) >= (0));
}

static int failure(pid_t *val)
{
	return((*val) == (-1));
}

static char *format(pid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(pid_t *a, pid_t *b)
{
	return(*a == *b);
}

extern pid_t *sv_gpid_t(void);

static struct ftable Ttcgetpgrp = {
	"tcgetpgrp",
	"a return value >= 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gpid_t,
	1,
};

pid_t  Ztcgetpgrp(int fildes)
{
	pid_t ret_val;

	errno = 0;
	ret_val = tcgetpgrp(fildes);
	evaluate(&Ttcgetpgrp, (pointer)&ret_val);
	return(ret_val);
}
