/* z_tmpfile.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef PCTS_FUNCT_INTF_CK
#undef	tmpfile
#endif

static int success(FILE **val)
{
	return((*val) ? 1 : 0);
}

static int failure(FILE **val)
{
	return((*val) ? 0 : 1);
}

static char *format(val)
FILE **val;
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(FILE **a, FILE **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a) ? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Ttmpfile = {
	"tmpfile",
	"a return value other than NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	0,
};

FILE *Ztmpfile(void)
{
	FILE * ret_val;

	errno = 0;
	ret_val = tmpfile();
	evaluate(&Ttmpfile, (pointer)&ret_val);
	return(ret_val);
}
