/* z_waitpid.c */

#include <z_pcts.h>
#include <sys/wait.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	waitpid
#endif

static int success(pid_t *val)
{
	return((*val) >= 0);
}

static int failure(pid_t *val)
{
	return((*val) == (-1));
}

static char *format(pid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(pid_t *a, pid_t *b)
{
	return(*a == *b);
}

extern pid_t *sv_gpid_t(void);

static struct ftable Twaitpid = {
	"waitpid",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gpid_t,
	1,
};

pid_t  Zwaitpid(pid_t pid, int *stat_loc, int opt)
{
	pid_t ret_val;

	errno = 0;
	ret_val = waitpid(pid, stat_loc, opt);
	evaluate(&Twaitpid, (pointer)&ret_val);
	return(ret_val);
}
